package astroj;

import ij.*;
import ij.io.*;
import ij.io.OpenDialog;

import ij.gui.*;
import ij.process.*;
import ij.text.*;
import ij.macro.Interpreter;
//import ij.measure.*;
import ij.measure.Calibration;
import ij.plugin.FolderOpener;
//import ij.plugin.filter.*;
//import ij.plugin.frame.*;
//import ij.macro.Interpreter;

import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics.*;
import java.awt.event.*;
import java.awt.event.MouseEvent.*;
import java.lang.reflect.*;

//import java.awt.image.*;
import java.awt.geom.*;
import java.io.*;

import javax.swing.*;
import javax.swing.event.*;
import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;
//import javax.swing.border.TitledBorder;
//import javax.swing.event.*;
import java.util.*;
//import java.util.Properties;
//import java.util.EventListener;

import java.lang.Math.*;
import java.text.*;

import java.io.File;
import java.util.Iterator;
import javax.imageio.ImageWriter;
import javax.imageio.stream.*;
import javax.imageio.*;

import bislider.com.visutools.nav.bislider.*;
import ij.util.Tools;




/**
 *
 * @author Karen
 */
public class AstroStackWindow extends StackWindow implements LayoutManager, ActionListener,
                                   MouseListener, MouseMotionListener, MouseWheelListener,
                                   KeyListener, ItemListener {

            AstroCanvas ac;
            Component[] stackSliders;
            static final int MIN_WIDTH = 128;
            static final int MIN_HEIGHT = 32;
            static final int MIN_FRAME_WIDTH = 500;
            static final int MAX_FRAME_HEIGHT_PADDING = 300;
            static final boolean DRAGGING = true;
            static final boolean NOT_DRAGGING = false;
            static final boolean REFRESH = true;
            static final boolean NEW = false;
            static final boolean RESIZE = true;
            static final boolean NORESIZE = false;
            static final boolean MOUSECLICK = true;
            static final boolean WHEEL = false;
            static final int BISLISER_SEGMENTS = 255;
            static final boolean IMAGE_UPDATE = true;
            static final boolean NO_IMAGE_UPDATE = false;

            int slice=0;
            int stackSize=0;
            double oldX;
            double oldY;
            double magnification = 0.5;
            Rectangle rct;
            DmsFormat form;
            DecimalFormat fourPlaces = new DecimalFormat("###,###,##0.0000");
            DecimalFormat threePlaces = new DecimalFormat("0.000");
            DecimalFormat noPlaces = new DecimalFormat("###,###,##0");
            DecimalFormat sixPlaces = new DecimalFormat("0.000000");
            DecimalFormat uptoSixPlaces = new DecimalFormat("0.######");
            ImageStatistics stats, stats2;
            Dimension screenDim;

            int startDragX, startDragY, endDragX, endDragY;
            int origCanvasHeight, origCanvasWidth;
            int startDragSubImageX, startDragSubImageY;
            int startDragScreenX, startDragScreenY;
            int lastScreenX, lastScreenY;
            int screenX, screenY;
            double lastImageX, lastImageY;
            int frameLocationX, frameLocationY;
            int newPositionX, newPositionY;
            int icHeight, icWidth, ipWidth, ipHeight;
            int astronomyToolId, apertureToolId, zoomToolId, panToolId, currentToolId;
            int ocanvasHeight, ocanvasWidth;
            int imageHeight, imageWidth, winWidth, winHeight;
            int otherPanelsHeight;
            int sliderScale;
            int count = 0;
            int newicWidth;
            int currentSlice;
            int oldICHeight=0;
            int oldICWidth=0;
            int clipX = 0;
            int clipY = 0;
            int clipWidth = 0;
            int clipHeight = 0;

            int oldX3=0, oldY3=0, oldH3=0, oldW3=0;

            double radius = 25, rBack1 = 40, rBack2 = 60;


            int hgap = 0;
            int vgap = 0;
            int[] histogram;
            double histMax = 0.0;
            double[] logHistogram;
            boolean maxBoundsReset = false;
            int resetMaxBoundsCount;
            double dstWidth;
            double dstHeight;
            double prevBarHeight = 0.0;
            Rectangle srcRect;
            int imageEdgeX1, imageEdgeX2, imageEdgeY1, imageEdgeY2;
            long setMaxBoundsTime;
            String slash = System.getProperty("file.separator");

            double sliderMultiplier, sliderShift;
            double prevMag, prevImageX=0, prevImageY=0;
            double startMinDisplayValue, startMaxDisplayValue;
            double imageMedian, min, max, minValue, maxValue, meanValue, stdDevValue;
            double[] sliceMin, sliceMax;
            double scaleMin, scaleMax, fixedMinValue, fixedMaxValue;
            double brightness, contrast, brightstepsize, contrastStepSize;
            double autoScaleFactorLow=0.5, autoScaleFactorHigh=2.0,autoScaleFactorLowRGB=2.0, autoScaleFactorHighRGB=6.0;

            double savedMag = 1.0;
            double savedMin = 0.0;
            double savedMax = 255.0;
            public double pixelScaleX = 0.0, pixelScaleY = 0.0;
            int savedICHeight = 600;
            int savedICWidth = 600;
            int savedPanX = 0;
            int savedPanY = 0;
            int savedPanHeight = 600;
            int savedPanWidth = 600;
            int savedIpHeight = 0;
            int savedIpWidth = 0;
            int winHeightBeforeMaximize;
            int winWidthBeforeMaximize;
            int canHeightBeforeMaximize;
            int canWidthBeforeMaximize;            
            double magbefore = 1;

            public boolean minMaxChanged = false;
            boolean newClick;
            boolean button2Drag;
            boolean alreadyCustomStackWindow = false;
            public boolean goodWCS = false;
            boolean firstClick = true;
            boolean useSexagesimal = true;
            boolean startupPrevSize = true;
            boolean showPhotometer = true;
            boolean prevShiftDownState = false;
            public boolean startupAutoLevel = true;
            public boolean isReady = false;
            boolean startupPrevPan = false;
            boolean startupPrevZoom = false;
            boolean startupPrevLevels = false;
            boolean startupPrevLevelsPerSlice = false;
            boolean rememberWindowLocation = true;
            boolean writeMiddleClickValues = true;
            boolean writeMiddleDragValues = true;
            boolean astronomyMode = true;
            boolean autoConvert = true;
            boolean firstTime = true;
            boolean mouseDown = false;
            boolean stackRotated = false;
            boolean refresh2 = false;
            boolean fillNotFit = false;
            boolean useInvertingLut = false;
            boolean reposition = true;
            boolean redrawing = false;
            boolean middleClickCenter = true;
            boolean removeBackStars = true;
            boolean showRemovedPixels = false;
            boolean apertureChanged = false;
            boolean showSkyOverlay = false;
            boolean showZoom = true;
            boolean showDir = true;
            boolean showXY = true;
            boolean showScaleX = true, showScaleY = true;
            boolean useFixedMinMaxValues = false;
            boolean dataRotated = false;
            boolean shiftAndControlWasDown = false;
            boolean shiftClickDisabled = false;
            boolean unzoomWhenMinimize = false;
            boolean invertX = false;
            boolean invertY = false;
            boolean nameOverlay = true;
            boolean valueOverlay = true;
            boolean showMeanNotPeak = false;
            boolean saveAllPNG = true;
            boolean saveImage = true;
            boolean savePlot = true;
            boolean saveConfig = true;
            boolean saveTable = true;
            boolean saveApertures = true;
            boolean saveLog = true;
            boolean updatesEnabled = true;
            boolean autoScaleIconClicked = false;

//            boolean prevInvertX = false;
//            boolean prevInvertY = false;
            int rotation = AstroCanvas.ROT_0;
//            int prevRotation = 0;
            boolean netFlipX, netFlipY, netRotate;
            boolean flipDataX, flipDataY, rotateDataCW, rotateDataCCW;

            String IJVersion = IJ.getVersion();
            String impTitle;

            String imageSuffix = "_field";
            String plotSuffix = "_lightcurve";
            String configSuffix = "_measurements";
            String dataSuffix = "_measurements";
            String aperSuffix = "_measurements";
            String logSuffix = "_calibration";

            TimerTask rotateTask = null, photometerTask = null;
            java.util.Timer rotateTaskTimer = null, photometerTaskTimer = null;

            JScrollBar channelSelector, sliceSelector, frameSelector;
            Thread thread;
            volatile boolean done;
            boolean hyperStack;
//            int nChannels=1, nSlices=1, nFrames=1;
            int c=1, z=1, t=1;
            int scrollBarTotal;

            MouseWheelListener[] mwl;
            MouseWheelListener[] icmwl;
            MouseMotionListener[] mml;
            MouseListener[] ml;
            Toolbar toolbar;

            double[] radec, startRadec;

            double[] xy = new double[2];
            public WCS wcs;
            Photometer photom;
//            Overlay apertureOverlay = new Overlay();
            Roi radiusRoi = null;
            Roi rBack1Roi = null;
            Roi rBack2Roi = null;

            double[] crpix = null;
            double[][] cd = null;
            int[] npix = null;

            Font p12;
            Font p13;
            Font b12;

            Color mouseApertureColor = new Color(128, 128, 255);

            MenuBar mainMenuBar = new MenuBar();
            Panel mainPanel;
            JPanel infoPanel;
            JPanel topPanelA;
            JPanel zoomPanel;
            JPanel topPanelB, topPanelBC;
            JPanel bottomPanelB;
            JPanel canvasPanel;
            JTextField lengthLabel, peakLabel, infoTextField;

            Menu fileMenu, preferencesMenu, scaleMenu, viewMenu, editMenu, processMenu, colorMenu, analyzeMenu;

            MenuItem exitMenuItem, flipDataXMenuItem, flipDataYMenuItem, rotateDataCWMenuItem, rotateDataCCWMenuItem;
            MenuItem openMenuItem, openInNewWindowMenuItem, openSeqMenuItem,openSeqInNewWindowMenuItem;
            MenuItem saveDisplayAsJpgMenuItem, saveDisplayAsPngMenuItem, saveStatePNGMenuItem, saveStateJPGMenuItem, setSaveStateMenuItem;
            MenuItem openAperturesMenuItem, saveAperturesMenuItem, saveMenuItem, saveFitsMenuItem, saveStackSequenceMenuItem, clearOverlayMenuItem;
            MenuItem saveTiffMenuItem, saveJpegMenuItem, savePngMenuItem, saveBmpMenuItem, saveGifMenuItem, saveAviMenuItem;
            MenuItem dirAngleMenuItem;

            MenuItem stackSorterMenuItem, alignStackMenuItem, imageStabilizerMenuItem, imageStabilizerApplyMenuItem;
            MenuItem debayerMenuItem, splitChannelsMenuItem, imagesToStackMenuItem, stackToImagesMenuItem;
            MenuItem normalizeStackMenuItem, shiftImageMenuItem, editFitsHeaderMenuItem, staticProfilerMenuItem, stackToRGBMenuItem, makeCompositeMenuItem;
            MenuItem apertureSettingsMenuItem, multiApertureMenuItem, multiPlotMenuItem, openMeasurementsTableMenuItem, threeDSurfacePlotMenuItem;
            MenuItem bestEdgesMenuItem, imageCalcMenuItem, seeingProfileMenuItem, dynamicProfilerMenuItem, azimuthalAverageMenuItem;
            MenuItem measurementSettingsMenuItem, measurementMenuItem, smoothMenuItem, sharpenMenuItem, removeOutliersMenuItem;
            MenuItem dataReducerMenuItem, selectBestFramesMenuItem, setPixelScaleMenuItem, setZoomIndicatorSizeMenuItem, setAutoScaleParametersMenuItem;

            CheckboxMenuItem startupAutoLevelRB, usePreviousLevelsRB, usePreviousLevelsPerSliceRB, useFullRangeRB, negativeDisplayRB;
            CheckboxMenuItem invertNoneRB, invertXRB, invertYRB, invertXYRB;
            CheckboxMenuItem rotate0RB, rotate90RB, rotate180RB, rotate270RB;
            CheckboxMenuItem showZoomCB, showDirCB, showXYCB, showScaleXCB, showScaleYCB, useFixedMinMaxValuesCB;
            ButtonGroup contrastGroup, invertGroup, rotationGroup;
            CheckboxMenuItem autoConvertCB, usePreviousSizeCB, usePreviousPanCB, usePreviousZoomCB, showMeanNotPeakCB,
                    rememberWindowLocationCB, useSexagesimalCB, middleClickCenterCB, writeMiddleClickValuesCB,
                    writeMiddleDragValuesCB, showPhotometerCB, removeBackStarsCB, showRemovedPixelsCB, showRedCrossHairCursorCB;

            JButton buttonAdd32768, buttonSub32768, buttonFit, buttonHeader, buttonLUT, buttonZoomInFast, buttonZoomIn, buttonZoomOut;
            JButton buttonFlipX, buttonFlipY, buttonRotCCW, buttonRotCW, buttonAutoLevels, buttonClearMeasurements;
            JButton buttonBroom, buttonShowAll, buttonMultiAperture, buttonAlign, buttonSetAperture, buttonDeleteSlice;
            JToggleButton buttonShowSky, buttonSourceID, buttonSourceCounts, buttonCentroid,buttonNegative;
            JSlider minSlider, maxSlider;
            JTextField minValueTextField, maxValueTextField, minTextField, maxTextField, meanTextField;
            JTextField valueTextField, RATextField, DecTextField, peakTextField;
            JTextField fitsXTextField, fitsYTextField, lengthTextField;
            JTextField ijXTextField, ijYTextField;
            BiSlider minMaxBiSlider;
            
            Rectangle defaultScreenBounds;
            GraphicsDevice defaultScreen;


     public AstroStackWindow(ImagePlus imp, AstroCanvas ac, boolean refresh, boolean resize) {

                super(imp, ac);

//                SET DEFAULT SYSTEM LOOK AND FEEL
//                UIManager.LookAndFeelInfo[] laf = UIManager.getInstalledLookAndFeels();
//                for (int i = 0 ; i < laf.length; i++)
//                IJ.write(""+laf[i]);
//                System.setProperty("com.apple.laf.useScreenMenuBar", "false");
//                System.setProperty("apple.awt.graphics.UseQuartz","false");
                if (IJ.isWindows())
                        {
//                        try {UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");}
                        try {UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");}
//                        try {UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());}
                        catch (Exception e) { }
                        }
                else if (IJ.isLinux())
                        {
                        try {UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");}
                        catch (Exception e) { }
                        }
//                    try {UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");}
//                    try {UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");}
//                    try {UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");}
                else if (IJ.isMacOSX())
                        {

                        try {UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");}
//                        try {UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());}
                        catch (Exception e) { }
                        }
//                System.setProperty("apple.laf.useScreenMenuBar", "false");
//                System.setProperty("com.apple.macos.useScreenMenuBar", "false");
                
                GraphicsEnvironment localGfxEnvironment = GraphicsEnvironment.getLocalGraphicsEnvironment();
                defaultScreen = localGfxEnvironment.getDefaultScreenDevice();
                defaultScreenBounds = defaultScreen.getDefaultConfiguration().getBounds();                
                
                this.imp = imp;
                this.ac = ac;

                super.hasMenus = true;

//                super.ic.setBackground(Color.WHITE);

                getStatistics();
                minValue = stats.min;
                maxValue = stats.max;
                min = minValue;
                max = maxValue;
                
                ImageProcessor ip = imp.getProcessor();

                if (imp.getType()==ImagePlus.COLOR_RGB)
                    {
                    ip.snapshot();
                    }
                
                stackSize = imp.getStackSize();
                sliceMin = new double[stackSize];
                sliceMax = new double[stackSize];
                for (int i = 0; i < stackSize; i++)
                    {
                    sliceMin[i] = min;
                    sliceMax[i] = max;
                    }
                
                getPrefs();

                if (imp.getType() == ImagePlus.COLOR_256 || imp.getType() == ImagePlus.COLOR_RGB || imp.getType() == ImagePlus.GRAY8)
                    {
                    useFixedMinMaxValues = false;
                    minValue = 0;
                    maxValue = 255;
                    }
                else
                    {
                    maxValue = useFixedMinMaxValues ? fixedMaxValue : stats.max;
                    minValue = useFixedMinMaxValues ? fixedMinValue : stats.min;
                    if (imp.getType() == ImagePlus.GRAY16 && maxValue - minValue < 256)
                         maxValue = minValue + 255;
                    }
                impTitle = imp.getTitle();

                
                wcs = new WCS(imp);
                goodWCS = wcs.hasWCS();
                ac.setWCS(wcs);                
                
                ac.setOrientation(invertX, invertY, rotation);
                ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);
                netFlipX = ac.getNetFlipX();
                netFlipY = ac.getNetFlipY();
                netRotate = ac.getNetRotate();
                ac.setShowZoom(showZoom);
                ac.setShowDir(showDir);
                ac.setShowXY(showXY);


//                adjustImageRotation(NO_IMAGE_UPDATE);

                
                photom = new Photometer (imp.getCalibration());
                photom.setSourceApertureRadius (radius);
                photom.setBackgroundApertureRadii (rBack1,rBack2);
                photom.setRemoveBackStars(removeBackStars);
                photom.setMarkRemovedPixels(false);
                ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
                ac.setAstronomyMode(true);

//                imp.setOverlay(apertureOverlay);
                

                if (IJ.isWindows())
                    {
                    p12 = new Font("Dialog",Font.PLAIN,12);
                    p13 = new Font("Dialog",Font.PLAIN,13);
                    b12 = new Font("Dialog",Font.BOLD,12);
                    }
                else
                    {
                    p12 = new Font("Dialog",Font.PLAIN,11);
                    p13 = new Font("Dialog",Font.PLAIN,12);
                    b12 = new Font("Dialog",Font.BOLD,11);
                    }

                winWidth = this.getWidth();
                winHeight = this.getHeight();

                if(!startupPrevSize && resize && IJVersion.compareTo("1.42q") > 0)
                    {
                    ac.setDrawingSize((int)(ac.getWidth()*0.9), (int)(ac.getHeight()*0.9));
                    ac.setMagnification(ac.getMagnification()*0.9);
                    }
                else if(startupPrevSize)
                    {
                    ac.setDrawingSize((int)((double)savedICHeight*(double)imp.getWidth()/(double)imp.getHeight()),savedICHeight);
                    ac.setMagnification((double)savedICHeight/(double)imp.getHeight());
                    }

                magnification = ac.getMagnification();
                icWidth = ac.getWidth();
                icHeight = ac.getHeight();
                ipWidth = ip.getWidth();
                ipHeight = ip.getHeight();

                if (icWidth < MIN_FRAME_WIDTH)
                    {
                    newicWidth = MIN_FRAME_WIDTH;
                    double mag = Math.max((double)newicWidth/(double)ipWidth, (double)icHeight/(double)ipHeight);
                    ac.setDrawingSize((int)(ipWidth*mag), (int)(ipHeight*mag));
                    ac.setMagnification(mag);
                    }
                screenDim = Toolkit.getDefaultToolkit().getScreenSize();
                if (ac.getHeight() > screenDim.height - MAX_FRAME_HEIGHT_PADDING)
                    {
                    ac.setMagnification((double)(screenDim.height - MAX_FRAME_HEIGHT_PADDING)/(double)ip.getHeight());
                    ac.setDrawingSize((int)Math.max(((screenDim.height - MAX_FRAME_HEIGHT_PADDING)*(double)ip.getWidth()/
                                           (double)ip.getHeight()), MIN_FRAME_WIDTH), screenDim.height - MAX_FRAME_HEIGHT_PADDING);
                    }

                magnification = ac.getMagnification();
                icWidth = ac.getWidth();
                icHeight = ac.getHeight();
                ipWidth = ip.getWidth();
                ipHeight = ip.getHeight();

//                IJ.log("Starting build of astro window");
                buildAstroWindow();
//                IJ.log("Finished build of astro window");
                
//                IJ.log("Starting check of 'startup using previous pan position'");
                if (startupPrevPan && ipWidth == savedIpWidth && ipHeight == savedIpHeight )
                    {
                    double w = (double)icWidth/magnification;
                    if (w*magnification<icWidth) w++;
                    double h = (double)icHeight/magnification;
                    if (h*magnification<icHeight) h++;
                    Rectangle rect = new Rectangle(savedPanX, savedPanY, savedPanWidth, savedPanHeight);
                    ac.setSourceRect(rect);
                    ac.setMagnification((double)ac.getHeight()/(double)rect.height);
                    ac.setDrawingSize((int)((double)ac.getHeight()*(double)rect.width/(double)rect.height), ac.getHeight());
                    if (rect.x<0 || rect.y<0 || rect.x+w>ipWidth || rect.y+h>ipHeight)
                        {
                        ac.paint(ac.getGraphics());//clearAndPaint();
                        }
                    }
//                IJ.log("Finished check of 'startup using previous pan position'");

                setupListeners();
                setImageEdges();
                addWindowListener(new WindowAdapter(){
                    @Override
                    public void windowClosing(WindowEvent e){
                    saveAndClose(false);}});

//                IJ.log("Before 'set layout'");
                setLayout(this);
//                IJ.log("Before 'wait 200 ms'");
                IJ.wait(200); //an attempt to work around window non-display
//                IJ.log("After 'wait 200 ms'");
//                doLayout();
                isReady = true;
                startDragScreenX = (int)(ac.getX() + ac.getWidth()/2.0);
                startDragScreenY = (int)(ac.getY() + ac.getHeight()/2.0);
//                IJ.error("pause");
//                IJ.log("Start setAutoLevels");
                if (startupAutoLevel)
                    {
                    setAutoLevels(null);
                    }
                else if (startupPrevLevels || startupPrevLevelsPerSlice)
                    {
                    min = savedMin;
                    max = savedMax;
                    updatePanelValues();
                    }
                else
                    {
                    min = minValue;
                    max = maxValue;
                    updatePanelValues();
                    }
//                IJ.log("Start useInvertingLut");
                if (useInvertingLut != ip.isInvertedLut() && !ip.isColorLut())
                    ip.invertLut();
//                IJ.log("Start updateZoomBoxParameters");
                ac.updateZoomBoxParameters();
                imp.getWindow().requestFocus();
//                IJ.log("Start requestFocusInWindow");
                imp.getCanvas().requestFocusInWindow();
//                IJ.log("Start setVisible");
                setVisible(true);
//                IJ.log("Finished displaying astro window");
                
    }

        void saveAndClose(boolean cleanWindow)
                {
                savePrefs();
                toolbar.removeMouseListener(toolbarMouseListener);
                ac.removeMouseWheelListener(this);
                ac.removeMouseListener(this);
                ac.removeMouseMotionListener(this);
                ac.removeKeyListener(this);
                if (imp != null) imp.changes = false;
                if (imp != null) imp.unlock();
                wcs = null;
                photom = null;
                if (cleanWindow)
                    {
                    if (imp != null) imp.close();
                    WindowManager.removeWindow(this);
                    }
                }

//        void updatePhotometerOverlay()
//                {
////                apertureChanged = Prefs.get("setaperture.aperturechanged", apertureChanged);
////
////                if ((apertureOverlay.size() > 0) && !apertureChanged)
////                    {
////                    apertureOverlay.set   StrokeColor(mouseApertureColor);
////                    radiusRoi.setLocation((int)(lastImageX-photom.radius+0.5), (int)(lastImageY-photom.radius+0.5));
////                    if (showSkyOverlay)
////                        {
////                        rBack1Roi.setLocation((int) (lastImageX - photom.rBack1 + 0.5), (int) (lastImageY - photom.rBack1 + 0.5));
////                        rBack2Roi.setLocation((int)(lastImageX-photom.rBack2+0.5), (int)(lastImageY-photom.rBack2+0.5));
////                        }
////                    Graphics g = ac.getGraphics();
////                    ac.paint(g);
////                    }
////                else
////                    {
////                    showSkyOverlay = Prefs.get ("aperture.skyoverlay", showSkyOverlay);
////                    Prefs.set("setaperture.aperturechanged", false);
////                    apertureOverlay.clear();
////                    radius = Prefs.get("aperture.radius", radius);
////                    rBack1 = Prefs.get("aperture.rback1",rBack1);
////                    rBack2 = Prefs.get("aperture.rback2",rBack2);
////                    removeBackStars = Prefs.get("aperture.removebackstars", removeBackStars);
////                    photom.setSourceApertureRadius(radius);
////                    photom.setBackgroundApertureRadii(rBack1,rBack2);
////                    photom.setRemoveBackStars(removeBackStars);
////                    apertureOverlay.setStrokeColor(mouseApertureColor);
////                    radiusRoi = new ij.gui.OvalRoi((int)(lastImageX-photom.radius+0.5), (int)(lastImageY-photom.radius+0.5), (int)(photom.radius*2.0), (int)(photom.radius*2.0));
////                    apertureOverlay.add(radiusRoi);
////                    if (showSkyOverlay)
////                        {
////                        rBack1Roi = new ij.gui.OvalRoi((int)(lastImageX-photom.rBack1+0.5), (int)(lastImageY-photom.rBack1+0.5), (int)(photom.rBack1*2.0), (int)(photom.rBack1*2.0));
////                        rBack2Roi = new ij.gui.OvalRoi((int)(lastImageX-photom.rBack2+0.5), (int)(lastImageY-photom.rBack2+0.5), (int)(photom.rBack2*2.0), (int)(photom.rBack2*2.0));
////                        apertureOverlay.add(rBack1Roi);
////                        apertureOverlay.add(rBack2Roi);
////                        }
////                    imp.setOverlay(apertureOverlay);
////                    }
//                Thread tt = new Thread()
//                    {
//                    public void run()
//                        {
//                Graphics g = ac.getGraphics();
//                ((Graphics2D)g).setTransform(ac.invCanvTrans);
//                ac.transEnabled = false;
//                g.setColor(mouseApertureColor);
//                double imageX = ac.offScreenXD(screenX);
//                double imageY = ac.offScreenYD(screenY);
//
//                int sx = ac.screenXD (imageX);
//                int sy = ac.screenYD (imageY);
//
//                int x1 = ac.screenXD (imageX-radius);
//                int w1 = ac.screenXD (imageX+radius)-x1;
//                int y1 = ac.screenYD (imageY-radius);
//                int h1 = ac.screenYD (imageY+radius)-y1;
//                int x2 = ac.screenXD (imageX-rBack1);
//                int x3 = ac.screenXD (imageX-rBack2);
//                int w2 = ac.screenXD (imageX+rBack1)-x2;
//                int w3 = ac.screenXD (imageX+rBack2)-x3;
//                int y2 = ac.screenYD (imageY-rBack1);
//                int y3 = ac.screenYD (imageY-rBack2);
//                int h2 = ac.screenYD (imageY+rBack1)-y2;
//                int h3 = ac.screenYD (imageY+rBack2)-y3;
//
//                g.drawOval (x1,y1,w1,h1);
//
//
//                if (showSkyOverlay)
//                    {
//
//                    g.drawOval (x2,y2,w2,h2);
//                    g.drawOval (x3,y3,w3,h3);
//                    }
//                clipX = (x3<=oldX3)?x3:oldX3;
//                clipY = (y3<=oldY3)?y3:oldY3;
//                clipWidth = ((x3+w3>=oldX3+oldW3)?x3+w3:oldX3+oldW3) - clipX + 1;
//                clipHeight = ((y3+h3>=oldY3+oldH3)?y3+h3:oldY3+oldH3) - clipY + 1;
//                clipX-=2; clipY-=2;
//                clipWidth+=4; clipHeight+=4;
//                oldX3=x3;
//                oldY3=y3;
//                oldW3=w3;
//                oldH3=h3;
//
//                ac.transEnabled = true;
//                ((Graphics2D)g).setTransform(ac.canvTrans);
//
//                        ac.repaint(ac.getNetFlipX()?ac.getWidth()-clipWidth-clipX:clipX, ac.getNetFlipY()?ac.getHeight()-clipHeight-clipY:clipY, clipWidth, clipHeight);
//                        }
//                    };
//                tt.start();
//                Thread.yield();
//                }


            void buildAstroWindow() {
                mainMenuBar = new MenuBar();
//                JPopupMenu.setDefaultLightWeightPopupEnabled(false);

//------FILE menu---------------------------------------------------------------------

                fileMenu = new Menu("   File");

                openMenuItem = new MenuItem("Open image in this window...");
                openMenuItem.addActionListener(this);
                if (stackSize != 1) openMenuItem.setEnabled(false);
                fileMenu.add(openMenuItem);

                openInNewWindowMenuItem = new MenuItem("Open image in new window...");
                openInNewWindowMenuItem.addActionListener(this);
                fileMenu.add(openInNewWindowMenuItem); 

//                openSeqMenuItem = new MenuItem("Open sequence...");
//                openSeqMenuItem.addActionListener(this);
//                fileMenu.add(openSeqMenuItem);

                openSeqInNewWindowMenuItem = new MenuItem("Open image sequence in new window...");
                openSeqInNewWindowMenuItem.addActionListener(this);
                fileMenu.add(openSeqInNewWindowMenuItem);

                fileMenu.addSeparator();

                openMeasurementsTableMenuItem = new MenuItem("Open data file...");
                openMeasurementsTableMenuItem.addActionListener(this);
                fileMenu.add(openMeasurementsTableMenuItem);

                fileMenu.addSeparator();

                saveDisplayAsPngMenuItem = new MenuItem("Save image display as PNG...");
                saveDisplayAsPngMenuItem.addActionListener(this);
                fileMenu.add(saveDisplayAsPngMenuItem);

                saveDisplayAsJpgMenuItem = new MenuItem("Save image display as JPEG...");
                saveDisplayAsJpgMenuItem.addActionListener(this);
                fileMenu.add(saveDisplayAsJpgMenuItem);
                
                fileMenu.addSeparator();
                
                openAperturesMenuItem = new MenuItem("Open apertures...");
                openAperturesMenuItem.addActionListener(this);
                fileMenu.add(openAperturesMenuItem);                
                
                saveAperturesMenuItem = new MenuItem("Save apertures...");
                saveAperturesMenuItem.addActionListener(this);
                fileMenu.add(saveAperturesMenuItem);
                
                fileMenu.addSeparator();                

                saveStatePNGMenuItem = new MenuItem("Save all...");
                saveStatePNGMenuItem.addActionListener(this);
                fileMenu.add(saveStatePNGMenuItem);

                setSaveStateMenuItem = new MenuItem("Save all (with options)...");
                setSaveStateMenuItem.addActionListener(this);
                fileMenu.add(setSaveStateMenuItem);

                fileMenu.addSeparator();

                saveMenuItem = new MenuItem("Save image");
                saveMenuItem.addActionListener(this);
                fileMenu.add(saveMenuItem);

                saveFitsMenuItem = new MenuItem("Save image/slice as FITS...");
                saveFitsMenuItem.addActionListener(this);
                fileMenu.add(saveFitsMenuItem);

                saveTiffMenuItem = new MenuItem("Save image/stack as TIFF...");
                saveTiffMenuItem.addActionListener(this);
                fileMenu.add(saveTiffMenuItem);

                saveJpegMenuItem = new MenuItem("Save image/slice as JPEG...");
                saveJpegMenuItem.addActionListener(this);
                fileMenu.add(saveJpegMenuItem);

                saveGifMenuItem = new MenuItem("Save image/stack as GIF...");
                saveGifMenuItem.addActionListener(this);
                fileMenu.add(saveGifMenuItem);

                savePngMenuItem = new MenuItem("Save image/slice as PNG...");
                savePngMenuItem.addActionListener(this);
                fileMenu.add(savePngMenuItem);

                saveBmpMenuItem = new MenuItem("Save image/slice as BMP...");
                saveBmpMenuItem.addActionListener(this);
                fileMenu.add(saveBmpMenuItem);

                saveAviMenuItem = new MenuItem("Save image/stack as AVI...");
                saveAviMenuItem.addActionListener(this);
                fileMenu.add(saveAviMenuItem);

                saveStackSequenceMenuItem = new MenuItem("Save stack as sequence...");
                saveStackSequenceMenuItem.addActionListener(this);
                fileMenu.add(saveStackSequenceMenuItem);

                fileMenu.addSeparator();

                exitMenuItem = new MenuItem("Close Window");
                exitMenuItem.addActionListener(this);
                fileMenu.add(exitMenuItem);

                mainMenuBar.add(fileMenu);

//------Preferences menu---------------------------------------------------------------------
                
                preferencesMenu = new Menu ("Preferences");
                
                autoConvertCB = new CheckboxMenuItem("Use astro-window when images are opened", autoConvert);
                autoConvertCB.addItemListener(this);
                preferencesMenu.add(autoConvertCB);

                preferencesMenu.addSeparator();                

                usePreviousSizeCB = new CheckboxMenuItem("Use previous window size", startupPrevSize);
                usePreviousSizeCB.addItemListener(this);
                preferencesMenu.add(usePreviousSizeCB);

                usePreviousPanCB = new CheckboxMenuItem("Use previous pan position", startupPrevPan);
                usePreviousPanCB.addItemListener(this);
                preferencesMenu.add(usePreviousPanCB);

                usePreviousZoomCB = new CheckboxMenuItem("Use previous zoom setting", startupPrevZoom);
                usePreviousZoomCB.addItemListener(this);
//                preferencesMenu.add(usePreviousZoomCB);

                rememberWindowLocationCB = new CheckboxMenuItem("Use previous window location", rememberWindowLocation);
                rememberWindowLocationCB.addItemListener(this);
                preferencesMenu.add(rememberWindowLocationCB);

                preferencesMenu.addSeparator();

                showMeanNotPeakCB = new CheckboxMenuItem("Display mean counts in aperture (deselect to show peak)", showMeanNotPeak);
                showMeanNotPeakCB.addItemListener(this);
                preferencesMenu.add(showMeanNotPeakCB);                
                
                useSexagesimalCB = new CheckboxMenuItem("Display WCS in sexagesimal format", useSexagesimal);
                useSexagesimalCB.addItemListener(this);
                preferencesMenu.add(useSexagesimalCB);

                middleClickCenterCB = new CheckboxMenuItem("Middle click centers image at click location", middleClickCenter);
                middleClickCenterCB.addItemListener(this);
                preferencesMenu.add(middleClickCenterCB);

                writeMiddleClickValuesCB = new CheckboxMenuItem("Middle click writes image data to results window", writeMiddleClickValues);
                writeMiddleClickValuesCB.addItemListener(this);
                preferencesMenu.add(writeMiddleClickValuesCB);

                writeMiddleDragValuesCB = new CheckboxMenuItem("Middle drag writes image data to results window", writeMiddleDragValues);
                writeMiddleDragValuesCB.addItemListener(this);
                preferencesMenu.add(writeMiddleDragValuesCB);

                preferencesMenu.addSeparator();

                showPhotometerCB = new CheckboxMenuItem("Show photometer aperture at mouse cursor", showPhotometer);
                showPhotometerCB.addItemListener(this);
                preferencesMenu.add(showPhotometerCB);

                showRedCrossHairCursorCB = new CheckboxMenuItem("Show cross-hair with photometer aperture at mouse cursor", ac.showRedCrossHairCursor);
                showRedCrossHairCursorCB.addItemListener(this);
                preferencesMenu.add(showRedCrossHairCursorCB);

                removeBackStarsCB = new CheckboxMenuItem("Ignore pixels > 2 sigma from mean in photometer background region", removeBackStars);
                removeBackStarsCB.addItemListener(this);
                preferencesMenu.add(removeBackStarsCB);

                showRemovedPixelsCB = new CheckboxMenuItem("Mark pixels > 2 sigma from mean in photometer background region", showRemovedPixels);
                showRemovedPixelsCB.addItemListener(this);
                preferencesMenu.add(showRemovedPixelsCB);
                
                preferencesMenu.addSeparator();

                setPixelScaleMenuItem = new MenuItem("Set pixel scale for images without WCS...");
                setPixelScaleMenuItem.addActionListener(this);
                preferencesMenu.add(setPixelScaleMenuItem);

                dirAngleMenuItem = new MenuItem("Set direction angles for images without WCS...");
                dirAngleMenuItem.addActionListener(this);
                preferencesMenu.add(dirAngleMenuItem);

                setZoomIndicatorSizeMenuItem = new MenuItem("Set zoom indicator size...");
                setZoomIndicatorSizeMenuItem.addActionListener(this);
                preferencesMenu.add(setZoomIndicatorSizeMenuItem);

                mainMenuBar.add(preferencesMenu);
                
//------SCALE menu---------------------------------------------------------------------                
                
                scaleMenu = new Menu ("Scale");

                scaleMenu.add("--When an image is opened or modified use:--");

                startupAutoLevelRB = new CheckboxMenuItem("auto brightness & contrast", startupAutoLevel);
                startupAutoLevelRB.addItemListener(this);
                scaleMenu.add(startupAutoLevelRB);

                usePreviousLevelsRB = new CheckboxMenuItem("fixed brightness & contrast", !startupAutoLevel && startupPrevLevels);
                usePreviousLevelsRB.addItemListener(this);
                scaleMenu.add(usePreviousLevelsRB);
                
                usePreviousLevelsPerSliceRB = new CheckboxMenuItem("fixed brightness & contrast (per image slice)", !startupAutoLevel && !startupPrevLevels && startupPrevLevelsPerSlice);
                usePreviousLevelsPerSliceRB.addItemListener(this);
                scaleMenu.add(usePreviousLevelsPerSliceRB);                

                useFullRangeRB = new CheckboxMenuItem("full dynamic range", !startupAutoLevel && !startupPrevLevels && !startupPrevLevelsPerSlice);
                useFullRangeRB.addItemListener(this);
                scaleMenu.add(useFullRangeRB);

                scaleMenu.addSeparator();

                useFixedMinMaxValuesCB = new CheckboxMenuItem("Use fixed min and max histogram values", useFixedMinMaxValues);
                useFixedMinMaxValuesCB.addItemListener(this);
                scaleMenu.add(useFixedMinMaxValuesCB);
                
                scaleMenu.addSeparator();

                setAutoScaleParametersMenuItem = new MenuItem("Set auto brightness & contrast parameters...");
                setAutoScaleParametersMenuItem.addActionListener(this);
                scaleMenu.add(setAutoScaleParametersMenuItem);                

                mainMenuBar.add(scaleMenu);                

//------VIEW menu---------------------------------------------------------------------

                viewMenu = new Menu ("View");
                
                clearOverlayMenuItem = new MenuItem("Clear Overlay");
                clearOverlayMenuItem.addActionListener(this);
                viewMenu.add(clearOverlayMenuItem);

                viewMenu.addSeparator();

                invertNoneRB = new CheckboxMenuItem("Invert None", !invertX && !invertY);
                invertNoneRB.addItemListener(this);
                viewMenu.add(invertNoneRB);

                invertXRB = new CheckboxMenuItem("Invert X", invertX && !invertY);
                invertXRB.addItemListener(this);
                viewMenu.add(invertXRB);

                invertYRB = new CheckboxMenuItem("Invert Y", !invertX && invertY);
                invertYRB.addItemListener(this);
                viewMenu.add(invertYRB);

                invertXYRB = new CheckboxMenuItem("Invert X and Y", invertX && invertY);
                invertXYRB.addItemListener(this);
                viewMenu.add(invertXYRB);

//                invertGroup = new ButtonGroup();
//                invertGroup.add(invertNoneRB);
//                invertGroup.add(invertXRB);
//                invertGroup.add(invertYRB);
//                invertGroup.add(invertXYRB);

                viewMenu.addSeparator();

                rotate0RB = new CheckboxMenuItem("0 degrees", rotation == AstroCanvas.ROT_0);
                rotate0RB.addItemListener(this);
                viewMenu.add(rotate0RB);

                rotate90RB = new CheckboxMenuItem("90 degrees", rotation == AstroCanvas.ROT_90);
                rotate90RB.setEnabled(false);
                rotate90RB.addItemListener(this);
                viewMenu.add(rotate90RB);

                rotate180RB = new CheckboxMenuItem("180 degrees", rotation == AstroCanvas.ROT_180);
                rotate180RB.addItemListener(this);
                rotate180RB.setEnabled(true);
                viewMenu.add(rotate180RB);

                rotate270RB = new CheckboxMenuItem("270 degrees", rotation == AstroCanvas.ROT_270);
                rotate270RB.addItemListener(this);
                rotate270RB.setEnabled(false);
                viewMenu.add(rotate270RB);
                
                viewMenu.addSeparator();

                showZoomCB = new CheckboxMenuItem("Show zoom indicator in overlay", showZoom);
                showZoomCB.addItemListener(this);
                viewMenu.add(showZoomCB);

                showDirCB = new CheckboxMenuItem("Show north & east in overlay", showDir);
                showDirCB.addItemListener(this);
                viewMenu.add(showDirCB);

                showXYCB = new CheckboxMenuItem("Show x-dir & y-dir in overlay", showXY);
                showXYCB.addItemListener(this);
                viewMenu.add(showXYCB);

                showScaleXCB = new CheckboxMenuItem("Show x-dir arclength scale in overlay", showScaleX);
                showScaleXCB.addItemListener(this);
                viewMenu.add(showScaleXCB);
                
                showScaleYCB = new CheckboxMenuItem("Show y-dir arclength scale in overlay", showScaleY);
                showScaleYCB.addItemListener(this);
                viewMenu.add(showScaleYCB);                


//                rotationGroup = new ButtonGroup();
//                rotationGroup.add(rotate0RB);
//                rotationGroup.add(rotate90RB);
//                rotationGroup.add(rotate180RB);
//                rotationGroup.add(rotate270RB);

                mainMenuBar.add(viewMenu);

//------EDIT menu---------------------------------------------------------------------

                editMenu = new Menu("Edit");

                apertureSettingsMenuItem = new MenuItem("Aperture settings...");
                apertureSettingsMenuItem.addActionListener(this);
                editMenu.add(apertureSettingsMenuItem);

                measurementSettingsMenuItem = new MenuItem("Measurement settings...");
                measurementSettingsMenuItem.addActionListener(this);
                editMenu.add(measurementSettingsMenuItem);

                editFitsHeaderMenuItem = new MenuItem("FITS header...");
                editFitsHeaderMenuItem.addActionListener(this);

                editMenu.add(editFitsHeaderMenuItem);

                stackSorterMenuItem = new MenuItem("Stack...");
                stackSorterMenuItem.addActionListener(this);
                editMenu.add(stackSorterMenuItem);

                mainMenuBar.add(editMenu);


//------Process menu---------------------------------------------------------------------

                processMenu = new Menu("Process");
                processMenu.add("**Warning - these selections may modify your image data**");

                processMenu.addSeparator();

                dataReducerMenuItem = new MenuItem("Data reduction facility...");
                dataReducerMenuItem.addActionListener(this);
                processMenu.add(dataReducerMenuItem);

                processMenu.addSeparator();

                imageCalcMenuItem = new MenuItem("Image/stack calculator...");
                imageCalcMenuItem.addActionListener(this);
                processMenu.add(imageCalcMenuItem);

                removeOutliersMenuItem = new MenuItem("Remove outliers from image/stack...");
                removeOutliersMenuItem.addActionListener(this);
                processMenu.add(removeOutliersMenuItem);
                
                smoothMenuItem = new MenuItem("Smooth image/stack...");
                smoothMenuItem.addActionListener(this);
                processMenu.add(smoothMenuItem);    
                
                sharpenMenuItem = new MenuItem("Sharpen image/stack...");
                sharpenMenuItem.addActionListener(this);
                processMenu.add(sharpenMenuItem);

                normalizeStackMenuItem = new MenuItem("Normalize image/stack...");
                normalizeStackMenuItem.addActionListener(this);
                processMenu.add(normalizeStackMenuItem);

                processMenu.addSeparator();

                alignStackMenuItem = new MenuItem("Align stack using apertures...");
                alignStackMenuItem.addActionListener(this);
                processMenu.add(alignStackMenuItem);

                imageStabilizerMenuItem = new MenuItem("Align stack using image stabilizer...");
                imageStabilizerMenuItem.addActionListener(this);
                processMenu.add(imageStabilizerMenuItem);

                imageStabilizerApplyMenuItem = new MenuItem("Apply image stabilizer coefficients...");
                imageStabilizerApplyMenuItem.addActionListener(this);
                processMenu.add(imageStabilizerApplyMenuItem);

                shiftImageMenuItem = new MenuItem("Shift image manually...");
                shiftImageMenuItem.addActionListener(this);
                processMenu.add(shiftImageMenuItem);

                selectBestFramesMenuItem = new MenuItem("Select stack images with best edges...");
                selectBestFramesMenuItem.addActionListener(this);
                processMenu.add(selectBestFramesMenuItem);

                processMenu.addSeparator();

                flipDataXMenuItem = new MenuItem("Flip data in x-axis");
                flipDataXMenuItem.addActionListener(this);
                processMenu.add(flipDataXMenuItem);

                flipDataYMenuItem = new MenuItem("Flip data in y-axis");
                flipDataYMenuItem.addActionListener(this);
                processMenu.add(flipDataYMenuItem);

                rotateDataCWMenuItem = new MenuItem("Rotate data 90 degrees clockwise");
                rotateDataCWMenuItem.addActionListener(this);
                processMenu.add(rotateDataCWMenuItem);

                rotateDataCCWMenuItem = new MenuItem("Rotate data 90 degrees counter-clockwise");
                rotateDataCCWMenuItem.addActionListener(this);
                processMenu.add(rotateDataCCWMenuItem);

                mainMenuBar.add(processMenu);
                
//------Color processing menu---------------------------------------------------------------------                

                colorMenu = new Menu("Color"); //splitChannelsMenuItem, imagesToStackMenuItem stackToImagesMenuItem
                
                splitChannelsMenuItem = new MenuItem("Split RBG image into three 8-bit images");
                splitChannelsMenuItem.addActionListener(this);
                colorMenu.add(splitChannelsMenuItem); 
                
                imagesToStackMenuItem = new MenuItem("Images to Stack");
                imagesToStackMenuItem.addActionListener(this);
                colorMenu.add(imagesToStackMenuItem); 
                
                stackToImagesMenuItem = new MenuItem("Stack to Images");
                stackToImagesMenuItem.addActionListener(this);
                colorMenu.add(stackToImagesMenuItem);                

                debayerMenuItem = new MenuItem("Debayer Image (FITS header aware)...");
                debayerMenuItem.addActionListener(this);
                colorMenu.add(debayerMenuItem); 
                
                makeCompositeMenuItem = new MenuItem("Make Composite color image");
                makeCompositeMenuItem.addActionListener(this);
                colorMenu.add(makeCompositeMenuItem);                
                
                stackToRGBMenuItem = new MenuItem("Convert RGB stack to color image");
                stackToRGBMenuItem.addActionListener(this);
                colorMenu.add(stackToRGBMenuItem); 

                
                mainMenuBar.add(colorMenu);
                
//------ANALYZE menu---------------------------------------------------------------------

                analyzeMenu = new Menu("Analyze");

                multiApertureMenuItem = new MenuItem("Multi-aperture...");
                multiApertureMenuItem.addActionListener(this);
                analyzeMenu.add(multiApertureMenuItem);

                multiPlotMenuItem = new MenuItem("Multi-plot...");
                multiPlotMenuItem.addActionListener(this);
                analyzeMenu.add(multiPlotMenuItem);

                measurementMenuItem = new MenuItem("Measure *");
                measurementMenuItem.addActionListener(this);
                analyzeMenu.add(measurementMenuItem);

                analyzeMenu.addSeparator();
                
                seeingProfileMenuItem = new MenuItem("Plot seeing profile... *");
                seeingProfileMenuItem.addActionListener(this);
                analyzeMenu.add(seeingProfileMenuItem);
                
                staticProfilerMenuItem = new MenuItem("Plot static line/box profile... *");
                staticProfilerMenuItem.addActionListener(this);
                analyzeMenu.add(staticProfilerMenuItem);

                dynamicProfilerMenuItem = new MenuItem("Plot dynamic line/box profile... *");
                dynamicProfilerMenuItem.addActionListener(this);
                analyzeMenu.add(dynamicProfilerMenuItem);

                azimuthalAverageMenuItem = new MenuItem("Plot azimuthal average... *");
                azimuthalAverageMenuItem.addActionListener(this);
                azimuthalAverageMenuItem.setEnabled(false);
                analyzeMenu.add(azimuthalAverageMenuItem);

                threeDSurfacePlotMenuItem = new MenuItem("Interactive 3-D surface plot");
                threeDSurfacePlotMenuItem.addActionListener(this);
                analyzeMenu.add(threeDSurfacePlotMenuItem);

                analyzeMenu.addSeparator();

                analyzeMenu.add("*Requires line, box, or circle selection");
                analyzeMenu.add("  on image before execution.");

                mainMenuBar.add(analyzeMenu);

//------end menus---------------------------------------------------------------------

                mainPanel = new Panel(new SpringLayout());
                topPanelA = new JPanel();
                topPanelA.setLayout(new BoxLayout(topPanelA, BoxLayout.LINE_AXIS));
                zoomPanel = new JPanel();
                zoomPanel.setLayout(new BoxLayout(zoomPanel, BoxLayout.LINE_AXIS));
                topPanelB = new JPanel();
                topPanelB.setLayout(new BoxLayout(topPanelB, BoxLayout.LINE_AXIS));
                topPanelBC = new JPanel(new SpringLayout());
                bottomPanelB = new JPanel();
                bottomPanelB.setLayout(new BoxLayout(bottomPanelB, BoxLayout.LINE_AXIS));

                topPanelB.add(Box.createHorizontalGlue());

                Dimension valueDim = new Dimension(90, 20);
                Dimension valueDimMin = new Dimension(90, 20);
                Dimension intCntDim = new Dimension(120, 20);
                Dimension intCntDimMin = new Dimension(120, 20);
                Dimension labelDim = new Dimension(65, 20);
                Dimension labelDimMin = new Dimension (65, 20);

                JLabel ijXLabel = new JLabel("ImageJ X:");
                ijXLabel.setFont(p12);
                ijXLabel.setHorizontalAlignment(JLabel.RIGHT);
                ijXLabel.setPreferredSize(labelDim);
                ijXLabel.setMaximumSize(labelDim);
                ijXLabel.setMinimumSize(labelDimMin);
                ijXLabel.setLabelFor(ijXTextField);
                topPanelBC.add(ijXLabel);

                ijXTextField = new JTextField("");
                ijXTextField.setFont(p12);
                ijXTextField.setHorizontalAlignment(JLabel.RIGHT);
                ijXTextField.setPreferredSize(valueDim);
                ijXTextField.setMaximumSize(valueDim);
                ijXTextField.setMinimumSize(valueDimMin);
                ijXTextField.setEditable(false);
                topPanelBC.add(ijXTextField);

                JLabel ijYLabel = new JLabel("ImageJ Y:");
                ijYLabel.setFont(p12);
                ijYLabel.setHorizontalAlignment(JLabel.RIGHT);
                ijYLabel.setPreferredSize(labelDim);
                ijYLabel.setMaximumSize(labelDim);
                ijYLabel.setMinimumSize(labelDimMin);
                ijYLabel.setLabelFor(ijYTextField);
                topPanelBC.add(ijYLabel);

                ijYTextField = new JTextField("");
                ijYTextField.setFont(p12);
                ijYTextField.setHorizontalAlignment(JTextField.RIGHT);
                ijYTextField.setPreferredSize(valueDim);
                ijYTextField.setMaximumSize(valueDim);
                ijYTextField.setMinimumSize(valueDimMin);
                ijYTextField.setEditable(false);
                topPanelBC.add(ijYTextField);

                JLabel valueLabel = new JLabel("Value:");
                valueLabel.setFont(p12);
                valueLabel.setHorizontalAlignment(JLabel.RIGHT);
                valueLabel.setPreferredSize(labelDim);
                valueLabel.setMaximumSize(labelDim);
                valueLabel.setMinimumSize(labelDimMin);
                valueLabel.setLabelFor(valueTextField);
                topPanelBC.add(valueLabel);

                valueTextField = new JTextField("");
                valueTextField.setFont(b12);
                valueTextField.setHorizontalAlignment(JTextField.RIGHT);
                valueTextField.setPreferredSize(intCntDim);
                valueTextField.setMaximumSize(intCntDim);
                valueTextField.setMinimumSize(intCntDimMin);
                valueTextField.setEditable(false);
                topPanelBC.add(valueTextField);

                JLabel RALabel = new JLabel("RA:");
                RALabel.setFont(p12);
                RALabel.setHorizontalAlignment(JLabel.RIGHT);
                RALabel.setPreferredSize(labelDim);
                RALabel.setMaximumSize(labelDim);
                RALabel.setMinimumSize(labelDimMin);
                RALabel.setLabelFor(RATextField);
                topPanelBC.add(RALabel);

                RATextField = new JTextField("");
                RATextField.setFont(p12);
                RATextField.setHorizontalAlignment(JLabel.RIGHT);
                RATextField.setPreferredSize(valueDim);
                RATextField.setMaximumSize(valueDim);
                RATextField.setMinimumSize(valueDimMin);
                RATextField.setEditable(false);
                topPanelBC.add(RATextField);

                JLabel DecLabel = new JLabel("DEC:");
                DecLabel.setFont(p12);
                DecLabel.setHorizontalAlignment(JLabel.RIGHT);
                DecLabel.setPreferredSize(labelDim);
                DecLabel.setMaximumSize(labelDim);
                DecLabel.setMinimumSize(labelDimMin);
                DecLabel.setLabelFor(DecTextField);
                topPanelBC.add(DecLabel);

                DecTextField = new JTextField("");
                DecTextField.setFont(p12);
                DecTextField.setHorizontalAlignment(JLabel.RIGHT);
                DecTextField.setPreferredSize(valueDim);
                DecTextField.setMaximumSize(valueDim);
                DecTextField.setMinimumSize(valueDimMin);
                DecTextField.setEditable(false);
                topPanelBC.add(DecTextField);

//                JLabel arcLengthLabel = new JLabel("Arclen:");
                peakLabel = new JTextField("Peak:");
                peakLabel.setFont(p12);
                peakLabel.setBorder(BorderFactory.createEmptyBorder());
                peakLabel.setBackground(topPanelA.getBackground());
                peakLabel.setPreferredSize(labelDim);
                peakLabel.setMaximumSize(labelDim);
                peakLabel.setMinimumSize(labelDimMin);
                peakLabel.setHorizontalAlignment(JLabel.RIGHT);
                topPanelBC.add(peakLabel);

                peakTextField = new JTextField("");
                peakTextField.setFont(p12);
                peakTextField.setHorizontalAlignment(JLabel.RIGHT);
                peakTextField.setPreferredSize(intCntDim);
                peakTextField.setMaximumSize(intCntDim);
                peakTextField.setMinimumSize(intCntDimMin);
                peakTextField.setEditable(false);
                topPanelBC.add(peakTextField);

                JLabel fitsXLabel = new JLabel("FITS X:");
                fitsXLabel.setFont(p12);
                fitsXLabel.setHorizontalAlignment(JLabel.RIGHT);
                fitsXLabel.setPreferredSize(labelDim);
                fitsXLabel.setMaximumSize(labelDim);
                fitsXLabel.setMinimumSize(labelDimMin);
                fitsXLabel.setLabelFor(fitsXTextField);
                topPanelBC.add(fitsXLabel);

                fitsXTextField = new JTextField("");
                fitsXTextField.setFont(p12);
                fitsXTextField.setHorizontalAlignment(JLabel.RIGHT);
                fitsXTextField.setPreferredSize(valueDim);
                fitsXTextField.setMaximumSize(valueDim);
                fitsXTextField.setMinimumSize(valueDimMin);
                fitsXTextField.setEditable(false);
                topPanelBC.add(fitsXTextField);

                JLabel fitsYLabel = new JLabel("FITS Y:");
                fitsYLabel.setFont(p12);
                fitsYLabel.setHorizontalAlignment(JLabel.RIGHT);
                fitsYLabel.setPreferredSize(labelDim);
                fitsYLabel.setMaximumSize(labelDim);
                fitsYLabel.setMinimumSize(labelDimMin);
                fitsYLabel.setLabelFor(fitsYTextField);
                topPanelBC.add(fitsYLabel);

                fitsYTextField = new JTextField("");
                fitsYTextField.setFont(p12);
                fitsYTextField.setHorizontalAlignment(JLabel.RIGHT);
                fitsYTextField.setPreferredSize(valueDim);
                fitsYTextField.setMaximumSize(valueDim);
                fitsYTextField.setMinimumSize(valueDimMin);
                fitsYTextField.setEditable(false);
                topPanelBC.add(fitsYTextField);

//                JLabel lengthLabel = new JLabel("Length:");
                lengthLabel = new JTextField("Int Cnts:");
                lengthLabel.setFont(p12);
                lengthLabel.setBorder(BorderFactory.createEmptyBorder());
                lengthLabel.setBackground(topPanelA.getBackground());
                lengthLabel.setPreferredSize(labelDim);
                lengthLabel.setMaximumSize(labelDim);
                lengthLabel.setMinimumSize(labelDimMin);
                lengthLabel.setHorizontalAlignment(JLabel.RIGHT);
                topPanelBC.add(lengthLabel);

                lengthTextField = new JTextField("");
                lengthTextField.setFont(p12);
                lengthTextField.setHorizontalAlignment(JLabel.RIGHT);
                lengthTextField.setPreferredSize(intCntDim);
                lengthTextField.setMaximumSize(intCntDim);
                lengthTextField.setMinimumSize(intCntDimMin);
                lengthTextField.setEditable(false);
                topPanelBC.add(lengthTextField);

                SpringUtil.makeCompactGrid (topPanelBC, 3, topPanelBC.getComponentCount()/3, 3,3,3,3);
                topPanelB.add(topPanelBC);

                topPanelB.add(Box.createGlue());

                mainPanel.add(topPanelB);

                int iconWidth = 26;
                int iconHeight = 26;
                Dimension iconDimension = new Dimension(iconWidth, iconHeight);

                ImageIcon zoomInFastIcon = createImageIcon("images/viewmag++.png", "In Fast");
                ImageIcon zoomInIcon = createImageIcon("images/viewmag+.png", "In");
                ImageIcon zoomOutIcon = createImageIcon("images/viewmag-.png", "Out");
                ImageIcon zoomFitIcon = createImageIcon("images/viewmagfit.png", "Fit");
                ImageIcon multiApertureIcon = createImageIcon("images/multiaperture.png", "Multi-Aperture");
                ImageIcon alignIcon = createImageIcon("images/align.png", "Stack Align");
                ImageIcon headerIcon = createImageIcon("images/header.png", "Header");
                ImageIcon negativeIcon = createImageIcon("images/negative.png", "Negative");
                ImageIcon negativeIconSelected = createImageIcon("images/negativeselected.png", "Negative (selected)");
                ImageIcon autoscaleIcon = createImageIcon("images/autoscale.png", "Autoscale");
                ImageIcon broomIcon = createImageIcon("images/broom.png", "Clear Aperture Overlay");
                ImageIcon showAllIcon = createImageIcon("images/showallaps.png", "Show All Apertures in Overlay");
                ImageIcon showSkyIcon = createImageIcon("images/showsky.png", "Toggle Sky Annuli");
                ImageIcon showSkyIconSelected = createImageIcon("images/showskyselected.png", "Toggle Sky Annuli (selected)");
                ImageIcon sourceIDIcon = createImageIcon("images/sourceid.png", "Toogle Source ID");
                ImageIcon sourceIDIconSelected = createImageIcon("images/sourceidselected.png", "Toogle Source ID (selected)");
                ImageIcon sourceCountsIcon = createImageIcon("images/sourcecounts.png", "Toggle Source Counts");
                ImageIcon sourceCountsIconSelected = createImageIcon("images/sourcecountsselected.png", "Toggle Source Counts (selected)");
                ImageIcon centroidIcon = createImageIcon("images/centroid.png", "Centroid Apertures");
                ImageIcon centroidIconSelected = createImageIcon("images/centroidselected.png", "Centroid Apertures (selected)");
                ImageIcon setApertureIcon = createImageIcon("images/setaperture.png", "Change Aperture Settings");
                ImageIcon clearMeasurementsIcon = createImageIcon("images/cleartable.png", "Clear Measurements Table");
                ImageIcon deleteSliceIcon = createImageIcon("images/deleteslice.png", "Delete current slice");

                topPanelA.add(Box.createHorizontalGlue());
                topPanelA.add(Box.createHorizontalStrut(20));
                Insets buttonMargin = new Insets(2,2,2,2); //top,left,bottom,right
//                if (IJ.isWindows() || IJ.isMacintosh())
//                       buttonMargin = new Insets(2,4,2,4); //top,left,bottom,right

                buttonSub32768 = new JButton("-32768");
//                buttonSub32768.setMargin(buttonMargin);
                buttonSub32768.addActionListener(this);
//                topPanelAC.add(buttonSub32768);
                buttonAdd32768 = new JButton("+32768");
//                buttonAdd32768.setMargin(buttonMargin);
                buttonAdd32768.addActionListener(this);
//                topPanelAC.add(buttonAdd32768);

                buttonDeleteSlice = new JButton(deleteSliceIcon);
                buttonDeleteSlice.setToolTipText("delete currently displayed slice from stack");
                buttonDeleteSlice.setPreferredSize(iconDimension);
                buttonDeleteSlice.setMargin(buttonMargin);
                buttonDeleteSlice.addActionListener(this);
                topPanelA.add(buttonDeleteSlice);

                topPanelA.add(Box.createHorizontalStrut(10));
                
                buttonNegative = new JToggleButton(negativeIcon, useInvertingLut);
                buttonNegative.setToolTipText("display as image negative");
                buttonNegative.setSelectedIcon(negativeIconSelected);
                buttonNegative.setPreferredSize(iconDimension);
                buttonNegative.setMargin(buttonMargin);
                buttonNegative.addActionListener(this);
                topPanelA.add(buttonNegative);

                buttonShowSky = new JToggleButton(showSkyIcon, showSkyOverlay);
                buttonShowSky.setToolTipText("display sky background regions");
                buttonShowSky.setSelectedIcon(showSkyIconSelected);
                buttonShowSky.setPreferredSize(iconDimension);
                buttonShowSky.setMargin(buttonMargin);
                buttonShowSky.addActionListener(this);
                topPanelA.add(buttonShowSky);

                buttonSourceID = new JToggleButton(sourceIDIcon, nameOverlay);
                buttonSourceID.setToolTipText("display source identification");
                buttonSourceID.setSelectedIcon(sourceIDIconSelected);
                buttonSourceID.setPreferredSize(iconDimension);
                buttonSourceID.setMargin(buttonMargin);
                buttonSourceID.addActionListener(this);
                topPanelA.add(buttonSourceID);

                buttonSourceCounts = new JToggleButton(sourceCountsIcon, valueOverlay);
                buttonSourceCounts.setToolTipText("display source integrated counts");
                buttonSourceCounts.setSelectedIcon(sourceCountsIconSelected);
                buttonSourceCounts.setPreferredSize(iconDimension);
                buttonSourceCounts.setMargin(buttonMargin);
                buttonSourceCounts.addActionListener(this);
                topPanelA.add(buttonSourceCounts);

                buttonCentroid = new JToggleButton(centroidIcon, reposition);
                buttonCentroid.setToolTipText("centroid apertures");
                buttonCentroid.setSelectedIcon(centroidIconSelected);
                buttonCentroid.setPreferredSize(iconDimension);
                buttonCentroid.setMargin(buttonMargin);
                buttonCentroid.addActionListener(this);
                topPanelA.add(buttonCentroid);

                buttonSetAperture = new JButton(setApertureIcon);
                buttonSetAperture.setToolTipText("change aperture settings");
                buttonSetAperture.setPreferredSize(iconDimension);
                buttonSetAperture.setMargin(buttonMargin);
                buttonSetAperture.addActionListener(this);
                topPanelA.add(buttonSetAperture);

                buttonBroom = new JButton(broomIcon);
                buttonBroom.setToolTipText("clear aperture overlay");
                buttonBroom.setPreferredSize(iconDimension);
                buttonBroom.setMargin(buttonMargin);
                buttonBroom.addActionListener(this);
                topPanelA.add(buttonBroom);
                
                buttonShowAll = new JButton(showAllIcon);
                buttonShowAll.setToolTipText("draw all stored apertures in overlay");
                buttonShowAll.setPreferredSize(iconDimension);
                buttonShowAll.setMargin(buttonMargin);
                buttonShowAll.addActionListener(this);
                topPanelA.add(buttonShowAll);

                topPanelA.add(Box.createHorizontalStrut(10));                
                
                buttonFlipX = new JButton("FlipX");
//                buttonFlipX.setMargin(buttonMargin);
                buttonFlipX.addActionListener(this);
//                topPanelA.add(buttonFlipX);
                buttonFlipY = new JButton("FlipY");
//                buttonFlipY.setMargin(buttonMargin);
                buttonFlipY.addActionListener(this);
//                topPanelA.add(buttonFlipY);
                buttonRotCCW = new JButton("RotCCW");
//                buttonRotCCW.setMargin(buttonMargin);
                buttonRotCCW.addActionListener(this);
//                topPanelA.add(buttonRotCCW);
                buttonRotCW = new JButton("RotCW");
//                buttonRotCW.setMargin(buttonMargin);
                buttonRotCW.addActionListener(this);
//                topPanelA.add(buttonRotCW);

                buttonClearMeasurements = new JButton(clearMeasurementsIcon);
                buttonClearMeasurements.setToolTipText("clear measurements table data");
                buttonClearMeasurements.setPreferredSize(iconDimension);
                buttonClearMeasurements.setMargin(buttonMargin);
                buttonClearMeasurements.addActionListener(this);
                topPanelA.add(buttonClearMeasurements);

                buttonMultiAperture = new JButton(multiApertureIcon);
                buttonMultiAperture.setToolTipText("perform multi-aperture photometry");
                buttonMultiAperture.setPreferredSize(iconDimension);
                buttonMultiAperture.setMargin(buttonMargin);
                buttonMultiAperture.addActionListener(this);
                topPanelA.add(buttonMultiAperture);

                buttonAlign = new JButton(alignIcon);
                buttonAlign.setToolTipText("align stack using apertures");
                buttonAlign.setPreferredSize(iconDimension);
                buttonAlign.setMargin(buttonMargin);
                buttonAlign.addActionListener(this);
                topPanelA.add(buttonAlign);

                buttonHeader = new JButton(headerIcon);
                buttonHeader.setToolTipText("display fits header");
                buttonHeader.setPreferredSize(iconDimension);
                buttonHeader.setMargin(buttonMargin);
                buttonHeader.addActionListener(this);
                topPanelA.add(buttonHeader);
                topPanelA.add(Box.createHorizontalStrut(10));
                topPanelA.setBorder(BorderFactory.createEmptyBorder(0, 0, 5, 0));

//                buttonLUT = new JButton("LUT");
//                buttonLUT.setMargin(buttonMargin);
//                buttonLUT.addActionListener(this);
//                topPanelAC.add(buttonLUT);




//                JLabel zoomLabel = new JLabel("Zoom  ");
//                zoomPanel.add(zoomLabel);



                

                buttonZoomInFast = new JButton(zoomInFastIcon);
                buttonZoomInFast.setToolTipText("zoom in fast");
                buttonZoomInFast.setMargin(buttonMargin);
                buttonZoomInFast.addActionListener(this);
                buttonZoomInFast.setPreferredSize(iconDimension);
                zoomPanel.add(buttonZoomInFast);

                buttonZoomIn = new JButton(zoomInIcon);
                buttonZoomIn.setMargin(buttonMargin);
                buttonZoomIn.addActionListener(this);
                buttonZoomIn.setToolTipText("zoom in");
                buttonZoomIn.setPreferredSize(iconDimension);
                zoomPanel.add(buttonZoomIn);

                buttonZoomOut = new JButton(zoomOutIcon);
                buttonZoomOut.setMargin(buttonMargin);
                buttonZoomOut.addActionListener(this);
                buttonZoomOut.setToolTipText("zoom out");
                buttonZoomOut.setPreferredSize(iconDimension);
                zoomPanel.add(buttonZoomOut);

                buttonFit = new JButton(zoomFitIcon);
                buttonFit.setMargin(buttonMargin);
                buttonFit.setToolTipText("zoom to fit image to window");
                buttonFit.setPreferredSize(iconDimension);
                buttonFit.addActionListener(this);
                zoomPanel.add(buttonFit);
//                zoomPanel.setBorder(BorderFactory.createTitledBorder(""));
                topPanelA.add(zoomPanel);

                topPanelA.add(Box.createHorizontalStrut(10));
                
                buttonAutoLevels = new JButton(autoscaleIcon);
                buttonAutoLevels.setToolTipText("auto brightness and contrast");
                buttonAutoLevels.setMargin(buttonMargin);
                buttonAutoLevels.setPreferredSize(iconDimension);
                buttonAutoLevels.addActionListener(this);
                topPanelA.add(buttonAutoLevels);
                topPanelA.add(Box.createHorizontalGlue());
                mainPanel.add(topPanelA);


//                icPanel.add(ac);
//                SpringUtil.makeCompactGrid (icPanel, 1, 1, 0,0,0,0);
                mainPanel.add(ac);

                stackSliders = this.getComponents();
//                IJ.log("stackSliders.length="+stackSliders.length);
                if (stackSliders.length > 0)
                        for (int i = 0; i < stackSliders.length; i++)
                                {
                                stackSliders[i].setPreferredSize(new Dimension(100,18));
                                mainPanel.add(stackSliders[i]);
                                }


                minValueTextField = new JTextField(fourPlaces.format(minValue));
                minValueTextField.setFont(p12);
                minValueTextField.setPreferredSize(new Dimension(70,17));
                minValueTextField.setHorizontalAlignment(JTextField.LEFT);
                bottomPanelB.add(minValueTextField);
                JTextField minlabelTextField = new JTextField(":min");
                minlabelTextField.setFont(p12);
                minlabelTextField.setPreferredSize(new Dimension(30,17));
                minlabelTextField.setHorizontalAlignment(JTextField.LEFT);
                minlabelTextField.setBorder(BorderFactory.createEmptyBorder());
                minlabelTextField.setEditable(false);
                bottomPanelB.add(minlabelTextField);

                bottomPanelB.add(Box.createHorizontalStrut(10));

                minTextField = new JTextField(fourPlaces.format(min));
                minTextField.setFont(b12);
                minTextField.setPreferredSize(new Dimension(70,17));
                minTextField.setHorizontalAlignment(JTextField.RIGHT);
                minTextField.setBorder(BorderFactory.createLineBorder(Color.RED));
                minTextField.setEditable(true);
                minTextField.addActionListener(this);
//                minTextField.getDocument().addDocumentListener(new thisDocumentListener());
                bottomPanelB.add(minTextField);

                JTextField lowlabelTextField = new JTextField(":black");
                lowlabelTextField.setFont(p12);
                lowlabelTextField.setPreferredSize(new Dimension(30,17));
                lowlabelTextField.setHorizontalAlignment(JTextField.LEFT);
                lowlabelTextField.setBorder(BorderFactory.createEmptyBorder());
                lowlabelTextField.setEditable(false);
                bottomPanelB.add(lowlabelTextField);

                bottomPanelB.add(Box.createHorizontalGlue());

                JTextField meanlabelTextField = new JTextField("mean:");
                meanlabelTextField.setFont(p12);
                meanlabelTextField.setPreferredSize(new Dimension(70,17));
                meanlabelTextField.setHorizontalAlignment(JTextField.RIGHT);
                meanlabelTextField.setBorder(BorderFactory.createEmptyBorder());
                meanlabelTextField.setEditable(false);
                bottomPanelB.add(meanlabelTextField);

                meanTextField = new JTextField(fourPlaces.format(stats.mean));
                meanTextField.setFont(p12);
                meanTextField.setPreferredSize(new Dimension(70,17));
                meanTextField.setHorizontalAlignment(JTextField.LEFT);
                meanTextField.setBorder(BorderFactory.createEmptyBorder());
                meanTextField.setEditable(false);
                bottomPanelB.add(meanTextField);

                bottomPanelB.add(Box.createHorizontalGlue());

                JTextField highlabelTextField = new JTextField("white:");
                highlabelTextField.setFont(p12);
                highlabelTextField.setPreferredSize(new Dimension(30,17));
                highlabelTextField.setHorizontalAlignment(JTextField.RIGHT);
                highlabelTextField.setBorder(BorderFactory.createEmptyBorder());
                highlabelTextField.setEditable(false);
                bottomPanelB.add(highlabelTextField);

                maxTextField = new JTextField(fourPlaces.format(max));
                maxTextField.setFont(b12);
                maxTextField.setPreferredSize(new Dimension(70,17));
                maxTextField.setHorizontalAlignment(JTextField.RIGHT);
                maxTextField.setBorder(BorderFactory.createLineBorder(Color.RED));
                maxTextField.setEditable(true);
                maxTextField.addActionListener(this);
//                maxTextField.getDocument().addDocumentListener(new thisDocumentListener());
                bottomPanelB.add(maxTextField);

                bottomPanelB.add(Box.createHorizontalStrut(10));

                JTextField maxlabelTextField = new JTextField("max:");
                maxlabelTextField.setFont(p12);
                maxlabelTextField.setPreferredSize(new Dimension(30,17));
                maxlabelTextField.setHorizontalAlignment(JTextField.RIGHT);
                maxlabelTextField.setBorder(BorderFactory.createEmptyBorder());
                maxlabelTextField.setEditable(false);
                bottomPanelB.add(maxlabelTextField);

                maxValueTextField = new JTextField(fourPlaces.format(maxValue));
                maxValueTextField.setFont(p12);
                maxValueTextField.setPreferredSize(new Dimension(70,17));
                maxValueTextField.setHorizontalAlignment(JTextField.RIGHT);
                bottomPanelB.add(maxValueTextField);
                updateMinMaxValueTextFields();
                bottomPanelB.setBorder(BorderFactory.createEmptyBorder(0, 0, 5, 0));

//                SpringUtil.makeCompactGrid (bottomPanelB, 1, bottomPanelB.getComponentCount(), 5,0,5,0);
                ImageProcessor ip = imp.getProcessor();

                getBiSliderStatistics();
                histogram = stats.histogram;
                logHistogram = new double[histogram.length];

                for (int i=0; i<histogram.length; i++)
                    {
                    if (histogram[i] <= 1)
                        logHistogram[i] = 0;
                    else
                        logHistogram[i] = Math.log(histogram[i]);
                    if (logHistogram[i] > histMax)
                        histMax = logHistogram[i];
                    }

                minMaxBiSlider = new BiSlider(BiSlider.RGB);
                minMaxBiSlider.setUniformSegment(false);
                minMaxBiSlider.setDecimalFormater(fourPlaces);
                minMaxBiSlider.setFont(p13);
//                minMaxBiSlider.setHorizontal(false);
//                minMaxBiSlider.setUI((BiSliderPresentation) metal);
                minMaxBiSlider.setVisible(true);
                minMaxBiSlider.setValues(minValue, maxValue);
                minMaxBiSlider.setMinimumColoredValue(min);
                minMaxBiSlider.setMaximumColoredValue(max);
                minMaxBiSlider.setMinimumValue(minValue);
                minMaxBiSlider.setMaximumValue(maxValue);
                minMaxBiSlider.setSegmentSize((maxValue - minValue)/(double)BISLISER_SEGMENTS);
                minMaxBiSlider.setMinimumColor(Color.BLACK);

                minMaxBiSlider.setMiddleColor(Color.BLACK);
                minMaxBiSlider.setMaximumColor(Color.BLACK);
                minMaxBiSlider.setColoredValues(min, max);
                minMaxBiSlider.setUnit("  ");
                minMaxBiSlider.setSliderBackground(Color.LIGHT_GRAY);
                minMaxBiSlider.setForeground(Color.BLACK);

                minMaxBiSlider.setDefaultColor(Color.WHITE);
                minMaxBiSlider.setPreferredSize(new Dimension(535,75));
                minMaxBiSlider.setPrecise(false);
                minMaxBiSlider.setOpaque(true);
                minMaxBiSlider.setArcSize(0);
                minMaxBiSlider.addContentPainterListener(new ContentPainterListener() {
                  public void paint(ContentPainterEvent ContentPainterEvent_Arg){
                    Graphics2D Graphics2 = (Graphics2D)ContentPainterEvent_Arg.getGraphics();
                    Rectangle Rect1 = ContentPainterEvent_Arg.getRectangle();
                    Graphics2.setColor((new Color(230, 230, 230)));
                    Graphics2.fillRect(Rect1.x, Rect1.y, Rect1.width, Rect1.height);
                    Rectangle Rect2 = ContentPainterEvent_Arg.getBoundingRectangle();
//                    double BarHeight = Math.abs(Math.cos(Math.PI*(Rect2.x+Rect2.width/2) / minMaxBiSlider.getWidth()));
//                    double BarHeight = (double)(Rect2.x+Rect2.width/2) / minMaxBiSlider.getWidth();
//                    double BarHeight = Math.random();

//                    float X = ((float)Rect2.x-minMaxBiSlider.getWidth()/2)/minMaxBiSlider.getWidth()*6;
                    double X = ((double)(Rect2.x - 10 - minMaxBiSlider.getX()))/((double)minMaxBiSlider.getWidth()-22.0);
//                    double BarHeight = 1-Math.exp((-1*X*X)/2);
                    int index = (int)(histogram.length*X);
                    if (index < 0) index = 0;
                    if (index >= logHistogram.length) index = logHistogram.length - 1;
//                    IJ.log("index = "+index+"   Max index = "+(logHistogram.length-1));
                    double BarHeight = 1.0-(logHistogram[index])/histMax;
//                    X = ((float)(Rect2.x-Rect2.width - 10 - minMaxBiSlider.getX()))/(double)minMaxBiSlider.getWidth();
//                    double BarHeight2 = 1-Math.exp((-1*X*X)/2);
//                    double BarHeight2 = 1.0-(logHistogram[(int)(histogram.length*X)])/histMax;

                    if (ContentPainterEvent_Arg.getColor()!=null) {
                      Graphics2.setColor(Color.WHITE);
                      Graphics2.fillRect(Rect2.x, Rect2.y, Rect2.width, (int)((BarHeight*Rect2.height)));
                      Graphics2.setColor(new Color(120, 165, 255));//(ContentPainterEvent_Arg.getColor());
                      Graphics2.fillRect(Rect2.x, Rect2.y+(int)((BarHeight*Rect2.height)), Rect2.width+1, 1+(int)(((1-BarHeight)*Rect2.height)));
                      //Graphics2.drawRect(Rect2.x, Rect2.y+(int)((BarHeight*Rect2.height)), Rect2.width+1, 1+(int)(((1-BarHeight)*Rect2.height)));
                    } else {
                      Graphics2.setColor(Color.LIGHT_GRAY);//(new Color(255, 255, 218, 64));
                      Graphics2.fillRect(Rect2.x, Rect2.y+(int)((BarHeight*Rect2.height)), Rect2.width+1, 1+(int)(((1-BarHeight)*Rect2.height)));
                    }
//                    Graphics2.setColor(Color.LIGHT_GRAY);
//                    //Graphics2.drawRect(Rect2.x, Rect2.y+(int)((BarHeight*Rect2.height)), Rect2.width-1, (int)(((1-BarHeight)*Rect2.height)));
//                    Graphics2.drawLine(Rect2.x, Rect2.y+(int)((BarHeight*Rect2.height)), Rect2.x+Rect2.width-1, Rect2.y+(int)((BarHeight*Rect2.height)));
//                    Graphics2.drawLine(Rect2.x, Rect2.y+(int)((BarHeight*Rect2.height)), Rect2.x, Rect2.y+(int)((prevBarHeight*Rect2.height)));
////                    Graphics2.drawLine(Rect2.x, Rect2.y+(int)((Math.max(BarHeight, BarHeight2)*Rect2.height)), Rect2.x, Rect2.y+Rect2.height);
//                    Rect3 = Rect2;
//                    prevBarHeight = BarHeight;
                  }
                });

//                final JPopupMenu JPopupMenu6 = minMaxBiSlider.createPopupMenu();
//                minMaxBiSlider.addMouseListener(new MouseAdapter(){
//                  public void mousePressed(MouseEvent MouseEvent_Arg){
//                    if (MouseEvent_Arg.getButton()==MouseEvent.BUTTON3){
//                      JPopupMenu6.show(minMaxBiSlider, MouseEvent_Arg.getX(), MouseEvent_Arg.getY());
//                    }
//                  }
//                });

                final String initialText = "\n\n\n Use this BiSlider to see the events generated\n";
                final JTextArea JTextArea5 = new  JTextArea(initialText);
                minMaxBiSlider.addBiSliderListener(new BiSliderAdapter(){
                      /** something changed that modified the color gradient between min and max */
                      public void newColors(BiSliderEvent BiSliderEvent_Arg) {
//                      IJ.log("newColors()");
                      }
                      /**  min or max colored values changed  */
                      public void newValues(BiSliderEvent BiSliderEvent_Arg) {
                            if (updatesEnabled)
                                {
                                min = minMaxBiSlider.getMinimumColoredValue();
                                max = minMaxBiSlider.getMaximumColoredValue();
                                sliceMin[imp.getCurrentSlice()-1] = min;
                                sliceMax[imp.getCurrentSlice()-1] = max;
    //
    //                            if (min < minValue)
    //                                    {
    //                                    min = minValue;
    //                                    minMaxBiSlider.setMinimumColoredValue(min);
    //                                    }
    //                            if (min > maxValue)
    //                                     {
    //                                    min = maxValue;
    //                                    minMaxBiSlider.setMinimumColoredValue(min);
    //                                    }
    //                            if (max > maxValue)
    //                                    {
    //                                    max = maxValue;
    //                                    minMaxBiSlider.setMaximumColoredValue(max);
    //                                    }
    //                            if (max < min)
    //                                    {
    //                                    max = min;
    //                                    minMaxBiSlider.setMaximumColoredValue(max);
    //                                    }

                                imp.setDisplayRange(min, max);
                                minMaxChanged = true;
                                minTextField.setText(fourPlaces.format(min));
                                maxTextField.setText(fourPlaces.format(max));
                                savedMin = min;
                                savedMax = max;
    //                            Prefs.set("Astronomy_Tool.savedMin", savedMin);
    //                            Prefs.set("Astronomy_Tool.savedMax", savedMax);

                                imp.updateAndDraw();
                                }
                           }
                      /**  min selected value changed  */
                      public void newMinValue(BiSliderEvent BiSliderEvent_Arg) {
//                      IJ.log("newMinValue()");
//                          getBiSliderStatistics;
//                          updatePanelValues();
                      }
                      /**  max selected value changed  */
                      public void newMaxValue(BiSliderEvent BiSliderEvent_Arg) {
//                      IJ.log("newMaxValue()");
//                            getBiSliderStatistics;
//                            maxValue = minMaxBiSlider.getMaximumValue();
//                            minMaxBiSlider.setSegmentSize((maxValue - minValue)/256.0);
//                            histogram = stats.histogram;
//                            IJ.log("after histogram="+minMaxBiSlider.getMaximumValue());
//                            for (int i=0; i<histogram.length; i++)
//                                {
//                                if (histogram[i] <= 1)
//                                    logHistogram[i] = 0;
//                                else
//                                    logHistogram[i] = Math.log(histogram[i]);
//                                if (logHistogram[i] > histMax)
//                                    histMax = logHistogram[i];
//                                }
//                            updatePanelValues();
                      }
                      /**  selected segments changed  */
                      public void newSegments(BiSliderEvent BiSliderEvent_Arg) {
//                          IJ.log("newSegments()");
//                          getBiSliderStatistics);
//                          updatePanelValues();
                      }
                    });
//                imp.setDisplayRange(min, max);
//                minMaxChanged = true;
                mainPanel.add(minMaxBiSlider);
                mainPanel.add(bottomPanelB);
                
                FileDrop fileDrop = new FileDrop(mainPanel, BorderFactory.createEmptyBorder(),new FileDrop.Listener()
                    {   public void filesDropped( java.io.File[] files )
                        {
                        openDragAndDropFiles(files);
                        }
                    });                

                SpringUtil.makeCompactGrid (mainPanel, mainPanel.getComponentCount(), 1, 0,0,0,0);
                
                setMenuBar(mainMenuBar);
                setTitle(impTitle);
                setName(impTitle);
                add(mainPanel);
                ImageIcon frameIcon = createImageIcon("images/astroIJ.png", "File Open");
                this.setIconImage(frameIcon.getImage());
                
                setResizable(true);


                pack();

                if (rememberWindowLocation)
                    {
                    Dimension mainScreenSize = Toolkit.getDefaultToolkit().getScreenSize();
                    if (!Prefs.isLocationOnScreen(new Point(frameLocationX, frameLocationY)))
                        {
                        frameLocationX = mainScreenSize.width/2 - getWidth()/2;
                        frameLocationY = mainScreenSize.height/2 - getHeight()/2;
                        }
                    this.setLocation(frameLocationX, frameLocationY);
                    }

                otherPanelsHeight = topPanelA.getHeight() + topPanelB.getHeight() +
                                    bottomPanelB.getHeight() + minMaxBiSlider.getHeight();
     }

//            class thisDocumentListener implements DocumentListener
//                {
//                public void insertUpdate (DocumentEvent ev)
//                    {
//                    IJ.log("insert");
//                    }
//                public void removeUpdate (DocumentEvent ev)
//                    {
//                    IJ.log("remove");
//                    }
//                public void changedUpdate (DocumentEvent ev)
//                    {
//                    IJ.log("changed");
//                    }
//                }


/** Returns an ImageIcon, or null if the path was invalid. */
protected ImageIcon createImageIcon(String path, String description) {
    java.net.URL imgURL = getClass().getResource(path);
    if (imgURL != null) {
        return new ImageIcon(imgURL, description);
    } else {
        IJ.log("Couldn't find icon file: " + path);
        return null;
    }
}



    void updateMinMaxValueTextFields() 
        {
        if (!useFixedMinMaxValues)
            {
            minValueTextField.setEditable(false);
            minValueTextField.setBorder(BorderFactory.createLineBorder(Color.GRAY));
            minValueTextField.removeActionListener(this);
            maxValueTextField.setEditable(false);
            maxValueTextField.setBorder(BorderFactory.createLineBorder(Color.GRAY));
            maxValueTextField.removeActionListener(this);
            }
        else
            {
            minValueTextField.setBorder(BorderFactory.createLineBorder(Color.RED));
            minValueTextField.setEditable(true);
            minValueTextField.addActionListener(this);
            maxValueTextField.setBorder(BorderFactory.createLineBorder(Color.RED));
            maxValueTextField.setEditable(true);
            maxValueTextField.addActionListener(this);
            }
        }

	public void itemStateChanged (ItemEvent e)
		{
		Object source = e.getItemSelectable();
		if (e.getStateChange() == ItemEvent.SELECTED)
			{
			if (source == autoConvertCB)
                {
				autoConvert = true;
                Prefs.set("Astronomy_Tool.autoConvert",autoConvert);
                }
            else if (source == startupAutoLevelRB)
                {
                startupAutoLevel = true;
                startupPrevLevels = false;
                startupPrevLevelsPerSlice = false;
                usePreviousLevelsRB.setState(false);
                usePreviousLevelsPerSliceRB.setState(false);
                useFullRangeRB.setState(false);
                Prefs.set("Astronomy_Tool.startupAutoLevel",startupAutoLevel);
                Prefs.set("Astronomy_Tool.startupPrevLevels",startupPrevLevels);
                Prefs.set("Astronomy_Tool.startupPrevLevelsPerSlice",startupPrevLevelsPerSlice);
                setAutoLevels(null);
                }
            else if (source == usePreviousLevelsRB)
                {
                startupAutoLevel = false;
                startupPrevLevels = true;
                startupPrevLevelsPerSlice = false;
                startupAutoLevelRB.setState(false);
                usePreviousLevelsPerSliceRB.setState(false);
                useFullRangeRB.setState(false);
                Prefs.set("Astronomy_Tool.startupAutoLevel",startupAutoLevel);
                Prefs.set("Astronomy_Tool.startupPrevLevels",startupPrevLevels);
                Prefs.set("Astronomy_Tool.startupPrevLevelsPerSlice",startupPrevLevelsPerSlice);
                }
            else if (source == usePreviousLevelsPerSliceRB)
                {
                startupAutoLevel = false;
                startupPrevLevels = false;
                startupPrevLevelsPerSlice = true;
                startupAutoLevelRB.setState(false);
                usePreviousLevelsRB.setState(false);
                useFullRangeRB.setState(false);
                Prefs.set("Astronomy_Tool.startupAutoLevel",startupAutoLevel);
                Prefs.set("Astronomy_Tool.startupPrevLevels",startupPrevLevels);
                Prefs.set("Astronomy_Tool.startupPrevLevelsPerSlice",startupPrevLevelsPerSlice);
                min = sliceMin[imp.getCurrentSlice()-1];
                max = sliceMax[imp.getCurrentSlice()-1];
                updatePanelValues();                
                }
             else if (source == useFullRangeRB)
                {
                startupAutoLevel = false;
                startupPrevLevels = false;
                startupPrevLevelsPerSlice = false;
                startupAutoLevelRB.setState(false);
                usePreviousLevelsRB.setState(false);
                usePreviousLevelsPerSliceRB.setState(false);
                Prefs.set("Astronomy_Tool.startupAutoLevel",startupAutoLevel);
                Prefs.set("Astronomy_Tool.startupPrevLevels",startupPrevLevels);
                Prefs.set("Astronomy_Tool.startupPrevLevelsPerSlice",startupPrevLevelsPerSlice);
                min = minValue;
                max = maxValue;
                updatePanelValues();
                }
            else if (source == useFixedMinMaxValuesCB)
                {
                if (imp.getType() == ImagePlus.COLOR_256 || imp.getType() == ImagePlus.COLOR_RGB || imp.getType() == ImagePlus.GRAY8)
                    {
                    useFixedMinMaxValues = false;
                    useFixedMinMaxValuesCB.setState(false);
                    }
                else
                    {
                    useFixedMinMaxValues = true;
                    Prefs.set("Astronomy_Tool.useFixedMinMaxValues", useFixedMinMaxValues);
      
                    if (imp.getType() == ImagePlus.GRAY16 && fixedMaxValue - fixedMinValue < 256)
                         fixedMaxValue = fixedMinValue + 255;
                    maxValue = fixedMaxValue;
                    minValue = fixedMinValue;             
                    updateMinMaxValues();
                    updateMinMaxValueTextFields();
                    }
                }
            else if(source == usePreviousSizeCB)
                {
				startupPrevSize = true;
                Prefs.set("Astronomy_Tool.startupPrevSize",startupPrevSize);
                }
            else if(source == usePreviousPanCB)
                {
				startupPrevPan = true;
                Prefs.set("Astronomy_Tool.startupPrevPan",startupPrevPan);
                }
            else if(source == usePreviousZoomCB)
                {
				startupPrevZoom = true;
                Prefs.set("Astronomy_Tool.startupPrevZoom",startupPrevZoom);
                }
            else if(source == rememberWindowLocationCB)
                {
				rememberWindowLocation = true;
                Prefs.set("Astronomy_Tool.rememberWindowLocation",rememberWindowLocation);
                }
            else if(source == showMeanNotPeakCB)
                {
				showMeanNotPeak = true;
                peakLabel.setText("Mean:");
                peakTextField.setText(fourPlaces.format(photom.meanBrightness()));                
                Prefs.set("Astronomy_Tool.showMeanNotPeak",showMeanNotPeak);
                }                        
            else if(source == useSexagesimalCB)
                {
				useSexagesimal = true;
                Prefs.set("Astronomy_Tool.useSexagesimal",useSexagesimal);
                }
            else if(source == middleClickCenterCB)
                {
				middleClickCenter = true;
                Prefs.set("Astronomy_Tool.middleClickCenter",middleClickCenter);
                }
            else if(source == writeMiddleClickValuesCB)
                {
				writeMiddleClickValues = true;
                Prefs.set("Astronomy_Tool.writeMiddleClickValues",writeMiddleClickValues);
                }
            else if(source == writeMiddleDragValuesCB)
                {
				writeMiddleDragValues = true;
                Prefs.set("Astronomy_Tool.writeMiddleDragValues",writeMiddleDragValues);
                }
            else if(source == showPhotometerCB)
                {
                showPhotometer = true;
//                updatePhotometerOverlay();
                ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showPhotometer",showPhotometer);
                }
            else if(source == showRedCrossHairCursorCB)
                {
                ac.showRedCrossHairCursor = true;
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showRedCrossHairCursor",ac.showRedCrossHairCursor);
                }
            else if(source == removeBackStarsCB)
                {
				removeBackStars = true;
                Prefs.set("aperture.removebackstars",removeBackStars);
                }
            else if(source == showRemovedPixelsCB)
                {
				showRemovedPixels = true;
                Prefs.set("aperture.showremovedpixels",showRemovedPixels);
                }
            else if(source == showZoomCB)
                {
				showZoom = true;
                ac.setShowZoom(showZoom);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showZoom",showZoom);
                }
            else if(source == showDirCB)
                {
				showDir = true;
                ac.setShowDir(showDir);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showDir",showDir);
                }
            else if(source == showXYCB)
                {
				showXY = true;
                ac.setShowXY(showXY);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showXY",showXY);
                }
            else if(source == showScaleXCB)
                {
				showScaleX = true;
                ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);;
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showScaleX",showScaleX);
                }
            else if(source == showScaleYCB)
                {
				showScaleY = true;
                ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);;
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showScaleY",showScaleY);
                }            
            else if(source == invertNoneRB)
                {
				invertX = false;
                invertY = false;
                invertXRB.setState(false);
                invertYRB.setState(false);
                invertXYRB.setState(false);
                setOrientation();
                }
            else if(source == invertXRB)
                {
				invertX = true;
                invertY = false;
                invertNoneRB.setState(false);
                invertYRB.setState(false);
                invertXYRB.setState(false);
                setOrientation();
                }
            else if(source == invertYRB)
                {
				invertX = false;
                invertY = true;
                invertXRB.setState(false);
                invertNoneRB.setState(false);
                invertXYRB.setState(false);
                setOrientation();
                }
            else if(source == invertXYRB)
                {
				invertX = true;
                invertY = true;
                invertXRB.setState(false);
                invertYRB.setState(false);
                invertNoneRB.setState(false);
                setOrientation();
                }
            else if(source == rotate0RB)
                {
				rotation = AstroCanvas.ROT_0;
                rotate90RB.setState(false);
                rotate180RB.setState(false);
                rotate270RB.setState(false);
                setOrientation();
                }
            else if(source == rotate90RB)
                {
				rotation = AstroCanvas.ROT_90;
                rotate0RB.setState(false);
                rotate180RB.setState(false);
                rotate270RB.setState(false);
                setOrientation();
                }
            else if(source == rotate180RB)
                {
				rotation = AstroCanvas.ROT_180;
                rotate0RB.setState(false);
                rotate90RB.setState(false);
                rotate270RB.setState(false);
                setOrientation();
                }
            else if(source == rotate270RB)
                {
				rotation = AstroCanvas.ROT_270;
                rotate0RB.setState(false);
                rotate90RB.setState(false);
                rotate180RB.setState(false);
                setOrientation();
                }
            }
        else if(e.getStateChange() == ItemEvent.DESELECTED)
			{
			if (source == autoConvertCB)
                {
				autoConvert = false;
                Prefs.set("Astronomy_Tool.autoConvert",autoConvert);
                }
            else if (source == useFixedMinMaxValuesCB)
                {
                useFixedMinMaxValues = false;
                getStatistics();
                if (imp.getType() == ImagePlus.COLOR_RGB || imp.getType() == ImagePlus.GRAY8)
                    {
                    minValue = 0;
                    maxValue = 255;
                    }
                else if (imp.getType() == ImagePlus.GRAY16 && stats.max-stats.min < 256)
                    {
                    minValue = stats.min;
                    maxValue = stats.min + 255;
                    }
                else
                    {
                    minValue=stats.min;
                    maxValue=stats.max;
                    Prefs.set("Astronomy_Tool.useFixedMinMaxValues", useFixedMinMaxValues);
                    }
                updateMinMaxValueTextFields();
                updateMinMaxValues();
                }
            else if(source == usePreviousSizeCB)
                {
				startupPrevSize = false;
                Prefs.set("Astronomy_Tool.startupPrevSize",startupPrevSize);
                }
            else if(source == usePreviousPanCB)
                {
				startupPrevPan = false;
                Prefs.set("Astronomy_Tool.startupPrevPan",startupPrevPan);
                }
            else if(source == usePreviousZoomCB)
                {
				startupPrevZoom = false;
                Prefs.set("Astronomy_Tool.startupPrevZoom",startupPrevZoom);
                }
            else if(source == rememberWindowLocationCB)
                {
				rememberWindowLocation = false;
                Prefs.set("Astronomy_Tool.rememberWindowLocation",rememberWindowLocation);
                }
            else if(source == showMeanNotPeakCB)
                {
				showMeanNotPeak = false;
                peakLabel.setText("Peak:");
                peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                Prefs.set("Astronomy_Tool.showMeanNotPeak",showMeanNotPeak);
                }             
            else if(source == useSexagesimalCB)
                {
				useSexagesimal = false;
                Prefs.set("Astronomy_Tool.useSexagesimal",useSexagesimal);
                }
            else if(source == middleClickCenterCB)
                {
				middleClickCenter = false;
                Prefs.set("Astronomy_Tool.middleClickCenter",middleClickCenter);
                }
            else if(source == writeMiddleClickValuesCB)
                {
				writeMiddleClickValues = false;
                Prefs.set("Astronomy_Tool.writeMiddleClickValues",writeMiddleClickValues);
                }
            else if(source == writeMiddleDragValuesCB)
                {
				writeMiddleDragValues = false;
                Prefs.set("Astronomy_Tool.writeMiddleDragValues",writeMiddleDragValues);
                }
            else if(source == showPhotometerCB)
                {
                showPhotometer = false;
                ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
//                apertureOverlay.clear();
                ac.repaint();
                Prefs.set("Astronomy_Tool.showPhotometer",showPhotometer);
                }
            else if(source == showRedCrossHairCursorCB)
                {
                ac.showRedCrossHairCursor = false;
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showRedCrossHairCursor",ac.showRedCrossHairCursor);
                }
            else if(source == removeBackStarsCB)
                {
				removeBackStars = false;
                Prefs.set("aperture.removebackstars",removeBackStars);
                }
            else if(source == showRemovedPixelsCB)
                {
				showRemovedPixels = false;
                Prefs.set("aperture.showremovedpixels",showRemovedPixels);
                }
            else if(source == showZoomCB)
                {
				showZoom = false;
                ac.setShowZoom(showZoom);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showZoom",showZoom);
                }
            else if(source == showDirCB)
                {
				showDir = false;
                ac.setShowDir(showDir);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showDir",showDir);
                }
            else if(source == showXYCB)
                {
				showXY = false;
                ac.setShowXY(showXY);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showXY",showXY);
                }
            else if(source == showScaleXCB)
                {
				showScaleX = false;
                ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showScaleX",showScaleX);
                }
            else if(source == showScaleYCB)
                {
				showScaleY = false;
                ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);
                ac.paint(ac.getGraphics());
                Prefs.set("Astronomy_Tool.showScaleY",showScaleY);
                }            
            else if(source == invertNoneRB)
                {
                invertNoneRB.setState(true);
                }
            else if(source == invertXRB)
                {
				invertXRB.setState(true);
                }
            else if(source == invertYRB)
                {
				invertYRB.setState(true);
                }
            else if(source == invertXYRB)
                {
				invertXYRB.setState(true);
                }
            else if(source == rotate0RB)
                {
				rotate0RB.setState(true);
                }
            else if(source == rotate90RB)
                {
				rotate90RB.setState(true);
                }
            else if(source == rotate180RB)
                {
				rotate180RB.setState(true);
                }
            else if(source == rotate270RB)
                {
				rotate270RB.setState(true);
                }
            else if (source == startupAutoLevelRB)
                {
                startupAutoLevelRB.setState(true);
                setAutoLevels(null);
                }
            else if (source == usePreviousLevelsRB)
                {
                usePreviousLevelsRB.setState(true);
                }
             else if (source == useFullRangeRB)
                {
                useFullRangeRB.setState(true);
                min = minValue;
                max = maxValue;
                updatePanelValues();
                }
            }
        }

         void setOrientation() {
            ac.setOrientation(invertX, invertY, rotation);
            ac.updateZoomBoxParameters();
            netFlipX = ac.getNetFlipX();
            netFlipY = ac.getNetFlipY();
            netRotate = ac.getNetRotate();
            ac.paint(ac.getGraphics());
            }


            public void actionPerformed(ActionEvent e) {
                Object b = e.getSource();
                currentSlice = imp.getCurrentSlice();

//------FILE menu--------------------------------------------------------------------------------------

                if (b==openMenuItem)
                    {
                    ImagePlus imp2 = IJ.openImage();
                    if (imp2 != null)
                        {
                        StackProcessor sp = new StackProcessor(imp.getStack(), imp2.getProcessor());
                        ImageStack s2 = imp2.getImageStack();
                        imp.setStack(s2);
                        imp.setFileInfo(imp2.getFileInfo());
                        copyImageProperties(imp2);
                        imp.setProcessor(imp2.getTitle(), imp2.getProcessor());
                        setAstroProcessor(false);
                        }
                    }
                else if (b==openInNewWindowMenuItem)
                    {
                    IJ.run("Open...");
                    }
                else if (b==openSeqMenuItem)
                    {
//				    String path = IJ.getDirectory ("current");
//                    DirectoryChooser.setDefaultDirectory(path);
//                    DirectoryChooser od = new DirectoryChooser ("Open Image Sequence...");
//        			if (od.getDirectory() != null)
//                        {
//                        path = od.getDirectory();
                        ImagePlus imp2 = FolderOpener.open(null);
                        StackProcessor sp = new StackProcessor(imp.getStack(), imp2.getProcessor());
                        ImageStack s2 = imp2.getImageStack();
                        imp.setStack(s2);
                        imp.setFileInfo(imp2.getFileInfo());
                        copyImageProperties(imp2);
                        imp.setProcessor(imp2.getTitle(), imp2.getProcessor());
                        setAstroProcessor(false);
//                        }
                    }
                else if (b==openSeqInNewWindowMenuItem)
                    {
                    IJ.run("Image Sequence...");
                    }
                else if (b==openMeasurementsTableMenuItem)
                    {
                    IJ.runPlugIn("Read_MeasurementTable","");
                    }
                else if (b==openAperturesMenuItem)
                    {
                    OpenDialog of = new OpenDialog("Open saved apertures", "");
                    if (of.getDirectory() == null || of.getFileName() == null)
                        return;
                    openApertures(of.getDirectory() + of.getFileName());
                    }                
                else if (b==saveAperturesMenuItem)
                    {
                    SaveDialog sf = new SaveDialog("Save aperture configuration", imp.getShortTitle(), "");
                    if (sf.getDirectory() == null || sf.getFileName() == null)
                        return;
                    String apsPath = sf.getDirectory() + sf.getFileName();
                    int location = apsPath.lastIndexOf('.');
                    if (location >= 0) apsPath = apsPath.substring(0, location);
                    saveApertures(apsPath+".apertures");
                    }
                else if (b==saveDisplayAsJpgMenuItem)
                    {
                    saveImageDisplay("jpg", false);
                    }
                else if (b==saveDisplayAsPngMenuItem)
                    {
                    saveImageDisplay("png", false);
                    }
                else if (b==saveStatePNGMenuItem)
                    {
                    if (saveAllPNG)
                        saveImageDisplay("png", true);
                    else
                        saveImageDisplay("jpg", true);
                    }
                else if (b==setSaveStateMenuItem)
                    {
                    setSaveStateDialog();
                    }
                else if (b==saveMenuItem)
                    {
                    String imageDirname = imp.getOriginalFileInfo().directory;
                    String imageFilename = imp.getStack().getShortSliceLabel(imp.getCurrentSlice());     
//                    IJ.log(imageDirname+imageFilename);
                    IJ.saveAs(imageFilename.substring(imageFilename.lastIndexOf('.')),imageDirname+imageFilename);
                    }
                else if (b==saveFitsMenuItem)
                    {
                    IJ.run("FITS...");
                    }
                else if (b==saveTiffMenuItem)
                    {
                    IJ.run("Tiff...");
                    }
                else if (b==saveJpegMenuItem)
                    {
                    IJ.run("Jpeg...");
                    }
                else if (b==saveGifMenuItem)
                    {
                    IJ.run("Gif...");
                    }
                else if (b==savePngMenuItem)
                    {
                    IJ.run("PNG...");
                    }
                else if (b==saveBmpMenuItem)
                    {
                    IJ.run("BMP...");
                    }
                else if (b==saveAviMenuItem)
                    {
                    IJ.run("AVI... ");
                    }
                else if (b==saveStackSequenceMenuItem)
                    {
                    IJ.run("Image Sequence... ");
                    }
                else if(b == exitMenuItem)
                    {
                    saveAndClose(true);
                    }

//-----PREFERENCES menu -------------------------------------------------------------

                else if(b == setPixelScaleMenuItem)
                    {
                    setPixelScaleDialog();
                    }
                else if(b == setZoomIndicatorSizeMenuItem)
                    {
                    setZoomIndicatorSizeDialog();
                    }
                else if(b == dirAngleMenuItem)
                    {
                    setDirAngleDialog();
                    }
                else if(b == setAutoScaleParametersMenuItem)
                    {
                    setAutoScaleParametersDialog();
                    }
              // Other are checkboxMenuItems



//-----VIEW menu --------------------------------------------------------------------

                else if(b == clearOverlayMenuItem)
                    {
                    IJ.runPlugIn("Clear_Overlay", "");
                    }

               // Others are checkboxMenuItems

//-----EDIT menu --------------------------------------------------------------------

                else if(b == apertureSettingsMenuItem)
                    {
                    IJ.runPlugIn("Set_Aperture", "");
                    }
                else if(b == measurementSettingsMenuItem)
                    {
                    IJ.run("Set Measurements...", "");
                    }
                else if(b == editFitsHeaderMenuItem)
                    {
                    FitsHeaderEditor fhe = new FitsHeaderEditor(imp);
//                    IJ.runPlugIn("FITS_Header_Editor", "");
                    }
                else if(b == stackSorterMenuItem)
                    {
                    IJ.runPlugIn("Stack_Sorter", "");
                    }

//-----PROCESS menu ------------------------------------------------------------------


                else if(b == dataReducerMenuItem)
                    {
                    IJ.runPlugIn("Data_Processor", "");
                    }
                else if(b == imageCalcMenuItem)
                    {
                    IJ.run("Image Calculator...", "");
                    }
                else if(b == removeOutliersMenuItem)
                    {
                    IJ.run("Remove Outliers...", "");
                    }
                else if(b == smoothMenuItem)
                    {
                    IJ.run("Smooth", "");
                    }
                else if(b == sharpenMenuItem)
                    {
                    IJ.run("Sharpen", "");
                    }
                else if(b == normalizeStackMenuItem)
                    {
                    IJ.runPlugIn("Normalize_Stack", "");
                    }
                else if(b == alignStackMenuItem)
                    {
                    IJ.runPlugIn("Stack_Aligner", "");
                    }
                else if(b == imageStabilizerMenuItem)
                    {
                    IJ.runPlugIn("Image_Stabilizer", "");
                    }
                else if(b == imageStabilizerApplyMenuItem)
                    {
                    IJ.runPlugIn("Image_Stabilizer_Log_Applier", "");
                    }
                else if(b == shiftImageMenuItem)
                    {
                    IJ.runPlugIn("Image_Shifter", "");
                    }
                else if(b == selectBestFramesMenuItem)
                    {
                    IJ.runPlugIn("Select_Frames_With_Best_Edges", "");
                    }
                else if(b == splitChannelsMenuItem)
                    {
                    IJ.doCommand("Split Channels");
                    }  
                else if(b == imagesToStackMenuItem)
                    {
                    IJ.doCommand("Images to Stack");
                    }  
                else if(b == stackToImagesMenuItem)
                    {
                    IJ.doCommand("Stack to Images");
                    }                  
                else if(b == debayerMenuItem)
                    {
                    IJ.runPlugIn("Debayer_Image_FITS", "");
                    }   
                else if(b == makeCompositeMenuItem)
                    {
                    IJ.doCommand("Make Composite");
                    }                              
                else if(b == stackToRGBMenuItem)
                    {
                    IJ.doCommand("Stack to RGB");
                    }                 
                else if (b==flipDataXMenuItem)
                    {
                    flipDataX = true;
                    startDataFlipRotate();
                    }
                else if (b==flipDataYMenuItem)
                    {
                    flipDataY = true;
                    startDataFlipRotate();
                    }
                else if (b==rotateDataCWMenuItem)
                    {
                    rotateDataCW = true;
                    startDataFlipRotate();
                    }
                else if (b==rotateDataCCWMenuItem)
                    {
                    rotateDataCCW = true;
                    startDataFlipRotate();
                    }



//-----ANALYZE menu ------------------------------------------------------------------


                else if(b == multiApertureMenuItem)
                    {
                    IJ.runPlugIn("MultiAperture_", "");
                    }
                else if(b == multiPlotMenuItem)
                    {
                    IJ.runPlugIn("Plot_IJ", "");
                    }
                else if(b == measurementMenuItem)
                    {
                    IJ.run("Measure", "");
                    }
                else if(b == seeingProfileMenuItem)
                    {
                    IJ.runPlugIn("Seeing_Profile", "");
                    }
                else if(b == staticProfilerMenuItem)
                    {
                    IJ.run("Plot Profile", "");
                    }
                else if(b == dynamicProfilerMenuItem)
                    {
                    IJ.runPlugIn("Dynamic_Profiler", "");
                    }
                else if(b == azimuthalAverageMenuItem)
                    {
                    IJ.runPlugIn("Azimuthal_Average", "imp");
                    }
                else if(b == threeDSurfacePlotMenuItem)
                    {
                    IJ.runPlugIn("Interactive_3D_Surface_Plot", "");
                    }






//-----TEXT fields ------------------------------------------------------------------

                else if(b == minTextField)
                    {
                    min = Double.parseDouble(minTextField.getText().replaceAll(",", ""));
                    sliceMin[imp.getCurrentSlice()-1] = min;
                    Prefs.set("Astronomy_Tool.savedMin", savedMin);
                    updatePanelValues();
                    }
                else if(b == maxTextField)
                    {
                    max = Double.parseDouble(maxTextField.getText().replaceAll(",", ""));
                    sliceMax[imp.getCurrentSlice()-1] = max;
                    Prefs.set("Astronomy_Tool.savedMin", savedMin);
                    updatePanelValues();
                    }
                else if(b == minValueTextField)
                    {
                    minValue = Double.parseDouble(minValueTextField.getText().replaceAll(",", ""));
                    if (imp.getType()==ImagePlus.GRAY16 && maxValue - minValue < 256)
                        minValue = maxValue - 255;
                    if (minValue > maxValue) minValue = maxValue;
                    if (min < minValue) min = minValue;
                    fixedMinValue = minValue;
                    Prefs.set("Astronomy_Tool.fixedMinValue", fixedMinValue);
                    updateMinMaxValues();
                    }
                else if(b == maxValueTextField)
                    {
                    maxValue = Double.parseDouble(maxValueTextField.getText().replaceAll(",", ""));
                    if (imp.getType()==ImagePlus.GRAY16 && maxValue - minValue < 256)
                        maxValue = minValue + 255;
                    if (maxValue < minValue) maxValue = minValue;
                    if (max > maxValue) max = maxValue;
                    fixedMaxValue = maxValue;
                    Prefs.set("Astronomy_Tool.fixedMaxValue", fixedMaxValue);
                    updateMinMaxValues();
                    }


//-----BUTTONS---------------------------------------------------------------------
                else if(b == buttonBroom)
                    {
                    IJ.runPlugIn("Clear_Overlay", "");
                    }
                else if(b == buttonShowAll)
                    {
                    openApertures("");
                    }                
                else if(b == buttonShowSky)
                    {
                    Prefs.set("setaperture.aperturechanged", true);
                    showSkyOverlay = !Prefs.get ("aperture.skyoverlay", showSkyOverlay);
                    Prefs.set ("aperture.skyoverlay", showSkyOverlay);
                    buttonShowSky.setSelected(showSkyOverlay);
                    ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
                    if (OverlayCanvas.hasOverlayCanvas(imp))
                        {
                        OverlayCanvas oc = OverlayCanvas.getOverlayCanvas(imp);
                        Roi[] rois = oc.getRois();
                        for (int i=0; i<rois.length; i++)
                            {
                            if (rois[i] instanceof astroj.ApertureRoi)
                                {
                                astroj.ApertureRoi aroi = (astroj.ApertureRoi)rois[i];
                                aroi.setShowSky(showSkyOverlay);
                                }
                            }
                        }
                    ac.repaint();
                    }
                else if(b == buttonSourceID)
                    {
                    nameOverlay = !Prefs.get ("aperture.nameoverlay", nameOverlay);
                    Prefs.set ("aperture.nameoverlay", nameOverlay);
                    buttonSourceID.setSelected(nameOverlay);
                    if (OverlayCanvas.hasOverlayCanvas(imp))
                        {
                        OverlayCanvas oc = OverlayCanvas.getOverlayCanvas(imp);
                        Roi[] rois = oc.getRois();
                        for (int i=0; i<rois.length; i++)
                            {
                            if (rois[i] instanceof astroj.ApertureRoi)
                                {
                                astroj.ApertureRoi aroi = (astroj.ApertureRoi)rois[i];
                                aroi.setShowName(nameOverlay);
                                }
                            }
                        }
                    ac.repaint();
                    }
                else if(b == buttonSourceCounts)
                    {
                    valueOverlay = !Prefs.get ("aperture.valueoverlay", valueOverlay);
                    Prefs.set ("aperture.valueoverlay", valueOverlay);
                    buttonSourceCounts.setSelected(valueOverlay);
                    if (OverlayCanvas.hasOverlayCanvas(imp))
                        {
                        OverlayCanvas oc = OverlayCanvas.getOverlayCanvas(imp);
                        Roi[] rois = oc.getRois();
                        for (int i=0; i<rois.length; i++)
                            {
                            if (rois[i] instanceof astroj.ApertureRoi)
                                {
                                astroj.ApertureRoi aroi = (astroj.ApertureRoi)rois[i];
                                aroi.setShowValue(valueOverlay);
                                }
                            }
                        }
                    ac.repaint();
                    }
                else if(b == buttonCentroid)
                    {
                    reposition = !Prefs.get ("aperture.reposition", reposition);
                    Prefs.set ("aperture.reposition", reposition);
                    buttonCentroid.setSelected(reposition);
                    }
                else if(b == buttonSetAperture)
                    {
                    IJ.runPlugIn("Set_Aperture", "");
                    }
                else if(b == buttonDeleteSlice)
                    {
                    if (!imp.lock())
                        return;
                    ImageStack stack = imp.getStack();
                    int numSlices = stack.getSize();
                    if (numSlices>2)
                        {
                        int n = imp.getCurrentSlice();
                        stack.deleteSlice(n);
                        imp.setStack(null, stack);
                        numSlices--;
                        if (n>numSlices)
                            imp.setSlice(numSlices);
                        else
                            imp.setSlice(n);

                        }
                    else
                        {
                        IJ.beep();
                        }
                    imp.unlock();
                    }
                else if(b == buttonMultiAperture)
                    {
                    reenterAstronomyTool();
                    IJ.runPlugIn("MultiAperture_", "");
                    }
                else if(b == buttonAlign)
                    {
                    reenterAstronomyTool();
                    IJ.runPlugIn("Stack_Aligner", "");
                    }
                else if(b == buttonHeader)
                    {
                    FitsHeaderEditor fhe = new FitsHeaderEditor(imp);
                    }
                else if(b == buttonNegative)
                    {
                    useInvertingLut = !useInvertingLut;
                    buttonNegative.setSelected(useInvertingLut);
                    ImageProcessor ip = imp.getProcessor();
                    if (useInvertingLut != ip.isInvertedLut() && !ip.isColorLut())
                        ip.invertLut();
                    imp.updateAndDraw();
                    }
                else if (b==buttonClearMeasurements)
                    {
                    try{
                        Class MP = Class.forName("MultiPlot_");
                        Method updatePlot = MP.getMethod("clearPlot");
                        updatePlot.invoke(null, (Object[])null);
                        
                        Class MA = Class.forName("MultiAperture_");
                        Method clearTable = MA.getMethod("clearTable");
                        clearTable.invoke(null, (Object[])null);

//                                Class MP = Class.forName("MultiPlot_");
//                                Method setTable = MP.getMethod("setTable", MeasurementTable.class, boolean.class);
//                                setTable.invoke(null, table, false);
                        }
                    catch (Throwable exception) {}
                    }
                else if (b==buttonFlipX)
                    {
                    for(int i = 1; i <= stackSize; i++)
                            {
                            imp.setSlice(i);
                            imp.getProcessor().flipHorizontal();
                            imp.updateAndDraw();
                            }
                    if (stackSize > 1)
                            {
                            imp.setSlice(currentSlice);
                            imp.updateAndDraw();
                            }
                    }
                else if (b==buttonFlipY)
                    {
                    for(int i = 1; i <= stackSize; i++)
                            {
                            imp.setSlice(i);
                            imp.getProcessor().flipVertical();
                            imp.updateAndDraw();
                            }
                    if (stackSize > 1)
                            {
                            imp.setSlice(currentSlice);
                            imp.updateAndDraw();
                            }
                    }
                else if (b==buttonRotCCW)
                    {
                    Calibration cal = imp.getCalibration();
                    currentSlice = imp.getCurrentSlice();
                    ImageProcessor ip = imp.getProcessor();
                    icWidth = ac.getWidth();
                    icHeight = ac.getHeight();
                    magnification = ac.getMagnification();
                    if (ipWidth != ipHeight)
                            {
                            StackProcessor sp = new StackProcessor(imp.getStack(), ip);
                            ImageStack s2 = null;
                            s2 = sp.rotateLeft();
                            imp.setStack(null, s2);
                            if (IJVersion.compareTo("1.42q") > 0 && IJVersion.compareTo("1.44f") < 0 ) 
                                imp = WindowManager.getImage(impTitle); 
                            double pixelWidth = cal.pixelWidth;
                            cal.pixelWidth = cal.pixelHeight;
                            cal.pixelHeight = pixelWidth;
                            imp.setCalibration(cal);
                            if (imp.getStackSize() > 1)
                                stackRotated = true;
                            layoutContainer(this);
                            ac.repaint();
//                            refreshAstroWindow();
                            }
                    else
                            {
                            for(int i = 1; i <= stackSize; i++)
                                    {
                                    imp.setSlice(i);
                                    ip = imp.getProcessor().rotateLeft();
                                    imp.setProcessor(null, ip);
                                    }
                            double pixelWidth = cal.pixelWidth;
                            cal.pixelWidth = cal.pixelHeight;
                            cal.pixelHeight = pixelWidth;  
                            imp.setCalibration(cal);
                            imp.setSlice(currentSlice);
                            }
                    }
                else if (b==buttonRotCW)
                    {
                    Calibration cal = imp.getCalibration();
                    ImageProcessor ip = imp.getProcessor();
                    currentSlice = imp.getCurrentSlice();
                    if (ipWidth != ipHeight)
                            {
                            StackProcessor sp = new StackProcessor(imp.getStack(), ip);
                            ImageStack s2 = null;
                            s2 = sp.rotateRight();
                            imp.setStack(null, s2);
                            if (IJVersion.compareTo("1.42q") > 0 && IJVersion.compareTo("1.44f") < 0 ) 
                                imp = WindowManager.getImage(impTitle);
                            double pixelWidth = cal.pixelWidth;
                            cal.pixelWidth = cal.pixelHeight;
                            cal.pixelHeight = pixelWidth;
                            imp.setCalibration(cal);
                            if (imp.getStackSize() > 1)
                                stackRotated = true;
                            ac.repaint();
//                            refreshAstroWindow();
                            }
                    else
                            {

//                            ImagePlus impr = NewImage.createFloatImage("temp", ipHeight, ipWidth, stackSize, 0);
//                            ImageProcessor ipr = impr.getProcessor();
//                            for(int i = 1; i <= stackSize; i++)
//                                    {
//                                    imp.setSlice(i);
//                                    impr.setSlice(i);
//                                    ipr = imp.getProcessor().rotateRight();
//                                    impr.setProcessor(null, ipr);
//                                    }
//                            ipr = impr.getProcessor();
//                            imp.flush();
//                            imp.setProcessor(null, ipr);
//                            ip = imp.getProcessor();
//                            imp.setWindow(iw);
                            for(int i = 1; i <= stackSize; i++)
                                    {
                                    imp.setSlice(i);
                                    ip = imp.getProcessor().rotateLeft();
                                    imp.setProcessor(null, ip);
                                    }
                            double pixelWidth = cal.pixelWidth;
                            cal.pixelWidth = cal.pixelHeight;
                            cal.pixelHeight = pixelWidth;
                            imp.setCalibration(cal);
                            imp.setSlice(currentSlice);
//                            Graphics g = ac.getGraphics();
//                            g.clearRect(0, 0, ac.getWidth(), ac.getHeight());
//                            ac.update(g);
                            ac.repaint();
                            }
                    }
//                else if (b==buttonLUT)
//                    {
//                    IJ.run("Image>Lookup Tables");
//                    }
                else if (b==buttonZoomOut)
                    {
                    zoomOut(startDragScreenX, startDragScreenY, true, true);
                    }
                else if (b==buttonZoomIn)
                    {
                    zoomIn(startDragScreenX, startDragScreenY, true, true, 0.0);
                    }
                else if (b==buttonZoomInFast)
                    {
                    zoomIn(startDragScreenX, startDragScreenY, true, true, 8.0);
                    }
                else if (b==buttonFit)
                    {
                    if ((e.getModifiers()& e.ALT_MASK) != 0 )
                        fillNotFit =true;
                    fitImageToCanvas();
                    }
                else if (b==buttonAutoLevels)
                    {
                    autoScaleIconClicked = true;
                    setAutoLevels(null);
                    }
            }

    void copyImageProperties(ImagePlus impp)
            {
            //CLEAR PROPERTIES FROM OPENIMAGE
            Enumeration enProps;
            String key;
            Properties props = imp.getProperties();
            if (props != null)
                {
                enProps = props.propertyNames();
                key = "";
                while (enProps.hasMoreElements())
                        {
                        key = (String) enProps.nextElement();
                        imp.setProperty(key, null);
                        }
                }
            // COPY NEW PROPERTIES TO OPEN WINDOW IMAGEPLUS
            props = impp.getProperties();
            if (props != null)
                {
                enProps = props.propertyNames();
                key = "";
                while (enProps.hasMoreElements())
                        {
                        key = (String) enProps.nextElement();
                        imp.setProperty(key, props.getProperty(key));
                        }
                }
            }

    void setSaveStateDialog()
        {
        GenericDialog gd = new GenericDialog ("Save all settings", getX()+getWidth()/2-165, getY()+getHeight()/2-77);
        gd.enableYesNoCancel("Save Files Now", "Save Settings Only");
        saveImage = Prefs.get("Astronomy_Tool.saveImage", saveImage);
        savePlot = Prefs.get("Astronomy_Tool.savePlot", savePlot);
        saveConfig = Prefs.get("Astronomy_Tool.saveConfig", saveConfig);
        saveTable = Prefs.get("Astronomy_Tool.saveTable", saveTable);
        saveApertures = Prefs.get("Astronomy_Tool.saveApertures", saveApertures);
        saveLog = Prefs.get("Astronomy_Tool.saveLog", saveLog);
        imageSuffix = Prefs.get("Astronomy_Tool.imageSuffix", imageSuffix);
        plotSuffix = Prefs.get("Astronomy_Tool.plotSuffix", plotSuffix);
        configSuffix = Prefs.get("Astronomy_Tool.configSuffix", configSuffix);
        dataSuffix = Prefs.get("Astronomy_Tool.dataSuffix", dataSuffix);
        aperSuffix = Prefs.get("Astronomy_Tool.aperSuffix", aperSuffix);
        logSuffix = Prefs.get("Astronomy_Tool.logSuffix", logSuffix);
        saveAllPNG = Prefs.get("Astronomy_Tool.saveAllPNG", saveAllPNG);

        gd.addMessage ("Select items to save when using save all:");
        String[] labels = {"Image","Plot","Plot Config","Data Table","Apertures","Log"};
        boolean[] defaults = {saveImage, savePlot, saveConfig, saveTable, saveApertures, saveLog};
        gd.addCheckboxGroup(1, 6, labels, defaults);
		gd.addStringField("Image suffix:", imageSuffix, 40);
        gd.addStringField("Plot image suffix:", plotSuffix, 40);
        gd.addStringField("Plot config file suffix:", configSuffix, 40);
        gd.addStringField("Data table file suffix:", dataSuffix, 40);
        gd.addStringField("Aperture file suffix:", aperSuffix, 40);
        gd.addStringField("Log file suffix:", logSuffix, 40);
        gd.addCheckbox("Save images in PNG format (uncheck for JPEG format)", saveAllPNG);
        gd.addMessage ("Tip: make plot config and data table suffix the same so that the plot config\n"+
                       "will auto-load when a new data table file is opened by drag and drop.");

		gd.showDialog();
		if (gd.wasCanceled()) return;
        saveImage = gd.getNextBoolean();
        savePlot = gd.getNextBoolean();
        saveConfig = gd.getNextBoolean();
        saveTable = gd.getNextBoolean();
        saveApertures = gd.getNextBoolean();
        saveLog = gd.getNextBoolean(); 
                
		imageSuffix = gd.getNextString();
        plotSuffix = gd.getNextString();
        configSuffix = gd.getNextString();
        dataSuffix = gd.getNextString();
        aperSuffix = gd.getNextString();
        logSuffix = gd.getNextString();
        
        saveAllPNG = gd.getNextBoolean(); 
        
        Prefs.set("Astronomy_Tool.saveImage", saveImage);
        Prefs.set("Astronomy_Tool.savePlot", savePlot);
        Prefs.set("Astronomy_Tool.saveConfig", saveConfig);
        Prefs.set("Astronomy_Tool.saveTable", saveTable);
        Prefs.set("Astronomy_Tool.saveApertures", saveApertures);
        Prefs.set("Astronomy_Tool.saveLog", saveLog); 
        Prefs.set("Astronomy_Tool.saveAllPNG", saveAllPNG);

        Prefs.set("Astronomy_Tool.imageSuffix", imageSuffix);
        Prefs.set("Astronomy_Tool.plotSuffix", plotSuffix);
        Prefs.set("Astronomy_Tool.configSuffix", configSuffix);
        Prefs.set("Astronomy_Tool.dataSuffix", dataSuffix);
        Prefs.set("Astronomy_Tool.aperSuffix", aperSuffix);
        Prefs.set("Astronomy_Tool.logSuffix", logSuffix);
        if (gd.wasOKed()) 
            {
            if (saveAllPNG)
                saveImageDisplay("png", true);
            else
                saveImageDisplay("jpg", true);            
            }
        }

    void setPixelScaleDialog()
        {
        GenericDialog gd = new GenericDialog ("Set pixel scale for images without WCS", getX()+getWidth()/2-165, getY()+getHeight()/2-77);

        gd.addMessage ("Enter 0 to report length in pixels.");
		gd.addNumericField ("X-pixel scale: ",pixelScaleX,4,8, "(seconds of arc per pixel in x-direction)");
        gd.addNumericField ("Y-pixel scale: ",pixelScaleY,4,8, "(seconds of arc per pixel in y-direction)");
        gd.addMessage ("");

		gd.showDialog();
		if (gd.wasCanceled()) return;
		pixelScaleX = gd.getNextNumber();
        pixelScaleY = gd.getNextNumber();
        ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);
        ac.updateZoomBoxParameters();
        ac.paint(ac.getGraphics());
        Prefs.set("Astronomy_Tool.pixelScaleX", pixelScaleX);
        Prefs.set("Astronomy_Tool.pixelScaleY", pixelScaleY);
        }

    void setZoomIndicatorSizeDialog()
        {
        GenericDialog gd = new GenericDialog ("Set Zoom Indicator Size", getX()+getWidth()/2-170, getY()+getHeight()/2-90);

		gd.addNumericField ("Zoom indicator height: ",ac.zoomIndicatorSize,0,6,"(pixels)");
        gd.addMessage ("(width is scaled according to image aspect ratio)");

		gd.showDialog();
		if (gd.wasCanceled()) return;
		ac.zoomIndicatorSize = (int)gd.getNextNumber();
        ac.updateZoomBoxParameters();
        ac.paint(ac.getGraphics());
        Prefs.set("Astronomy_Tool.zoomIndicatorSize", ac.zoomIndicatorSize);
        }

    void setDirAngleDialog()
        {
        GenericDialog gd = new GenericDialog ("Set Direction Indicator Angles",getX()+getWidth()/2-250,getY()+getHeight()/2-125);
//        gd.addMessage ("Direction angles are used when WCS is not available for an image.");
		gd.addNumericField ("North direction indicator angle: ",ac.NdirAngle,0,6,"(degrees CCW from +y-axis)***");
        gd.addNumericField ("East direction indicator angle: ",ac.EdirAngle,0,6,"(degrees CCW from north direction)***");
        gd.addMessage ("***Angles and directions are relative to image orientation 'Invert None'");
        gd.addMessage ("      and will follow the image if its orientation is changed.");

		gd.showDialog();

		if (gd.wasCanceled()) return;
        ac.NdirAngle=gd.getNextNumber();
        ac.EdirAngle=gd.getNextNumber();
        ac.updateZoomBoxParameters();
        ac.paint(ac.getGraphics());
        Prefs.set("Astronomy_Tool.NdirAngle", ac.NdirAngle);
        Prefs.set("Astronomy_Tool.EdirAngle", ac.EdirAngle);
        }

    void setAutoScaleParametersDialog()
        {
        GenericDialog gd = new GenericDialog ("Set Autoscale Parameters", getX()+getWidth()/2-337, getY()+getHeight()/2-175);
        gd.addMessage ("Auto brightness & contrast displays a range of pixel values based on the image's mean and standard deviation.");
        gd.addMessage ("");
        gd.addMessage ("Monochrome Images:");
		gd.addNumericField ("Low pixel value: mean image value less ",autoScaleFactorLow,4,8,"times standard deviation (default = 0.5)");
        gd.addNumericField ("How pixel value: mean image value plus ",autoScaleFactorHigh,4,8,"times standard deviation (default = 2.0)");
        gd.addMessage ("");
        gd.addMessage ("RGB Images:");
		gd.addNumericField ("Low pixel value: mean image value less ",autoScaleFactorLowRGB,4,8,"times standard deviation (default = 2.0)");
        gd.addNumericField ("How pixel value: mean image value plus ",autoScaleFactorHighRGB,4,8,"times standard deviation (default = 6.0)");

		gd.showDialog();
        
		if (gd.wasCanceled()) return;
        autoScaleFactorLow=gd.getNextNumber();
        autoScaleFactorHigh=gd.getNextNumber();
        autoScaleFactorLowRGB=gd.getNextNumber();
        autoScaleFactorHighRGB=gd.getNextNumber();

        if (startupAutoLevel) setAutoLevels(null);

        Prefs.set("Astronomy_Tool.autoScaleFactorLow", autoScaleFactorLow);
        Prefs.set("Astronomy_Tool.autoScaleFactorHigh", autoScaleFactorHigh);
        Prefs.set("Astronomy_Tool.autoScaleFactorLowRGB", autoScaleFactorLowRGB);
        Prefs.set("Astronomy_Tool.autoScaleFactorHighRGB", autoScaleFactorHighRGB);
        }


    void updateMinMaxValues()
        {
        if (startupAutoLevel)
            {
            setAutoLevels(null);
            }
        else if (startupPrevLevels)
            {
            updatePanelValues();
            }
        else
            {
            min = minValue;
            max = maxValue;
            updatePanelValues();
            }
        }

	void startDataFlipRotate()
		{
		try	{
			rotateTask = new TimerTask ()
				{
				public void run ()
					{
                    if (flipDataX) invertData("x", true);
                    else if (flipDataY) invertData("y", true);
                    else if (rotateDataCCW) rotateData("CCW", true);
                    else if (rotateDataCW) rotateData("CW", true);
                    flipDataX = false;
                    flipDataY = false;
                    rotateDataCCW = false;
                    rotateDataCW = false;

//                    adjustImageRotation(IMAGE_UPDATE);
                    rotateTask = null;
                    rotateTaskTimer = null;
                    }
                };
            rotateTaskTimer = new java.util.Timer();
            rotateTaskTimer.schedule (rotateTask,0);
            }

        catch (Exception e)
            {
            IJ.showMessage ("Error starting rotation task : "+e.getMessage());
            }
        }


//       void adjustImageRotation(boolean updateImage)
//            {
//            if (fX != prevInvertX)
//                {
//                invert("x", updateImage);
//                prevInvertX = invertX;
//
//                }
//            if (invertY != prevInvertY)
//                {
//                invert("y", updateImage);
//                prevInvertY = invertY;
//
//                }
//            if (rotation != prevRotation)
//                {
//                int del = rotation - prevRotation;
//                if (del == 1) rotate("left", updateImage);
//                else if (del ==-1) rotate("right", updateImage);
//                else if (del == 2 || del == - 2) {invert("x", updateImage); invert("y", updateImage);}
//                else if (del == 3) rotate("right", updateImage);
//                else if (del ==-3) rotate("left", updateImage);
//                prevRotation = rotation;
//
//                }
//            }
       
       void invertData(String dir, boolean updateImage)
            {
            stackSize = imp.getStackSize();
            currentSlice = imp.getCurrentSlice();
            ImageProcessor ip = imp.getProcessor();
            if (!dir.equals("x") && !dir.equals("y"))
                return;           
            for(int i = 1; i <= stackSize; i++)
                    {
                    minMaxChanged = true;
                    imp.setSlice(i);
                    IJ.showStatus("Invert-"+dir+": "+i+"/"+stackSize);
                    IJ.showProgress((double)i/(double)stackSize);
                    if (dir.equals("x"))
                        {minMaxChanged = true; imp.getProcessor().flipHorizontal();}
                    else
                        {minMaxChanged = true; imp.getProcessor().flipVertical();}
                    if (updateImage) {minMaxChanged = true; imp.updateAndDraw();}
                    }
            if (stackSize > 1)
                    {
                    minMaxChanged = true;
                    imp.setSlice(currentSlice);
                    if (updateImage) {minMaxChanged = true; imp.updateAndDraw();}
                    }
            }

       void rotateData(String dir, boolean updateImage)
            {
            if (!dir.equals("CCW") && !dir.equals("CW"))
                return;
            Calibration cal = imp.getCalibration();
            ImageProcessor ip = imp.getProcessor();
            icWidth = ac.getWidth();
            icHeight = ac.getHeight();
            ipWidth = imp.getWidth();
            ipHeight = imp.getHeight();
            stackSize = imp.getStackSize();
            currentSlice = imp.getCurrentSlice();
            if (ipWidth != ipHeight)
                {
                StackProcessor sp = new StackProcessor(imp.getStack(), ip);
                ImageStack s2 = null;
                if (dir.equals("CW")) {s2 = sp.rotateLeft();}
                else {s2 = sp.rotateRight();}
                imp.setStack(null, s2);
                if (IJVersion.compareTo("1.42q") > 0 && IJVersion.compareTo("1.44f") < 0 )
                    imp = WindowManager.getImage(impTitle);
                double pixelWidth = cal.pixelWidth;
                cal.pixelWidth = cal.pixelHeight;
                cal.pixelHeight = pixelWidth;
                minMaxChanged = true;
                imp.setCalibration(cal);
                if (imp.getStackSize() > 1)
                    stackRotated = true;
                if (updateImage)
                    {
                    dataRotated = true;
//                    layoutContainer(this);
                    ac.paint(ac.getGraphics());
                    }
                }
            else
                {
                for (int i = 1; i <= stackSize; i++)
                    {
                    imp.setSlice(i);
                    IJ.showStatus("Rotate: "+i+"/"+stackSize);
                    IJ.showProgress((double)i/(double)stackSize);
                    if (dir.equals("CW")) {ip = imp.getProcessor().rotateLeft();}
                    else {ip = imp.getProcessor().rotateRight();}
                    imp.setProcessor(null, ip);
                    if (updateImage) {imp.updateAndDraw();}
                    }
                double pixelWidth = cal.pixelWidth;
                cal.pixelWidth = cal.pixelHeight;
                cal.pixelHeight = pixelWidth;
                imp.setCalibration(cal);
                imp.setSlice(currentSlice);
                }
            if (stackSize > 1)
                    {
                    imp.setSlice(currentSlice);
                    if (updateImage) {imp.updateAndDraw();}
                    }
            }

       void fitImageToCanvas(){
            if (updatesEnabled)
                {
                int canvasWidth = newCanvasWidth();
                int canvasHeight = newCanvasHeight();


                double xmag = (double)canvasWidth/(double)imp.getWidth();
                double ymag = (double)canvasHeight/(double)imp.getHeight();
    //            if (ac.getNetRotate())
    //                {
    //                xmag = (double)newCanvasWidth()/(double)imp.getHeight();
    //                ymag = (double)newCanvasHeight()/(double)imp.getWidth();
    //                }

                ac.setDrawingSize(canvasWidth, canvasHeight);
                if (fillNotFit)
                    {
                    fillNotFit = false;
                    ac.setMagnification(Math.max(xmag,ymag));
                    }
                else
                    {
                    ac.setMagnification(Math.min(xmag,ymag));
                    }

                Rectangle r = new Rectangle((int)((imp.getWidth()/2.0) - canvasWidth/ac.getMagnification()/2.0),
                        (int)((imp.getHeight()/2.0 - canvasHeight/ac.getMagnification()/2.0 )),
                        (int)((double)newCanvasWidth()/ac.getMagnification()),
                        (int)((double)newCanvasHeight()/ac.getMagnification()));
                ac.setSourceRect(r);

                magnification = ac.getMagnification();
                Graphics g = ac.getGraphics();
                if (!fillNotFit)
                    {
                    g.setColor(Color.WHITE);
                    g.fillRect(0, 0, ac.getWidth(), ac.getHeight());
                    }
                ac.paint(g);

                srcRect = ac.getSrcRect();
                savedPanX = srcRect.x;
                savedPanY = srcRect.y;
                savedPanHeight = srcRect.height;
                savedPanWidth = srcRect.width;
                savedMag = ac.getMagnification();
                savedICWidth = ac.getWidth();
                savedICHeight = ac.getHeight();
                Prefs.set("Astronomy_Tool.savedMag", savedMag);
                Prefs.set("Astronomy_Tool.savedICWidth", savedICWidth);
                Prefs.set("Astronomy_Tool.savedICHeight", savedICHeight);
                Prefs.set("Astronomy_Tool.savedPanX", savedPanX);
                Prefs.set("Astronomy_Tool.savedPanY", savedPanY);
                Prefs.set("Astronomy_Tool.savedPanHeight", savedPanHeight);
                Prefs.set("Astronomy_Tool.savedPanWidth", imp.getWidth());
                setImageEdges();
                }
            }

        @Override
        protected Dimension getExtraSize() {
            if (otherPanelsHeight > 0)
                {
                return new Dimension(extraWidth(), extraHeight());
                }
            else
                {
                Insets insets = getInsets();
                int extraWidth = insets.left+insets.right + 10;
                int extraHeight = insets.top+insets.bottom + 10;
                if (extraHeight==20) extraHeight = 42;
                int members = getComponentCount();
                //if (IJ.debugMode) IJ.log("getExtraSize: "+members+" "+insets);
                for (int i=1; i<members; i++) {
                    Component m = getComponent(i);
                    Dimension d = m.getPreferredSize();
                    extraHeight += d.height + 5;
                    if (IJ.debugMode) IJ.log(i+"  "+d.height+" "+extraHeight);
                    }
                return new Dimension(extraWidth, extraHeight);
                }
            }


       int newCanvasWidth()
            {
            return getWidth() - extraWidth();
            }

       int extraWidth()
            {
            return getInsets().left + getInsets().right + 12;
            }

       int newCanvasHeight()
            {
            return getHeight() - extraHeight();
            }

       int extraHeight()
            {
            return getInsets().top + getInsets().bottom + otherPanelsHeight
                    + stackSliders.length*18 + 12;
            }

//       void clearAndPaint(){
//            ac.resetDoubleBuffer();
//
////            Graphics g = ac.getGraphics();
////            g.setColor(Color.WHITE);
////            g.fillRect(0, 0, ac.getWidth(), ac.getHeight());
////            ac.paint(g);
////            ac.repaint();
////            IJ.log("clearandPaint");
//            Graphics g = ac.getGraphics();
//            if (!IJ.isMacOSX())
//                {
//                int x1 = ac.screenX(0) > 0 ? ac.screenX(0) : 0;    //top left screen x-location
//                int y1 = ac.screenY(0) > 0 ? ac.screenY(0) : 0;    //top left screen y-location
//                int x2 = ac.screenX(imp.getWidth()) < ac.getWidth() ? ac.screenX(imp.getWidth()) : ac.getWidth();    //bottom right screen x-location
//                int y2 = ac.screenY(imp.getHeight()) < ac.getHeight() ? ac.screenY(imp.getHeight()) : ac.getHeight();    //bottom right screen y-location
//
//                g.setColor(Color.WHITE);
//                if (x1 >= 0)
//                    g.fillRect(0, 0, x1, ac.getHeight());
//                if (y1 >= 0)
//                    g.fillRect(x1, 0 , ac.getWidth()-x1, y1);
//                if (x2 <= ac.getWidth())
//                    g.fillRect(x2, y1 , ac.getWidth()-x2, ac.getHeight()-y1);
//                if (y2 <= ac.getHeight())
//                    g.fillRect(x1, y2 , x2-x1, ac.getHeight()-y2);
//               }
//
//            ac.paint(g);
//            }


//       public void refreshAstroWindow()
//                {
//                double newMag, oldMag;
//                imageWindow = imp.getWindow();
//                ac = OverlayCanvas.getOverlayCanvas(imp);
//                oldMag = ac.getMagnification();
//                ImageProcessor ip = imp.getProcessor();
//
//                ipWidth = ip.getWidth();
//                ipHeight = ip.getHeight();
//                icWidth = ac.getWidth();
//                icHeight = ac.getHeight();
//                imageHeight = imageWindow.getHeight();
//                imageWidth = imageWindow.getWidth();
//
//                int height = imageHeight-58-otherPanelsHeight-stackSliders.length*18;
//                int width = imageWidth - 26;
//                if (width < MIN_FRAME_WIDTH) width = MIN_FRAME_WIDTH;
//
//                if (stackRotated && (IJVersion.compareTo("1.44f") >= 0)) {
//                    newMag = Math.max((double)width/(double)ipHeight, (double)height/(double)ipWidth);
//                    stackRotated = false;
//                } else {
//                    newMag = Math.max((double)width/(double)ipWidth, (double)height/(double)ipHeight);
//                }
//                ac.setDrawingSize((int)(ipWidth*newMag), (int)(ipHeight*newMag));
//                ac.setMagnification(newMag);
////                ac.repaint();
////                toolbar.removeMouseListener(toolbarMouseListener);
//                astroWindow = new AstroStackWindow(imp, (OverlayCanvas)ac, REFRESH, NORESIZE);
//                }



void saveImageDisplay(String format, boolean saveAll)
    {
    String outBase = "dataset";
    Graphics g = ic.getGraphics();
    Image img = ac.graphicsToImage(g);
    BufferedImage imageDisplay = (BufferedImage)(img);
//    BufferedImage imageDisplay = toBufferedImage(img);
    SaveDialog sf = new SaveDialog(saveAll ? "Save all" : "Save as "+format.toUpperCase(), imp.getShortTitle(), "");
    if (sf.getDirectory() == null || sf.getFileName() == null)
        return;
    String outPath = sf.getDirectory() + sf.getFileName();
    int location = outPath.lastIndexOf('.');
    if (location >= 0) outPath = outPath.substring(0, location);
    outBase = outPath;
    if (outBase.endsWith(imageSuffix))
        {
        location = outBase.lastIndexOf(imageSuffix);
        if (location >= 0) outBase = outBase.substring(0, location);
        }
    else if (outBase.endsWith(plotSuffix))
        {
        location = outBase.lastIndexOf(plotSuffix);
        if (location >= 0) outBase = outBase.substring(0, location);
        }
    else if (outBase.endsWith(configSuffix))
        {
        location = outBase.lastIndexOf(configSuffix);
        if (location >= 0) outBase = outBase.substring(0, location);
        }
    else if (outBase.endsWith(dataSuffix))
        {
        location = outBase.lastIndexOf(dataSuffix);
        if (location >= 0) outBase = outBase.substring(0, location);
        }
    else if (outBase.endsWith(aperSuffix))
        {
        location = outBase.lastIndexOf(aperSuffix);
        if (location >= 0) outBase = outBase.substring(0, location);
        }   
    else if (outBase.endsWith(logSuffix))
        {
        location = outBase.lastIndexOf(logSuffix);
        if (location >= 0) outBase = outBase.substring(0, location);
        }    

    if (!saveAll || (saveAll && saveImage))
        {
        String imagePath = (saveAll ? outBase + imageSuffix : outPath) + "."+format;
        File saveFile = new File(imagePath);
        try {
            if (format.toLowerCase().equals("jpg"))
                {
                Iterator iter = ImageIO.getImageWritersByFormatName("jpeg");
                ImageWriter writer = (ImageWriter)iter.next();
                ImageWriteParam iwp = writer.getDefaultWriteParam();
                iwp.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
                iwp.setCompressionQuality(1.0f);   // an integer between 0 and 1 where 1 specifies minimum compression and maximum quality
                FileImageOutputStream output = new FileImageOutputStream(saveFile);
                writer.setOutput(output);
                IIOImage image = new IIOImage(imageDisplay, null, null);
                writer.write(null, image, iwp);
                output.close();
                writer.dispose();
                }
            else if (format.toLowerCase().equals("png"))
                {
                ImageIO.write(imageDisplay, format, saveFile);
                }
            else
                {
                IJ.error("bad image save format '"+format+"'");
                }

            }
        catch (IOException ex)
            {
            IJ.error("File Write Error", "Error writing image display to file '"+saveFile.toString()+"'");
            }
        }

    if (saveAll && (savePlot || saveConfig || saveTable))
        {
        try{
            Class MP = Class.forName("MultiPlot_");
            Method saveDataImageConfig = MP.getMethod("saveDataImageConfig", boolean.class, boolean.class, boolean.class,
                                                       boolean.class, String.class, String.class, String.class, String.class);
            saveDataImageConfig.invoke(null, savePlot, saveConfig, saveTable, true, format, outBase+plotSuffix+"."+format, outBase+configSuffix+".plotcfg",
                                                   outBase+dataSuffix+Prefs.get("options.ext", ".xls"));
            }
        catch(ClassNotFoundException e) {IJ.error("Multiplot is not running. Could not save plot image, config, and data.");}
        catch(NoSuchMethodException e) {IJ.error("Exception: java method MultiPlot_.saveDataImageConfig() not found");}
        catch(IllegalAccessException e) {IJ.error("Exception: illegal access to java method MultiPlot_.saveDataImageConfig()");}
        catch(InvocationTargetException e) {IJ.error("Exception: java method MultiPlot_.saveDataImageConfig() could not be invoked");}
        }
    if (saveAll && saveApertures)
        {
        saveApertures(outBase+aperSuffix+".apertures");
        }
    if (saveAll && saveLog)
        {
        saveLogToFile(outBase+logSuffix+".log");
        }    
    }

public void saveLogToFile(String path)
    {
    String log = IJ.getLog();
    if (log!=null)
        {
        String[] loglines = log.split("\\r?\\n|\\r");
        PrintWriter pw = null;
        try {
            FileOutputStream fos = new FileOutputStream(path);
            BufferedOutputStream bos = new BufferedOutputStream(fos);
            pw = new PrintWriter(bos);
            }
        catch (IOException e) {
            IJ.beep();
            IJ.showMessage("Error writing log file!");
            }
        for (int i=0; i<loglines.length;i++)
            {
            pw.println(loglines[i]);
            }
        pw.close();        
        }
    }

public void saveApertures(String apsPath)
        {
        File outFile = new File(apsPath);
        if (outFile == null || outFile.isDirectory())
            {
            IJ.error("bad aperture save filename");
            return;
            }
        if (outFile.isFile()) outFile.delete();
        Properties prefs = new Properties();
        Enumeration e = Prefs.ijPrefs.keys();
        while (e.hasMoreElements()) {
            String key = (String) e.nextElement();
            if (key.startsWith(".aperture.radius") || key.startsWith(".aperture.rback1") ||
                key.startsWith(".aperture.rback2") || key.startsWith(".aperture.removebackstars") ||
                key.startsWith(".aperture.backplane") || key.startsWith(".multiaperture.usevarsizeap") ||
                key.startsWith(".multiaperture.apfwhmfactor") || key.startsWith(".multiaperture.xapertures") ||
                key.startsWith(".multiaperture.yapertures") || key.startsWith(".multiaperture.isrefstar") || 
                key.startsWith(".multiaperture.naperturesmax"))
                prefs.put(key, Prefs.ijPrefs.getProperty(key));
        }
        try
            {
            FileOutputStream fos = new FileOutputStream(apsPath);
            BufferedOutputStream bos = new BufferedOutputStream(fos);
            prefs.store(bos, "AstroImageJ Saved Apertures");
            bos.close();
            }
        catch (IOException ioe)
            {
            IJ.beep();
            IJ.showMessage("Error writing apertures to file");
            }
        }

public void openApertures(String apsPath)
        {
        try {
            if (apsPath != null && !apsPath.trim().equals(""))
                {
                InputStream is = new BufferedInputStream(new FileInputStream(apsPath));
                Prefs.ijPrefs.load(is);
                is.close();
                }
            ac.clearRois();
            radius = Prefs.get("aperture.radius", radius);
            rBack1 = Prefs.get("aperture.rback1", rBack1);
            rBack2 = Prefs.get("aperture.rback2", rBack2);
            removeBackStars = Prefs.get("aperture.removebackstars", removeBackStars);
            String xapertures = Prefs.get("multiaperture.xapertures", "");
            String yapertures = Prefs.get("multiaperture.yapertures", "");
            String isRefStarString = Prefs.get("multiaperture.isrefstar", "");
            String[] xaps = xapertures.split(",");
            String[] yaps = yapertures.split(",");
            String[] isRefStar = isRefStarString.split(",");
            boolean[] isRef;
            if (xaps.length == 0 && yaps.length == 0)
                {
                IJ.beep();
                IJ.showMessage("Error: No apertures to load.");
                return;
                }
            if (xaps.length != yaps.length)
                {
                IJ.beep();
                IJ.showMessage("Error: The number of stored X and Y aperture coordinates is different. Aborting open apertures.");
                return;
                }
            double[] xap = extract(true, xaps);
            double[] yap = extract(false, yaps);
            
			if (xaps.length != isRefStar.length)
				{
                isRef = new boolean[xaps.length];
                for (int ap = 0; ap < xaps.length; ap++)
                    {
                    if (ap == 0)
                        isRef[ap] = false;
                    else
                        isRef[ap] = true;
                    }
				}
            else
                {
                isRef = extractBoolean(isRefStar);
                }            
            Prefs.set ("multiaperture.previous", true);
            GFormat g = new GFormat("4.3");
            photom.setSourceApertureRadius (radius);
            photom.setBackgroundApertureRadii (rBack1,rBack2);
            photom.setRemoveBackStars(removeBackStars);

            Photometer phot = new Photometer(imp.getCalibration());
            phot.setSourceApertureRadius (radius);
            phot.setBackgroundApertureRadii (rBack1,rBack2);
            phot.setRemoveBackStars(removeBackStars);
            phot.setMarkRemovedPixels(false);
            for (int i = 0; i<xaps.length; i++)
                {
                phot.measure(imp, xap[i], yap[i], radius, rBack1, rBack2);
                ApertureRoi roi = new ApertureRoi (xap[i],yap[i],radius,rBack1,rBack2,phot.source);
                roi.setAppearance (true,showSkyOverlay,nameOverlay,valueOverlay,!isRef[i]?new Color(196,222,155):Color.PINK,(!isRef[i]?"T":"C")+(i+1),g.format(phot.source));
                roi.setImage (imp);
                ac.add (roi);
                ac.paint(ac.getGraphics());
                }
            }
        catch (Exception e) {
            IJ.beep();
            IJ.showMessage("Error reading apertures file");
            }
        }

	/**
	 * Extracts a double array from a string array.
	 */
	protected double[] extract (boolean XnotY, String[] s)
		{
        boolean isFITS = false;
		double[] arr = new double[s.length];
        if (s.length > 0 && s[0].startsWith("FITS"))
            {
            isFITS = true;
            s[0] = s[0].substring(4);
            }
		try	{
			for (int i=0; i < arr.length; i++)
				arr[i] = Double.parseDouble(s[i]);
			}
		catch (NumberFormatException e)
			{
			arr = null;
			}
        if (isFITS)
            {
            if (XnotY)
                {
                for (int ap = 0; ap < arr.length; ap++)
                    {
                    arr[ap] -= Centroid.PIXELCENTER;
                    }
                }
            else
                {
                for (int ap = 0; ap < arr.length; ap++)
                    {
                    arr[ap] = (double)imp.getHeight() - arr[ap] + Centroid.PIXELCENTER;
                    }                
                }
            }
        
		return arr;
		}


	/**
	 * Extracts a boolean array from a string array.
	 */
	protected boolean[] extractBoolean (String[] s)
		{
		boolean[] arr = new boolean[s.length];

        for (int i=0; i < arr.length; i++)
            {
            if (s[i].equalsIgnoreCase("true"))
                arr[i] = true;
            else
                arr[i] = false;
            }

		return arr;
		}

void openDragAndDropFiles(java.io.File[] files)
        {
        if (files.length > 0 && files[0].isFile())
            {
            if (files[0].getName().endsWith(".apertures"))
                {
                try {
                    openApertures(files[0].getCanonicalPath());
                    }
                catch (Exception e) {
                    IJ.beep();
                    IJ.showMessage("Error reading aperture file");
                    }            
                }
            else if (files[0].getName().toLowerCase().endsWith(".fits") ||
                     files[0].getName().toLowerCase().endsWith(".fit") ||
                     files[0].getName().toLowerCase().endsWith(".tif") ||
                     files[0].getName().toLowerCase().endsWith(".tiff") ||
                     files[0].getName().toLowerCase().endsWith(".jpeg") ||
                     files[0].getName().toLowerCase().endsWith(".jpg") ||
                     files[0].getName().toLowerCase().endsWith(".png") ||
                     files[0].getName().toLowerCase().endsWith(".bmp") ||
                     files[0].getName().toLowerCase().endsWith(".bmp") ||
                     files[0].getName().toLowerCase().endsWith(".pgm") )
                {
                ImagePlus imp2 = null;
                try {
                    imp2 = IJ.openImage(files[0].getCanonicalPath());
                    }
                catch (Exception e) {
                    IJ.beep();
                    IJ.showMessage("Error reading image file");
                    return;
                    }                 
                if (imp2 != null && ((imp.getStackSize() == 1 && imp2.getStackSize() == 1) ||
                                     (imp.getStackSize() != 1 && imp2.getStackSize() != 1) ))
                    {
                    StackProcessor sp = new StackProcessor(imp.getStack(), imp2.getProcessor());
                    ImageStack s2 = imp2.getImageStack();
                    imp.setStack(s2);
                    imp.setFileInfo(imp2.getFileInfo());
                    copyImageProperties(imp2);
                    imp.setProcessor(imp2.getTitle(), imp2.getProcessor());
                    setAstroProcessor(false);
                    }
                }
            }
        }


// This method returns a buffered image with the contents of an image
public static BufferedImage toBufferedImage(Image image) {
    if (image instanceof BufferedImage) {
        return (BufferedImage)image;
    }

    // This code ensures that all the pixels in the image are loaded
    image = new ImageIcon(image).getImage();

    // Determine if the image has transparent pixels; for this method's
    // implementation, see Determining If an Image Has Transparent Pixels
    boolean hasAlpha = hasAlpha(image);

    // Create a buffered image with a format that's compatible with the screen
    BufferedImage bimage = null;
    GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
    try {
        // Determine the type of transparency of the new buffered image
        int transparency = Transparency.OPAQUE;
        if (hasAlpha) {
            transparency = Transparency.BITMASK;
        }

        // Create the buffered image
        GraphicsDevice gs = ge.getDefaultScreenDevice();
        GraphicsConfiguration gc = gs.getDefaultConfiguration();
        bimage = gc.createCompatibleImage(
            image.getWidth(null), image.getHeight(null), transparency);
    } catch (HeadlessException e) {
        // The system does not have a screen
    }

    if (bimage == null) {
        // Create a buffered image using the default color model
        int type = BufferedImage.TYPE_INT_RGB;
        if (hasAlpha) {
            type = BufferedImage.TYPE_INT_ARGB;
        }
        bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
    }

    // Copy image to buffered image
    Graphics g = bimage.createGraphics();

    // Paint the image onto the buffered image
    g.drawImage(image, 0, 0, null);
    g.dispose();

    return bimage;
}

// This method returns true if the specified image has transparent pixels
public static boolean hasAlpha(Image image) {
    // If buffered image, the color model is readily available
    if (image instanceof BufferedImage) {
        BufferedImage bimage = (BufferedImage)image;
        return bimage.getColorModel().hasAlpha();
    }

    // Use a pixel grabber to retrieve the image's color model;
    // grabbing a single pixel is usually sufficient
     PixelGrabber pg = new PixelGrabber(image, 0, 0, 1, 1, false);
    try {
        pg.grabPixels();
    } catch (InterruptedException e) {
    }

    // Get the image's color model
    ColorModel cm = pg.getColorModel();
    return cm.hasAlpha();
}


void setupListeners() {

//                imageWindow.removeComponentListener(this);
//                imageWindow.addComponentListener(this);
//                WindowListener[] wl = originalWindow.getWindowListeners();
//                if (wl.length>0)
//                    for (int i=0; i<wl.length; i++)
//                            imageWindow.addWindowListener(wl[i]);

        mwl = this.getMouseWheelListeners();
        if (mwl.length>0)
                for (int i=0; i<mwl.length; i++)
                        this.removeMouseWheelListener(mwl[i]);

        icmwl = ac.getMouseWheelListeners();
        if (icmwl.length>0)
                for (int i=0; i<icmwl.length; i++)
                        ac.removeMouseWheelListener(icmwl[i]);


//                mml = ac.getMouseMotionListeners();
//                if (mml.length>0)
//                        for (int i=0; i<mml.length; i++)
//                                ac.removeMouseMotionListener(mml[i]);

        ml = ac.getMouseListeners();
        if (ml.length>0)
                for (int i=0; i<ml.length; i++)
                        ac.removeMouseListener(ml[i]);

        ac.removeMouseMotionListener(this);
        ac.addMouseMotionListener(this);
        ac.removeMouseListener(this);
        ac.addMouseListener(this);
        ac.removeMouseWheelListener(this);
        ac.addMouseWheelListener(this);
        ac.addKeyListener(this);


//        FocusListener[] fl = super.getFocusListeners();
//        IJ.log("# of focus listeners = "+fl.length);
//        if (fl.length>0)
//                for (int i=0; i<fl.length; i++)
//                    super.removeFocusListener(fl[i]);
//
//
//        addFocusListener(new FocusListener(){
//            public void focusGained(FocusEvent e) {
//                IJ.log("focusGained: "+imp.getTitle());
//                WindowManager.setWindow(asw);
//            }
//            public void focusLost(FocusEvent e) {}});
//

//        this.addFocusListener(this);
        
        toolbar = Toolbar.getInstance();
        astronomyToolId = toolbar.getToolId("Astronomy_Tool");
        if (astronomyToolId != -1)
            toolbar.setTool(astronomyToolId);
        else
            astronomyToolId = -9999;
        apertureToolId = toolbar.getToolId("Aperture");
        if (apertureToolId == -1)
                apertureToolId = -9999;
        zoomToolId = Toolbar.MAGNIFIER;
        panToolId = Toolbar.HAND;
        toolbar.removeMouseListener(toolbarMouseListener);
        toolbar.addMouseListener(toolbarMouseListener);
    }


    void exitAstronomyTool() {

//        ac.removeMouseMotionListener(this);
//                ac.removeMouseWheelListener(this);

        ac.removeMouseListener(this);


//                if (mwl.length>0)
//                        for (int i=0; i<mwl.length; i++)
//                                imageWindow.addMouseWheelListener(mwl[i]);

//        if (mml.length>0)
//                for (int i=0; i<mml.length; i++)
//                        ac.removeMouseMotionListener(mml[i]);
//        if (mml.length>0)
//                for (int i=0; i<mml.length; i++)
//                        ac.addMouseMotionListener(mml[i]);

        if (ml.length>0)
                for (int i=0; i<ml.length; i++)
                        ac.removeMouseListener(ml[i]);
        if (ml.length>0)
                for (int i=0; i<ml.length; i++)
                        ac.addMouseListener(ml[i]);
        frameLocationX = this.getLocation().x;
        frameLocationY = this.getLocation().y;
//        apertureOverlay.clear();
        ac.setAstronomyMode(false);
        ac.paint(ac.getGraphics());
        savePrefs();
        astronomyMode = false;
        imp.unlock();
        };

    void reenterAstronomyTool()  {

//        ac.addMouseMotionListener(this);
        ac.removeMouseListener(this);
        ac.addMouseListener(this);

//        if (mml.length>0)
//                for (int i=0; i<mml.length; i++)
//                        ac.removeMouseMotionListener(mml[i]);
        if (ml.length>0)
                for (int i=0; i<ml.length; i++)
                        ac.removeMouseListener(ml[i]);
        astronomyMode = true;
        radius = Prefs.get("aperture.radius", radius);
		rBack1 = Prefs.get("aperture.rback1",rBack1);
		rBack2 = Prefs.get("aperture.rback2",rBack2);
        reposition = Prefs.get ("aperture.reposition", reposition);
        buttonCentroid.setSelected(reposition);
        removeBackStars = Prefs.get("aperture.removebackstars", removeBackStars);
        removeBackStarsCB.setState(removeBackStars);
        photom.setSourceApertureRadius (radius);
        photom.setBackgroundApertureRadii (rBack1,rBack2);
        photom.setRemoveBackStars(removeBackStars);
        ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
//        apertureOverlay.clear();
        ac.setMouseInImage(false);
        ac.setAstronomyMode(true);
        ac.paint(ac.getGraphics()); 
        }

//	public void focusGained(FocusEvent e) {
//		WindowManager.setWindow(this);
//
//        if(IJ.isMacOSX())
//            {
//            IJ.wait(1);
//            setMenuBar(mainMenuBar);
//            }
//        IJ.log("focus gained");
//
//	}
//
//	public void focusLost(FocusEvent e) {}


    MouseListener toolbarMouseListener = new MouseListener() {
                public void mousePressed(MouseEvent e) {
                    IJ.wait(250);
                    currentToolId = toolbar.getToolId();
                    if (currentToolId == astronomyToolId ||
                        currentToolId == zoomToolId ||
                        currentToolId == apertureToolId ||
                        currentToolId == panToolId)
                        {
                        reenterAstronomyTool();
                        }
                    else
                        {
                        exitAstronomyTool();
                        }
                    }

                public void mouseReleased(MouseEvent e) { }

                public void mouseEntered(MouseEvent e) { }

                public void mouseExited(MouseEvent e) { }

                public void mouseClicked(MouseEvent e) { } };


        public void setAutoLevels(String windowName) {

//            if (windowName == null)
//                imp = WindowManager.getImage(impTitle);
//            else
//                imp = WindowManager.getImage(windowName);

            getStatistics();
            
            if (imp.getType()==ImagePlus.COLOR_RGB)
                {
                min = Math.max(stats.mean - autoScaleFactorLowRGB*stats.stdDev, minValue);
                max = Math.min(stats.mean + autoScaleFactorHighRGB*stats.stdDev, maxValue);
                }
            else
                {
                min = Math.max(stats.mean - autoScaleFactorLow*stats.stdDev, minValue);
                max = Math.min(stats.mean + autoScaleFactorHigh*stats.stdDev, maxValue);
                }

            updatePanelValues();
            setImageEdges();
            savedMin = min;
            savedMax = max;
            Prefs.set("Astronomy_Tool.savedMin", savedMin);
            Prefs.set("Astronomy_Tool.savedMax", savedMax);

            radius = Prefs.get("aperture.radius", radius);
            rBack1 = Prefs.get("aperture.rback1", rBack1);
            rBack2 = Prefs.get("aperture.rback2", rBack2);
            photom.setSourceApertureRadius (radius);
            photom.setBackgroundApertureRadii (rBack1,rBack2);
            photom.setRemoveBackStars(removeBackStars);
            ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
            }

    protected void getStatistics()
            {
            Roi roi = imp.getRoi();
            imp.killRoi();
            if (imp.getType()==ImagePlus.COLOR_RGB)
                {
                ImageProcessor ip = imp.getProcessor();
                ip.reset();
                }
            stats = imp.getStatistics(ImageStatistics.MEAN+ImageStatistics.MIN_MAX+ImageStatistics.STD_DEV);
            imp.setRoi(roi);
            }

     protected void getBiSliderStatistics()
            {
            Roi roi = imp.getRoi();
            imp.killRoi();
            if (imp.getType()==ImagePlus.COLOR_RGB)
                {
                ImageProcessor ip = imp.getProcessor();
                ip.reset();
                }
            stats = imp.getStatistics((ImageStatistics.MEAN+ImageStatistics.MIN_MAX+
                                           ImageStatistics.STD_DEV), BISLISER_SEGMENTS,
                                           minValue, maxValue);
            imp.setRoi(roi);
            }

    public void setAstroProcessor(boolean adjustImage ) {

            ImageProcessor ip = imp.getProcessor();
            if (imp.getType()==ImagePlus.COLOR_RGB)
                {
                ip.snapshot();
                }
            impTitle = imp.getTitle();
            this.setTitle(impTitle);
            stackSize = imp.getStackSize();
            
            wcs = new WCS(imp);
            goodWCS = wcs.hasWCS();
            ac.setWCS(wcs); 
            ac.setShowPixelScale(showScaleX, showScaleY, pixelScaleX, pixelScaleY);
            
            getStatistics();
            if (imp.getType() == ImagePlus.COLOR_256 || imp.getType() == ImagePlus.COLOR_RGB || imp.getType() == ImagePlus.GRAY8)
                {
                useFixedMinMaxValues = false;
                useFixedMinMaxValuesCB.setState(false);
                minValue = 0;
                maxValue = 255;
                }
            else
                {
                maxValue = useFixedMinMaxValues ? fixedMaxValue : (startupPrevLevels ? Math.max(max, stats.max) : stats.max);
                minValue = useFixedMinMaxValues ? fixedMinValue : (startupPrevLevels ? Math.min(min, stats.min) : stats.min);
                if (imp.getType() == ImagePlus.GRAY16 && maxValue - minValue < 256)
                     maxValue = minValue + 255;
                }

            if (startupAutoLevel)
                {
                if (imp.getType()==ImagePlus.COLOR_RGB)
                    {
                    min = Math.max(stats.mean - autoScaleFactorLowRGB*stats.stdDev, minValue);
                    max = Math.min(stats.mean + autoScaleFactorHighRGB*stats.stdDev, maxValue);
                    }
                else
                    {
                    min = Math.max(stats.mean - autoScaleFactorLow*stats.stdDev, minValue);
                    max = Math.min(stats.mean + autoScaleFactorHigh*stats.stdDev, maxValue);
                    }
                }
            else if (!startupPrevLevels && !startupPrevLevelsPerSlice)
                {
                min = minValue;
                max = maxValue;
                }
            double[] oldSliceMin = sliceMin;
            double[] oldSliceMax = sliceMax;
            sliceMin = new double[stackSize];
            sliceMax = new double[stackSize];
            for (int i = 0; i < stackSize; i++)
                {
                sliceMin[i] = i < oldSliceMin.length ? oldSliceMin[i] : min;
                sliceMax[i] = i < oldSliceMax.length ? oldSliceMax[i] : max;
                }  

//            infoTextField.setText(""+super.createSubtitle());
            if (useInvertingLut != ip.isInvertedLut() && !ip.isColorLut())
                ip.invertLut();
            layoutContainer(this);
            ac.updateZoomBoxParameters();
            updatePanelValues();
            setImageEdges();
            radius = Prefs.get("aperture.radius", radius);
            rBack1 = Prefs.get("aperture.rback1", rBack1);
            rBack2 = Prefs.get("aperture.rback2", rBack2);
            photom = new Photometer (imp.getCalibration());
            photom.setSourceApertureRadius (radius);
            photom.setBackgroundApertureRadii (rBack1,rBack2);
            photom.setRemoveBackStars(removeBackStars);
            ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
            double value = ip.getPixelValue((int)lastImageX, (int)lastImageY);
            valueTextField.setText(fourPlaces.format(value));
            photom.setMarkRemovedPixels(false);
            photom.measure (imp,lastImageX,lastImageY);
            if (showMeanNotPeak)
                {
                peakLabel.setText("Mean:");
                peakTextField.setText(fourPlaces.format(photom.meanBrightness()));                
                }
            else
                {
                peakLabel.setText("Peak:");
                peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                }
            lengthLabel.setText("Int Cnts:");
            lengthTextField.setText(fourPlaces.format(photom.sourceBrightness()));

            }
    
    public void setUpdatesEnabled(boolean enabled)
        {
        updatesEnabled = enabled;
        }

    void updatePanelValues()
            {
            if (updatesEnabled)
                {
                ImageProcessor ip = imp.getProcessor();

                getBiSliderStatistics();

                if (startupPrevLevelsPerSlice)
                    {
                    if (!autoScaleIconClicked)
                        {
                        min = sliceMin[imp.getCurrentSlice()-1];
                        max = sliceMax[imp.getCurrentSlice()-1];
                        }
                    else
                        {
                        sliceMin[imp.getCurrentSlice()-1] = min;
                        sliceMax[imp.getCurrentSlice()-1] = max;
                        }
                    }
                autoScaleIconClicked = false;
                
                if (startupPrevLevels)
                    {
                    if (max < min) max = min;
                    if (min < minValue) minValue = min;
                    if (max > maxValue) maxValue = max;
                    }
                else
                    {
                    if (min < minValue) min = minValue;
                    if (min > maxValue) min = maxValue;
                    if (max > maxValue) max = maxValue;
                    if (max < min) max = min;
                    }

                histogram = stats.histogram;

                for (int i=0; i<histogram.length; i++)
                    {
                    if (histogram[i] <= 1)
                        logHistogram[i] = 0;
                    else
                        logHistogram[i] = Math.log(histogram[i]);
                    if (logHistogram[i] > histMax)
                        histMax = logHistogram[i];
                    }

                minMaxBiSlider.setParameters(BiSlider.RGB, false,
                                            ((maxValue - minValue)/(double)BISLISER_SEGMENTS),
                                            Color.BLACK, Color.BLACK, minValue, maxValue, min, max);

                minValueTextField.setText(""+fourPlaces.format(minValue));
                maxValueTextField.setText(""+fourPlaces.format(maxValue));

                minTextField.setText(""+fourPlaces.format(min));
                maxTextField.setText(""+fourPlaces.format(max));

                meanTextField.setText(""+fourPlaces.format(stats.mean));
                valueTextField.setText(""+fourPlaces.format(ip.getPixelValue((int)lastImageX, (int)lastImageY)));

                imp.setDisplayRange(min, max);
                minMaxChanged = true;
                imp.updateAndDraw();
                }
            }
    
    @Override
	public Rectangle getMaximumBounds() {
		double width = imp.getWidth();
		double height = imp.getHeight();
		double iAspectRatio = width/height;
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		Rectangle maxWindow = ge.getMaximumWindowBounds();
//		maxWindowBounds = maxWindow;
//		if (iAspectRatio/((double)maxWindow.width/maxWindow.height)>0.75) {
//			maxWindow.y += 22;  // uncover ImageJ menu bar
//			maxWindow.height -= 22;
//		}
//		Dimension extraSize = getExtraSize();
//		double maxWidth = maxWindow.width-extraSize.width;
//		double maxHeight = maxWindow.height-extraSize.height;
//		double mAspectRatio = maxWidth/maxHeight;
//		int wWidth, wHeight;
//		double mag;
//		if (iAspectRatio>=mAspectRatio) {
//			mag = maxWidth/width;
//			wWidth = maxWindow.width;
//			wHeight = (int)(height*mag+extraSize.height);
//		} else {
//			mag = maxHeight/height;
//			wHeight = maxWindow.height;
//			wWidth = (int)(width*mag+extraSize.width);
//		}
//		int xloc = (int)(maxWidth-wWidth)/2;
//		if (xloc<0) xloc = 0;
		return maxWindow;
	}        
    
    
        @Override
        public void maximize() {
            if (updatesEnabled)
                {
                fillNotFit = true;
                fitImageToCanvas();
                validate();
                repaint();
                imp.updateAndDraw();
                }
        }
        
    @Override
    public void minimize() {
//        IJ.log("minimize");
//		srcRect = new Rectangle(0, 0, imageWidth, imageHeight);
//		ac.setDrawingSize(canWidthBeforeMaximize, canWidthBeforeMaximize);
//		ac.setMagnification(magbefore);
//        setSize(winWidthBeforeMaximize,winWidthBeforeMaximize);
//        ac.setMaxBounds();
		pack();
//		ac.setMaxBounds();
		repaint();      
//        setSize(winWidthBeforeMaximize, winHeightBeforeMaximize);
//        fillNotFit =true;
//        fitImageToCanvas();
//		if (unzoomWhenMinimizing)
//			ic.unzoom();
//		unzoomWhenMinimizing = true;
        }

//        @Override
//        protected Rectangle getMaxWindow(int xloc, int yloc) {
//            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
//            Rectangle bounds = ge.getMaximumWindowBounds();
//
//            if (xloc>bounds.x+bounds.width || yloc>bounds.y+bounds.height || xloc<0 || yloc<0) {
//                Rectangle bounds2 = getSecondaryMonitorBounds(ge, xloc, yloc);
//                if (bounds2!=null) return bounds2;
//            }
//            Dimension ijSize = ij!=null?ij.getSize():new Dimension(0,0);
//            if (bounds.height>600) {
//                bounds.y += ijSize.height;
//                bounds.height -= ijSize.height;
//            }
//            return bounds;
//        }

    /** LAYOUT MANAGER METHODS **/

    /** Not used by this class. */
    public void addLayoutComponent(String name, Component comp) {
    }

    /** Not used by this class. */
    public void removeLayoutComponent(Component comp) {
    }

    /** Returns the preferred dimensions for this layout. */
    public Dimension preferredLayoutSize(Container target) {
		Dimension dim = new Dimension((int)newCanvasWidth(),(int)(this.getHeight()-56));

//		int nmembers = target.getComponentCount();
//		for (int i=0; i<nmembers; i++) {
//		    Component m = target.getComponent(i);
//			Dimension d = m.getPreferredSize();
//			dim.width = Math.max(dim.width, d.width);
//			if (i>0) dim.height += vgap;
//			dim.height += d.height;
//		}
//		Insets insets = target.getInsets();
//		dim.width += insets.left + insets.right + hgap*2;
//		dim.height += insets.top + insets.bottom + vgap*2;
        if (!redrawing )
            {
            ac.setDrawingSize((int)newCanvasWidth(), (int)newCanvasHeight());
            }

		return dim;
    }

    /** Returns the minimum dimensions for this layout. */
    public Dimension minimumLayoutSize(Container target) {
		return preferredLayoutSize(target);
//        return new Dimension(500, 500);
    }

    /** Centers the elements in the specified column, if there is any slack.*/
    private void moveComponents(Container target, int x, int y, int width, int height, int nmembers) {
//       IJ.log("moveComponents executed");
//    	int x2 = 0;
//	    y += height / 2;
//		for (int i=0; i<nmembers; i++) {
//		    Component m = target.getComponent(i);
//		    Dimension d = m.getSize();
//		    if (i==0 || d.height>60)
//		    	x2 = x + (width - d.width)/2;
//			m.setLocation(x2, y);
//			y += vgap + d.height;
//		}
    }

    /** Lays out the container and calls ImageCanvas.resizeCanvas()
		to adjust the image canvas size as needed. */
    @Override
    public void layoutContainer(Container target) {
        if (!redrawing)
            {
            redrawing = true;
//		Insets insets = target.getInsets();
//		int nmembers = target.getComponentCount();
//		Dimension d;
//		int extraHeight = 0;
//		for (int i=1; i<nmembers; i++) {
//			Component m = target.getComponent(i);
//			d = m.getPreferredSize();
//			extraHeight += d.height;
//		}
//
//		d = target.getSize();
//		int preferredImageWidth = d.width - (insets.left + insets.right + hgap*2);
//		int preferredImageHeight = d.height - (insets.top + insets.bottom + vgap*2 + extraHeight);
//
//		resizeCanvas ((int)(imageWindow.getWidth() - 26), (int)(imageWindow.getHeight()-56-otherPanelsHeight-stackSliders.length*18));//(preferredImageWidth, preferredImageHeight);

//		int maxwidth = d.width - (insets.left + insets.right + hgap*2);
//		int maxheight = d.height - (insets.top + insets.bottom + vgap*2);
//		Dimension psize = preferredLayoutSize(target);
//		int x =  hgap + (d.width - psize.width)/2; //insets.left + hgap + (d.width - psize.width)/2;
//		int y = 0;
//		int colw = 0;

//		for (int i=0; i<nmembers; i++) {
//			Component m = target.getComponent(0);
//			Dimension d = m.getPreferredSize();
//			if ((m instanceof ScrollbarWithLabel) || (m instanceof Scrollbar)) {
//				int scrollbarWidth = target.getComponent(0).getPreferredSize().width;
//				Dimension minSize = m.getMinimumSize();
//				if (scrollbarWidth<minSize.width) scrollbarWidth = minSize.width;
//				m.setSize(scrollbarWidth, d.height);
//			} else
//				m.setSize(d.width, d.height);
//			if (y > 0) y += vgap;
//			y += d.height;
//			colw = Math.max(colw, d.width);
//		}
//		moveComponents(target, x, insets.top + vgap, colw, maxheight - y, nmembers);

//        else
//            {
            Dimension psize = preferredLayoutSize(target);
            Component m = target.getComponent(0);
            Dimension d = m.getPreferredSize();
            m.setSize(d.width, d.height);

//            }
            int newCanvasWidth = newCanvasWidth();
            int newCanvasHeight = newCanvasHeight();
            ac.setDrawingSize(newCanvasWidth, newCanvasHeight);
            Rectangle r = new Rectangle(ac.getSrcRect());
//            double xmag = (double)newCanvasWidth/(double)(ac.getSrcRect().width);
//            double ymag = (double)newCanvasHeight/(double)(ac.getSrcRect().height);
//            if (IJ.altKeyDown() || (r.x <= 12 && r.y <= 12 && r.x+r.width > imp.getWidth()- 12 && r.x+r.height>imp.getHeight() - 12))
            if (IJ.altKeyDown() || (imp.getWidth()*ac.getMagnification()<newCanvasWidth || imp.getHeight()*ac.getMagnification()<newCanvasHeight))
                {
                double xmag = (double)newCanvasWidth/(double)(imp.getWidth());
                double ymag = (double)newCanvasHeight/(double)(imp.getHeight());
                ac.setMagnification(Math.min(xmag,ymag));
                int xStart = (int)(imp.getWidth()/2.0 - newCanvasWidth/(ac.getMagnification()*2.0));
                int yStart = (int)(imp.getHeight()/2.0 - newCanvasHeight/(ac.getMagnification()*2.0));
                r.x = xStart;//Math.abs(xStart)<3?0:xStart;
                r.y = yStart;//Math.abs(yStart)<3?0:yStart;
                }

            magnification = ac.getMagnification();
            
            r.width = (int)((double)(newCanvasWidth()+2)/magnification);
            r.height = (int)((double)(newCanvasHeight()+2)/magnification);
            ac.setSourceRect(r);
            
//            imageWindow = imp.getWindow();
//            ac = OverlayCanvas.getOverlayCanvas(imp);
            dstWidth = ac.getWidth();
            dstHeight = ac.getHeight();
            magnification = ac.getMagnification();
            srcRect = ac.getSrcRect();
//            maxBounds = imageWindow.getMaximumBounds();
//            imageWindow.setMaximizedBounds(new Rectangle (1000, 500));
            imageWidth = imp.getWidth();
            imageHeight = imp.getHeight();
            oldICWidth = this.getWidth();
            oldICHeight = this.getHeight();

            winWidth = this.getWidth();
            winHeight = this.getHeight();

            srcRect = ac.getSrcRect();
            savedPanX = srcRect.x;
            savedPanY = srcRect.y;
            savedPanHeight = srcRect.height;
            savedPanWidth = srcRect.width;
            savedMag = magnification;
            savedICWidth = newCanvasWidth();
            savedICHeight = newCanvasHeight();
            savedIpWidth = imp.getWidth();
            savedIpHeight = imp.getHeight();
            Prefs.set("Astronomy_Tool.savedPanX", savedPanX);
            Prefs.set("Astronomy_Tool.savedPanY", savedPanY);
            Prefs.set("Astronomy_Tool.savedPanHeight", savedPanHeight);
            Prefs.set("Astronomy_Tool.savedPanWidth", savedPanWidth);
            Prefs.set("Astronomy_Tool.savedMag", savedMag);
            Prefs.set("Astronomy_Tool.savedICWidth", savedICWidth);
            Prefs.set("Astronomy_Tool.savedICHeight", savedICHeight);
            Prefs.set("Astronomy_Tool.savedIpWidth", savedIpWidth);
            Prefs.set("Astronomy_Tool.savedIpHeight", savedIpHeight);
            setImageEdges();
            redrawing = false;
        }
    }

//	void setMaxBounds() {
//        IJ.log("setMaxBounds");
//        imageWindow.setMaximizedBounds(new Rectangle (500, 1000));
////		if (maxBoundsReset) {
////			maxBoundsReset = false;
////			imageWindow = imp.getWindow();
////			if (imageWindow!=null && !IJ.isLinux() && maxBounds!=null) {
////				imageWindow.setMaximizedBounds(maxBounds);
////				setMaxBoundsTime = System.currentTimeMillis();
////			}
////		}
//	}
//
//	void resetMaxBounds() {
//        IJ.log("resetMaxBounds");
//		imageWindow = imp.getWindow();
//		if (imageWindow!=null && (System.currentTimeMillis()-setMaxBoundsTime)>500L) {
//			imageWindow.setMaximizedBounds(maxBounds);
//			maxBoundsReset = true;
//		}
//	}
//
//
//	/** Enlarge the canvas if the user enlarges the window. */
//	void resizeCanvas(int width, int height) {
//        IJ.log("resize canvas");
//        ac.setDrawingSize(newCanvasWidth(), newCanvasHeight());
//        double xmag = (double)newCanvasWidth()/(double)(ac.getSrcRect().width);
//        double ymag = (double)newCanvasHeight()/(double)(ac.getSrcRect().height);
//        ac.setMagnification(Math.max(xmag,ymag));
//
//
//		imageWindow = imp.getWindow();
//        ac = OverlayCanvas.getOverlayCanvas(imp);
//        dstWidth = ac.getWidth();
//        dstHeight = ac.getHeight();
//        magnification = ac.getMagnification();
//        srcRect = ac.getSrcRect();
//        maxBounds = imageWindow.getMaximumBounds();
//
//        imageWidth = imp.getWidth();
//        imageHeight = imp.getHeight();
//
////		IJ.log("resizeCanvas: "+srcRect+" "+imageWidth+"  "+imageHeight+" "+width+"  "+height+" "+dstWidth+"  "+dstHeight+" "+win.maxBounds);
//		if (!maxBoundsReset&& (width>dstWidth||height>dstHeight)&&imageWindow!=null&&maxBounds!=null&&width!=maxBounds.width-10) {
//			if (resetMaxBoundsCount!=0)
//				resetMaxBounds(); // Works around problem that prevented window from being larger than maximized size
//			resetMaxBoundsCount++;
//        }
//
////		if (IJ.altKeyDown())
////			{fitToWindow(); return;}
////		if (srcRect.width<imageWidth || srcRect.height<imageHeight) {
////			if (width>imageWidth*magnification)
////				width = (int)(imageWidth*magnification);
////			if (height>imageHeight*magnification)
////				height = (int)(imageHeight*magnification);
////			ac.setDrawingSize(width, height);
////			srcRect.width = (int)(dstWidth/magnification);
////			srcRect.height = (int)(dstHeight/magnification);
////			if ((srcRect.x+srcRect.width)>imageWidth)
////				srcRect.x = imageWidth-srcRect.width;
////			if ((srcRect.y+srcRect.height)>imageHeight)
////				srcRect.y = imageHeight-srcRect.height;
////			ac.repaint();
//		}
        
//        winWidth = imageWindow.getWidth();
//        winHeight = imageWindow.getHeight();
//
//        IJ.log(""+oldWidth +" "+ winWidth +" "+ oldHeight +" "+ winHeight);
//
//        ac.setSize((int)(winWidth - 26), (int)(winHeight-otherPanelsHeight-stackSliders.length*18));
//        ac.setDrawingSize((int)(winWidth - 26), (int)(winHeight-otherPanelsHeight-stackSliders.length*18));
//        ac.setBounds(10, 50, (int)(winWidth - 26), (int)(winHeight-otherPanelsHeight-stackSliders.length*18));
//        ac.setMagnification(ac.getMagnification()*(double)winHeight/(double)oldHeight);
//        SpringUtil.makeCompactGrid (mainPanel, 5 + stackSliders.length, 1, 0,0,0,0);
//        ac.validate();
//        topPanelAL.validate();
//        topPanelAC.validate();
//        topPanelAR.validate();
//        topPanelBL.validate();
//        topPanelBC.validate();
//        topPanelBR.validate();
//        topPanelA.validate();
//        topPanelB.validate();
//        bottomPanelA.validate();
//        bottomPanelB.validate();
//        mainPanel.validate();

 //       mainPanel.repaint();

//        ac = OverlayCanvas.getOverlayCanvas(imp);
//        icHeight = ac.getHeight();
//        icWidth = ac.getWidth();
//		//IJ.log("resizeCanvas2: "+srcRect+" "+dstWidth+"  "+dstHeight+" "+width+"  "+height);
//	}



    /** Handle the key typed event from the text field. */
    public void keyTyped(KeyEvent e) {

    }

    /** Handle the key-pressed event from the text field. */
    public void keyPressed(KeyEvent e) {
        int keyCode = e.getKeyCode();

        if(keyCode == KeyEvent.VK_TAB)
            {
            shiftAndControlWasDown = true;
            IJ.setTool(0);
            exitAstronomyTool();
            }
        if (e.isShiftDown() && keyCode == KeyEvent.VK_UP)
            zoomIn(startDragScreenX, startDragScreenY, true, true, 8.0);
        else if (e.isShiftDown() && keyCode == KeyEvent.VK_DOWN)
            {
            if ((e.getModifiers()& e.ALT_MASK) != 0 )
                fillNotFit =true;
            fitImageToCanvas();
            }
        else if(keyCode == '+' || keyCode == '=' || keyCode == KeyEvent.VK_UP)
            zoomIn(startDragScreenX, startDragScreenY, true, true, 0.0);

        else if(keyCode == '-' || keyCode == '_' || keyCode == KeyEvent.VK_DOWN)
            zoomOut(startDragScreenX, startDragScreenY, true, true);

        }

    /** Handle the key-released event from the text field. */
    public void keyReleased(KeyEvent e) {
        int keyCode = e.getKeyCode();
        if(keyCode == KeyEvent.VK_TAB)
            {
            shiftAndControlWasDown = false;
            IJ.setTool(astronomyToolId);
            reenterAstronomyTool();
            }
    }




        public void mouseClicked(MouseEvent e) {

                // mouse clicked code is in mouseReleased() to allow drag/click thresholding
                IJ.setInputEvent(e);
                }

        public void mousePressed(MouseEvent e) {
                startDragScreenX = e.getX();
                startDragScreenY = e.getY();
                ac.setMousePosition(startDragScreenX, startDragScreenY);
                startDragX = ac.offScreenX(startDragScreenX);
                startDragY = ac.offScreenY(startDragScreenY);
                lastScreenX = startDragScreenX;  //update in mouseDragged during drag
                lastScreenY = startDragScreenY;  //update in mouseDragged during drag
                startDragSubImageX =ac.getSrcRect().x;
                startDragSubImageY =ac.getSrcRect().y;
                button2Drag = false;
                IJ.setInputEvent(e);
                newClick = true;
                if((e.getModifiers() & MouseEvent.BUTTON2_MASK) != 0)
                    {
                    if (e.getClickCount() == 1)
                        {
                        imp.killRoi();
                        }
                    else
                        {
                        IJ.runPlugIn("Clear_Overlay", "");
                        }
                    }

                if (goodWCS)
                    {
                    xy[0]= startDragX;
                    xy[1]= startDragY;
                    startRadec = wcs.pixels2wcs (xy);
                    }
                }

        
        public void mouseReleased(MouseEvent e) {
                int screenX = e.getX();
                int screenY = e.getY();
                ac.xClicked = e.getX();
                ac.yClicked = e.getY();
                ac.setMousePosition(screenX, screenY);
                double imageX = ac.offScreenXD(screenX);
                double imageY = ac.offScreenYD(screenY);
                ImageProcessor ip = imp.getProcessor();
                IJ.setInputEvent(e);
                if ((((e.getModifiers() & MouseEvent.BUTTON2_MASK) != 0) && button2Drag) ||
                        (((e.getModifiers() & MouseEvent.BUTTON3_MASK) != 0) && button2Drag && e.isControlDown()))
                        {                                // measure distance and report in Results Table
                        button2Drag = false;
                        double value = ip.getPixelValue((int)imageX, (int)imageY);
                        String lab;
                        if (goodWCS)
                                {
                                xy[0]= imageX;
                                xy[1]= imageY;
                                radec = wcs.pixels2wcs (xy);
                                updateWCS(DRAGGING);
                                }
                        updateXYValue(imageX, imageY, value, DRAGGING);
                        if (writeMiddleDragValues)
                                updateResultsTable(imageX, imageY, value, DRAGGING);
                        }

                if (Math.abs(screenX-startDragScreenX) + Math.abs(screenY-startDragScreenY) < 4.0)    //check mouse click/drag threshold
                        {
                        if (e.getClickCount() > 1 && e.getButton() == MouseEvent.BUTTON3 && !e.isControlDown() && currentToolId != zoomToolId)
                            {
                            if (IJ.altKeyDown() || e.getClickCount() == 2)
                                fillNotFit = true;
                            fitImageToCanvas();
                            }
                        else if (e.getClickCount() > 1 && e.getButton() == MouseEvent.BUTTON1 && !e.isControlDown() && currentToolId != zoomToolId)
                            {
                            zoomIn(startDragScreenX, startDragScreenY, true, false, 10.0);
                            }
                        else
                            {
                            if (e.getButton() == MouseEvent.BUTTON1)                          //left mouse click
                                    {
                                    if ((e.isControlDown() && !e.isShiftDown()) || currentToolId == zoomToolId)
                                        zoomControl(e.getX(), e.getY(), -1, MOUSECLICK);
                                    else if((e.isShiftDown() || currentToolId == apertureToolId)&&!shiftClickDisabled)
                                        {
//                                        imp.setRoi(new OvalRoi((int)(imageX-radius+0.5), (int)(imageY-radius+0.5), (int)(radius*2.0), (int)(radius*2.0)));
                                        IJ.runPlugIn(imp, "Aperture_", "");
                                        validate();
                                        }
                                    }

                            else if (e.getButton() == MouseEvent.BUTTON2)                     //middle mouse click
                                    {
                                    double value = ip.getPixelValue((int)imageX, (int)imageY);
                                    String lab;
                                    if (goodWCS)
                                            {
                                            xy[0]= imageX;
                                            xy[1]= imageY;
                                            radec = wcs.pixels2wcs (xy);
                                            updateWCS(NOT_DRAGGING);
                                            }
                                    updateXYValue(imageX, imageY, value, NOT_DRAGGING);
                                    if (writeMiddleClickValues)
                                            updateResultsTable(imageX, imageY, value, NOT_DRAGGING);
                                    if (middleClickCenter)
                                            {
                                            zoomControl(screenX, screenY, 0, MOUSECLICK);
                                            try
                                                {
                                                defaultScreenBounds = defaultScreen.getDefaultConfiguration().getBounds();   
                                                Robot robot = new Robot();     //move mouse pointer to new position on screen
                                                robot.mouseMove(ac.getLocationOnScreen().x + ac.getWidth()/2 - defaultScreenBounds.x,
                                                                ac.getLocationOnScreen().y + ac.getHeight()/2 - defaultScreenBounds.y);
                                                                // Robot takes coordinates relative to the primary screen
                                                                //GraphicsEnvironment localGfxEnvironment = GraphicsEnvironment.getLocalGraphicsEnvironment();
                                                                //GraphicsDevice defaultScreen = localGfxEnvironment.getDefaultScreenDevice();
                                                                //Rectangle defaultScreenBounds = defaultScreen.getDefaultConfiguration().getBounds();
                                                                //robot.mouseMove(newX - defaultScreenBounds.x, newY - defaultScreenBounds.y);                                                     
                                                }
                                            catch (AWTException ee) { }
                                            }
                                    }

                            else if (e.getButton() == MouseEvent.BUTTON3)    //right mouse click
                                    {
                                    if ((e.isControlDown() && !e.isShiftDown()) || currentToolId == zoomToolId)
                                            zoomControl(screenX, screenY, 1, MOUSECLICK);
                                    }
                            }
                        }
                ac.repaint();
                startDragScreenX = screenX;
                startDragScreenY = screenY;
                }

        public void mouseEntered(MouseEvent e)
            {
//            apertureOverlay.clear();
            reposition = Prefs.get ("aperture.reposition", reposition);
            buttonCentroid.setSelected(reposition);
            showSkyOverlay = Prefs.get ("aperture.skyoverlay", showSkyOverlay);
            buttonShowSky.setSelected(showSkyOverlay);
            nameOverlay = Prefs.get ("aperture.nameoverlay", nameOverlay);
            buttonSourceID.setSelected(nameOverlay);
            valueOverlay = Prefs.get ("aperture.valueoverlay", valueOverlay);
            buttonSourceCounts.setSelected(valueOverlay);
            radius = Prefs.get("aperture.radius", radius);
            rBack1 = Prefs.get("aperture.rback1",rBack1);
            rBack2 = Prefs.get("aperture.rback2",rBack2);
            ac.setAperture(radius,rBack1,rBack2,showSkyOverlay,showPhotometer);
            photom.setSourceApertureRadius(radius);
            photom.setBackgroundApertureRadii(rBack1, rBack2);
            removeBackStars = Prefs.get("aperture.removebackstars", removeBackStars);
            removeBackStarsCB.setState(removeBackStars);            
//            if (OverlayCanvas.hasOverlayCanvas(imp))     //UPDATES ALL APERTURES WITH NEW SETTINGS, AS CODED HERE, IT CAUSES MULTI-APERTURE
//                {                                        //APERTURES TO INAPPROPRIATELY RESIZE WHEN MOUSE CURSOR REENTERS IMAGE
//                                                         //MAYBE FIX THE ISSUE BY ADDING A MULTI-APERTURE SOURCE ID TO EACH APERTUREROI?            
//                OverlayCanvas oc = OverlayCanvas.getOverlayCanvas(imp);
//                Roi[] rois = oc.getRois();
//                for (int i=0; i<rois.length; i++)
//                    {
//                    if (rois[i] instanceof astroj.ApertureRoi)
//                        {
//                        astroj.ApertureRoi aroi = (astroj.ApertureRoi)rois[i];
//                        aroi.setSize(radius, rBack1, rBack2);
//                        aroi.setShowSky(showSkyOverlay);
//                        aroi.setShowName(nameOverlay);
//                        aroi.setShowValue(valueOverlay);
//                        }
//                    }
//                }
            ac.paint(ac.getGraphics());
            }

        public void mouseExited(MouseEvent e) 
            {
//            apertureOverlay.clear();
            ac.setMouseInImage(false);
            ac.paint(ac.getGraphics());
            }

        public void mouseMoved(MouseEvent e) {

                ac.setMousePosition(e.getX(),e.getY());
                screenX = e.getX();
                screenY = e.getY();
                double imageX = ac.offScreenXD(e.getX());
                double imageY = ac.offScreenYD(e.getY());
                ImageProcessor ip = imp.getProcessor();
                lastImageX = imageX;
                lastImageY = imageY;

                double value = ip.getPixelValue((int)imageX, (int)imageY);
                String lab;
                xy[0]= imageX;
                xy[1]= imageY;
                photom.measure (imp,imageX,imageY);
                IJ.setInputEvent(e);
                if (showPhotometer)// != e.isShiftDown())
                    {
                    if (lastImageX > imageEdgeX1 && lastImageX < imageEdgeX2 &&     //needed when image is zoomed out
                        lastImageY > imageEdgeY1 && lastImageY < imageEdgeY2)       //to be smaller than canvas
                        {
                        ac.setMouseInImage(true);
                        ac.paint(ac.getGraphics());
//                        updatePhotometerOverlay();
                        }
                    else
                        {
                        ac.setMouseInImage(false);
//                        apertureOverlay.clear();
                        ac.paint(ac.getGraphics());
                        }
                    }
//                else if (prevShiftDownState != e.isShiftDown())
//                    {
//                    apertureOverlay.clear();
//                    ac.repaint();
//                    }

                if (goodWCS)
                        {
                        radec = wcs.pixels2wcs (xy);
                        lab = "   "+hms(radec[0]/15.0, 3)+", ";
                        if (radec[1] > 0.0)
                                lab += "+"+hms(radec[1], 2);
                        else
                                lab += hms(radec[1], 2);
                        updateWCS(NOT_DRAGGING);

                        }
                else
                        {
                        lab = "";
//                        peakLabel.setText("Peak:");
//                        peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                        }
                updateXYValue(imageX, imageY, value, NOT_DRAGGING);
//                prevShiftDownState = e.isShiftDown();
                prevImageX = lastImageX;
                prevImageY = lastImageY;
                }

        public void mouseDragged(MouseEvent e) {
                int screenX = e.getX();
                int screenY = e.getY();
                ac.setMousePosition(screenX, screenY);
                int imageX = ac.offScreenX(screenX);
                int imageY = ac.offScreenY(screenY);
                ImageProcessor ip = imp.getProcessor();
                double value = ip.getPixelValue((int)imageX, (int)imageY);
                magnification = ac.getMagnification();
                photom.measure (imp,imageX,imageY);
                IJ.setInputEvent(e);
                if (Math.abs(screenX-startDragScreenX) + Math.abs(screenY-startDragScreenY) >= 4.0)  //check mouse click/drag threshold
                        {
//                        apertureOverlay.clear();
                        ac.repaint();
                        if ((e.getModifiers() & MouseEvent.BUTTON3_MASK) != 0)    // control-dragging with right mouse button
                                {                                                 // measure distance, update data display
                                if (e.isControlDown())
                                        {
//                                        button2Drag = true;
//                                        imp.setRoi(new Line(startDragX, startDragY, imageX, imageY));
//                                        if (goodWCS)
//                                                {
//                                                xy[0]= imageX;
//                                                xy[1]= imageY;
//                                                radec = wcs.pixels2wcs (xy);
//                                                updateWCS(DRAGGING);
//                                                }
//                                        else
//                                                {
//                                                arcLengthLabel.setText("Peak:");
//                                                arcLengthTextField.setText(fourPlaces.format(photom.peakBrightness()));
//                                                }
//                                        updateXYValue(imageX, imageY, value, DRAGGING);
//                                        String lab = ", RA: "+fourPlaces.format(radec[0])+", DEC: "+fourPlaces.format(radec[1]);
                                        }
                                else                                                //no modifier - change screen min and max display values
                                        {
                                        adjustMinAndMax(lastScreenX - screenX, lastScreenY - screenY);

//                                        THE COMMENTED CODE BELOW DIRECTLY CONTROLS MAX AND MIN DISPLAYED VALUES
//                                        scaleMin = 100.0;
//                                        scaleMax = 100.0;
//                                        if ((min < 1.5) && (imp.getType() == ImagePlus.GRAY32)) scaleMin = 0.01;
//                                        else if ((min < 10.0)  && (imp.getType() == ImagePlus.GRAY32)) scaleMin = 0.1;
//                                        else if (min < 100.0) scaleMin = 1.0;
//                                        else if (min < 1000.0) scaleMin = 10.0;
//                                        else if (min < 10000.0) scaleMin = 50.0;
//                                        if ((max < 1.5) && (imp.getType() == ImagePlus.GRAY32)) scaleMax = 0.01;
//                                        else if ((max < 10.0)  && (imp.getType() == ImagePlus.GRAY32)) scaleMax = 0.1;
//                                        else if (max < 100.0) scaleMax = 1.0;
//                                        else if (max < 1000.0) scaleMax = 10.0;
//                                        else if (max < 10000.0) scaleMax = 50.0;
//                                        min -= scaleMin*(double)(lastScreenX - screenX);
//                                        max += scaleMax*(double)(lastScreenY - screenY);
//                                        if ((min + scaleMin) > max)
//                                                max = min + scaleMax;
//                                        if (min < minValue )
//                                                min = minValue;
//                                        if (max < (minValue + scaleMax))
//                                                max = minValue + scaleMax;
//                                        if (min > (maxValue - scaleMin))
//                                                min = maxValue - scaleMin;
//                                        if (max > maxValue)
//                                                max = maxValue;
//                                        ip.setMinAndMax(min, max);


                                        lastScreenX = screenX;
                                        lastScreenY = screenY;
                                        if (goodWCS)
                                                {
                                                xy[0]= imageX;
                                                xy[1]= imageY;
                                                radec = wcs.pixels2wcs (xy);
                                                updateWCS(NOT_DRAGGING);
                                                }
                                        else
                                                {
//                                                peakLabel.setText("Peak:");
//                                                peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                                                }  
                                        updateXYValue(imageX, imageY, value, NOT_DRAGGING);
                                        }
                                }
                        else if ((e.getModifiers() & MouseEvent.BUTTON2_MASK) != 0)        // dragging with middle mouse button
                                {                                                          // measure distance, show on plot
                                button2Drag = true;                                        // and save to results window when mouse released
                                String lab;
                                imp.setRoi(new Line(startDragX, startDragY, imageX, imageY));
                                if (goodWCS)
                                        {
                                        xy[0]= imageX;
                                        xy[1]= imageY;
                                        radec = wcs.pixels2wcs (xy);
                                        updateWCS(DRAGGING);
                                        }
                                else
                                        {
//                                        peakLabel.setText("Peak:");
//                                        peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                                        }
                                updateXYValue(imageX, imageY, value, DRAGGING);
                                }
                        else if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0 && e.isShiftDown() && !e.isControlDown())
                            {
                            imp.setRoi(new OvalRoi(imageX>startDragX?startDragX:imageX, imageY>startDragY?startDragY:imageY,
                                    imageX>startDragX?imageX-startDragX:startDragX-imageX,
                                    imageY>startDragY?imageY-startDragY:startDragY-imageY));
                            }
                        else if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0 && e.isControlDown() && !e.isShiftDown())
                            {
                            imp.setRoi(new Rectangle(imageX>startDragX?startDragX:imageX, imageY>startDragY?startDragY:imageY,
                                    imageX>startDragX?imageX-startDragX:startDragX-imageX,
                                    imageY>startDragY?imageY-startDragY:startDragY-imageY));
                            }
                        else if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0 && !(e.isControlDown() || e.isShiftDown() || e.isAltDown()))  
                                {                                                 // dragging with left mouse button (pan image)
                                Rectangle imageRect = ac.getSrcRect();
                                String lab;
                                if (astronomyMode)
                                        {
//                                        int w = (int)Math.round(icWidth/magnification);
//                                        if (w*magnification<icWidth) w++;
//                                        int h = (int)Math.round(icHeight/magnification);
//                                        if (h*magnification<icHeight) h++;
                                        int height = imp.getHeight();
                                        int width = imp.getWidth();
                                        int ox = netFlipX ? startDragSubImageX + imageRect.width - (int)(e.getX()/magnification) :
                                                 startDragSubImageX + (int)(e.getX()/magnification);
                                        int oy = netFlipY ? startDragSubImageY + imageRect.height - (int)(e.getY()/magnification) :
                                                 startDragSubImageY + (int)(e.getY()/magnification);
                                        imageRect.x =  startDragSubImageX + (startDragX-ox);
                                        imageRect.y = startDragSubImageY + (startDragY-oy);
                                        savedPanX = imageRect.x;
                                        savedPanY = imageRect.y;
                                        savedPanHeight = imageRect.height;
                                        savedPanWidth = imageRect.width;

//                                        if (imageRect.x<0) imageRect.x = 0;
//                                        if (imageRect.y<0) imageRect.y = 0;
//                                        if (imageRect.x+w>icWidth) imageRect.x = ipWidth-w;
//                                        if (imageRect.y+h>icHeight) imageRect.y = ipHeight-h;

                                        ac.setSourceRect(imageRect);
                                        savedIpWidth = ip.getWidth();
                                        savedIpHeight = ip.getHeight();
                                        Prefs.set("Astronomy_Tool.savedIpWidth", savedIpWidth);
                                        Prefs.set("Astronomy_Tool.savedIpHeight", savedIpHeight);
                                        Prefs.set("Astronomy_Tool.savedPanX", savedPanX);
                                        Prefs.set("Astronomy_Tool.savedPanY", savedPanY);
                                        Prefs.set("Astronomy_Tool.savedPanHeight", savedPanHeight);
                                        Prefs.set("Astronomy_Tool.savedPanWidth", savedPanWidth);
                                        setImageEdges();
//                                        if (imageRect.x<0 || imageRect.y<0 || imageRect.x+imageRect.width>width || imageRect.y+imageRect.height>height)
//                                            {
//                                            clearAndPaint();
//                                            }
//                                        else
//                                            ac.repaint();
                                        ac.paint(ac.getGraphics());
                                        }
                                xy[0]= imageX;
                                xy[1]= imageY;
                                if (goodWCS)
                                        {
                                        radec = wcs.pixels2wcs (xy);
                                        lab = ", RA: "+fourPlaces.format(radec[0]/15)+", DEC: "+fourPlaces.format(radec[1]);
                                        updateWCS(NOT_DRAGGING);
                                        }
                                else
                                        {
                                        lab = "";
//                                        peakLabel.setText("Peak:");
//                                        peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                                        }
                                updateXYValue(imageX, imageY, value, NOT_DRAGGING);
                                }
                        }

                }


    void updateXYValue(double imageX, double imageY, double value, boolean dragging)
            {
            valueTextField.setText(fourPlaces.format(value));
            ijXTextField.setText(fourPlaces.format(imageX));
            ijYTextField.setText(fourPlaces.format(imageY));
            fitsXTextField.setText(fourPlaces.format(imageX + Centroid.PIXELCENTER));
            fitsYTextField.setText(fourPlaces.format((double)imp.getHeight() - imageY + Centroid.PIXELCENTER));
            if (showMeanNotPeak)
                {
                peakLabel.setText("Mean:");
                peakTextField.setText(fourPlaces.format(photom.meanBrightness()));                
                }
            else
                {
                peakLabel.setText("Peak:");
                peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
                }
            if (dragging && !goodWCS)
                {
                if (ac.XPixelScale <= 0.0 || ac.XPixelScale <= 0.0)
                    {
                    lengthLabel.setText("Length:");
                    lengthTextField.setText(fourPlaces.format(Math.sqrt((imageX-startDragX)*(imageX-startDragX)
                                                                      + (imageY-startDragY)*(imageY-startDragY))));
                    }
                else
                    {
                    lengthLabel.setText("Arclen:");
                    if (useSexagesimal)
                        lengthTextField.setText(hms(Math.sqrt(ac.XPixelScale*ac.XPixelScale*(imageX-startDragX)*(imageX-startDragX) +
                                                              ac.YPixelScale*ac.YPixelScale*(imageY-startDragY)*(imageY-startDragY))/3600,2));
                    else
                        lengthTextField.setText(fourPlaces.format(Math.sqrt(ac.XPixelScale*ac.XPixelScale*(imageX-startDragX)*(imageX-startDragX) +
                                                                           ac.YPixelScale*ac.YPixelScale*(imageY-startDragY)*(imageY-startDragY))/3600));
                    }
                }
            else if (!goodWCS)
                {
                lengthLabel.setText("Int Cnts:");
                lengthTextField.setText(fourPlaces.format(photom.sourceBrightness()));
                }
            }

    void updateWCS(boolean dragging)
            {
//            peakLabel.setText("Peak:");
//            peakTextField.setText(fourPlaces.format(photom.peakBrightness()));
            if (useSexagesimal)
                {
                RATextField.setText(hms(radec[0]/15.0, 3));
                if (radec[1] > 0.0)
                        DecTextField.setText("+"+hms(radec[1], 2));
                else
                        DecTextField.setText(hms(radec[1], 2));
                if (dragging)
                        {
                        lengthLabel.setText("Arclen:");
                        lengthTextField.setText(hms(arcLength(),2));
                        }
                else
                        {
                        lengthLabel.setText("Int Cnts:");
                        lengthTextField.setText(fourPlaces.format(photom.sourceBrightness()));
                        }
                }
            else
                {
                RATextField.setText(sixPlaces.format(radec[0]/15));
                DecTextField.setText(sixPlaces.format(radec[1]));
                if (dragging)
                        {
                        lengthLabel.setText("Arclen:");
                        lengthTextField.setText(fourPlaces.format(arcLength()));
                        }
                else
                        {
                        lengthLabel.setText("Int Cnts:");
                        lengthTextField.setText(fourPlaces.format(photom.sourceBrightness()));
                        }
                }

            }

    double arcLength()
            {
            double RADDEG = Math.PI/180.;
            return Math.acos(Math.cos((90.-startRadec[1])*RADDEG)*Math.cos((90. - radec[1])*RADDEG) +
                    Math.sin((90.-startRadec[1])*RADDEG)*Math.sin((90.-radec[1])*RADDEG)*
                    Math.cos((startRadec[0]-radec[0])*RADDEG))/RADDEG;
            }

    void updateResultsTable(double imageX, double imageY, double value, boolean dragging)
            {
            String lab = "";
            lab += "Xij: "+threePlaces.format(imageX);
            lab += ",  Yij: "+threePlaces.format(imageY);
            lab += ",  Xfits: "+threePlaces.format(imageX - Centroid.PIXELCENTER + 1.0);
            lab += ",  Yfits: "+threePlaces.format((double)imp.getHeight() - imageY + Centroid.PIXELCENTER);
            lab += ",  Value: "+uptoSixPlaces.format(value);
            if (goodWCS)
                {
                if (useSexagesimal)
                    {
                    lab += ",     RA: "+hms(radec[0]/15.0, 3);
                    if (radec[1] >= 0.0)
                            lab += ",  DEC: +"+hms(radec[1], 2);
                    else
                            lab += ",  DEC: "+hms(radec[1], 2);
                    if (dragging)
                            lab += ",  Arclength: "+(hms(arcLength(),2));
                    }
                else
                    {
                    lab += ",     RA: "+fourPlaces.format(radec[0]/15.0);
                    lab += ",  DEC: "+fourPlaces.format(radec[1]);
                    if (dragging)
                            lab += ",  Arclength: "+(fourPlaces.format(arcLength()));
                    }
                }
            else if (dragging)
                {
                if (ac.XPixelScale <= 0.0 || ac.YPixelScale <= 0.0)
                    {
                    lab += ",  Length: "+(fourPlaces.format((Math.sqrt(ac.XPixelScale*ac.XPixelScale*(imageX-startDragX)*(imageX-startDragX) +
                                                                       ac.YPixelScale*ac.YPixelScale*(imageY-startDragY)*(imageY-startDragY))))+" pixels");
                    }
                else if (useSexagesimal)
                    {
                    lab += ",  Arclength: "+(hms(Math.sqrt(ac.XPixelScale*ac.XPixelScale*(imageX-startDragX)*(imageX-startDragX) +
                                                           ac.YPixelScale*ac.YPixelScale*(imageY-startDragY)*(imageY-startDragY))/3600,2));
                    }
                else
                    {
                     lab += ",  Arclength: "+(fourPlaces.format(Math.sqrt(ac.XPixelScale*ac.XPixelScale*(imageX-startDragX)*(imageX-startDragX) +
                                                                          ac.YPixelScale*ac.YPixelScale*(imageY-startDragY)*(imageY-startDragY))/3600));
                    }
                }
            IJ.log(lab);
            }

        public boolean hasWCS()
            {
            return goodWCS;
            }

        public void mouseWheelMoved( MouseWheelEvent e ) {

                    if (updatesEnabled)
                        {
                        int screenX = e.getX();
                        int screenY = e.getY();
                        ac.setMousePosition(screenX, screenY);
                        double imageX = ac.offScreenXD(screenX);
                        double imageY = ac.offScreenYD(screenY);
                        ImageProcessor ip = imp.getProcessor();
                        double value = ip.getPixelValue((int)imageX, (int)imageY);
                        int magChangeSteps = e.getWheelRotation();
                        IJ.setInputEvent(e);
                        if (e.isControlDown() && ((e.getModifiers() & MouseEvent.BUTTON3_MASK) == 0))
                            {
                            adjustMinAndMax(magChangeSteps, 0);
                            }
                        else if (e.isShiftDown() && ((e.getModifiers() & MouseEvent.BUTTON3_MASK) == 0))
                            {
                            adjustMinAndMax(0, -magChangeSteps);
                            }
                        else
                            {
                            zoomControl(screenX, screenY, magChangeSteps, WHEEL);
                            }
                        }
                    }


        void adjustMinAndMax(int xSteps, int ySteps)
                {
                double low, high;
//                min = ip.getMin();
                min = imp.getDisplayRangeMin();
//                max = ip.getMax();
                max = imp.getDisplayRangeMax();
                brightness = (max + min)/2.0;
                contrast = (max - min)/2.0;

                if (imp.getType() == ImagePlus.COLOR_RGB || imp.getType() == ImagePlus.COLOR_256 ||
                        imp.getType() == ImagePlus.GRAY8) brightstepsize = 1.0;
                else if((contrast < 2.0) && (imp.getType() == ImagePlus.GRAY32) &&
                        (maxValue - minValue >= 10.0)) brightstepsize = 0.01;
                else if((contrast < 2.0) && (imp.getType() == ImagePlus.GRAY32) &&
                        (maxValue - minValue < 10.0)) brightstepsize = 0.001;
                else if ((contrast < 10.0)  && (imp.getType() == ImagePlus.GRAY32)) brightstepsize = 0.2;
                else if (contrast < 500.0) brightstepsize = 2.0;
                else if (contrast < 10000.0) brightstepsize = 20.0;
                else brightstepsize = 200.0;


                contrast -= brightstepsize*(double)(xSteps);
                if (brightstepsize > 0.2 && contrast < 10.0 && imp.getType() == ImagePlus.GRAY32)
                    {
                    contrast = 9.8;
                    brightstepsize = 0.2;
                    ySteps = -1;
                    }
                else if(brightstepsize > 0.01 && contrast < 2.0 && imp.getType() == ImagePlus.GRAY32)
                    {
                    contrast = 1.99;
                    brightstepsize = 0.001;
                    ySteps = -1;
                    }
                brightness += brightstepsize*(double)(ySteps);

                if (contrast < brightstepsize)
                        contrast = brightstepsize;
                else if ((contrast > (maxValue - minValue)/ 2.0))
                        contrast = (maxValue - minValue)/2.0;

                low = (brightness - contrast < minValue) ? minValue : brightness - contrast;
                high = (brightness + contrast < minValue + brightstepsize) ? minValue + brightstepsize : brightness + contrast;
                if (high > maxValue) high = maxValue;
//                ip.setMinAndMax(low, high);
                imp.setDisplayRange(low, high);
                minMaxChanged = true;
//                minSlider.setValue((int)((low + sliderShift)*(double)sliderMultiplier));
//                maxSlider.setValue((int)((high + sliderShift)*(double)sliderMultiplier));
                minMaxBiSlider.setColoredValues(low, high);
//                imp.updateAndDraw();
                }


        public void zoomControl(int screenX, int screenY, int magChangeSteps, boolean mouseClick)
                {
                ac.setMousePosition(screenX, screenY);
                double imageX = ac.offScreenXD(screenX);
                double imageY = ac.offScreenYD(screenY);
                double zoom = ac.getMagnification();
                double nextzoom = ac.getLowerZoomLevel(zoom);

                ipWidth = imp.getWidth();
                ipHeight = imp.getHeight();
                icWidth = ac.getWidth();
                icHeight = ac.getHeight();
                if (magChangeSteps > 0) //&& (zoom > initialHighMag))     //zoom out
                        {
                        zoomOut((int)(screenX), (int)(screenY), mouseClick, false);
                        }

                else if (magChangeSteps<0)    //zoom in
                        {
                        zoomIn((int)(screenX), (int)(screenY), mouseClick, false, 0.0);
                        }
                else  //magChangeSteps==0
                    {
                    adjustSourceRect(zoom, screenX, screenY, true);
                    }
//                try
//                        {
//                        Robot robot = new Robot();     //move mouse pointer to new position on screen
//                        robot.mouseMove(ac.getLocationOnScreen().x +ac.screenXD(Math.round(imageX+0.499)),
//                                        ac.getLocationOnScreen().y + ac.screenYD(Math.round(imageY+0.499)));
//                        }
//                catch (AWTException ee)
//                        {
//                        ee.printStackTrace();
//                        }
                }

	public void zoomIn(int screenX, int screenY, boolean mouseClick, boolean center, double factor) {
        int height = newCanvasHeight();
        int width = newCanvasWidth();
        int newHeight = height;
        int newWidth = width;
        magnification = ac.getMagnification();
        if (magnification >= 32) return;
        double newMag = magnification;
        if (mouseClick)
            {
            if (factor > 0.0)
                newMag = magnification*factor;
            else
                newMag = ac.getHigherZoomLevel(magnification);
            }
        else
            newMag = magnification*1.1;
        if (newMag >= 32) newMag = 32;
        adjustSourceRect(newMag, screenX, screenY, center);
	}

	public void zoomOut(int screenX, int screenY, boolean mouseClick, boolean center) {
        magnification = ac.getMagnification();
        if (magnification <= 0.03125) return;
        double newMag = magnification;
        if (mouseClick)
            newMag = ac.getLowerZoomLevel(magnification);
        else
            newMag = magnification/1.1;
        if (newMag <= 0.03125) newMag = 0.03125;
        adjustSourceRect(newMag, screenX, screenY, center);
        }


	void adjustSourceRect(double newMag, int screenX, int screenY, boolean center) {
        ac.setMousePosition(screenX, screenY);
        icWidth = ac.getWidth();
        icHeight = ac.getHeight();
		double w = (double)icWidth/newMag;
		if (w*newMag<icWidth) w++;
		double h = (double)icHeight/newMag;
		if (h*newMag<icHeight) h++;
        
        double xSign = netFlipX ? 1.0 : -1.0;
        double ySign = netFlipY ? 1.0 : -1.0;


		double offx = ac.offScreenXD(screenX);
		double offy = ac.offScreenYD(screenY);

        Rectangle r = ac.getSrcRect();

        if (center && newClick)
            {
            r.x = (int)(offx - w/2.0);
            r.y = (int)(offy - h/2.0);
            r.width = (int)w;
            r.height = (int)h;
            newClick = false;
            }
        else if (center && !newClick)
            {
            r.x = (int)(r.x + r.width/2.0 - w/2.0);
            r.y = (int)(r.y + r.height/2.0 - h/2.0);
            r.width = (int)w;
            r.height = (int)h;            
            }
        else
            {
            if (offx < 0) {offx = 0; screenX = ac.screenXD(offx);}
            if (offx > imp.getWidth()) {offx = imp.getWidth()-1; screenX = ac.screenXD(offx+2);}
            if (offy < 0) {offy = 0; screenY = ac.screenYD(offy);}
            if (offy > imp.getHeight()) {offy = imp.getHeight()-1; screenY = ac.screenYD(offy+2);}
            double offsetX = netFlipX ? 0.499 : 0.499;
            double offsetY = netFlipY ? 0.499 : 0.499;
            r = new Rectangle((int)(offsetX + offx-w/2.0*(1.0 + xSign*((double)icWidth/2.0 - (double)screenX)/((double)icWidth/2.0))),
                                        (int)(offsetY + offy-h/2.0*(1.0 + ySign*((double)icHeight/2.0 - (double)screenY)/((double)icHeight/2.0))),
                                        (int) w, (int) h);
            }

//        if (ac.getNetRotate())
//                  r = new Rectangle((int)(offsetY + offy-h/2.0*(1.0 + xSign*((double)icHeight/2.0 - (double)screenY)/((double)icHeight/2.0))),
//                                    (int)(offsetX + offx-w/2.0*(1.0 + ySign*((double)icWidth/2.0 - (double)screenX)/((double)icWidth/2.0))),
//                                    (int) h, (int) w);


        ac.setMagnification(newMag);
        ac.setSourceRect(r);


        savedPanX = r.x;
        savedPanY = r.y;
        savedPanHeight = r.height;
        savedPanWidth = r.width;
        savedMag = ac.getMagnification();
        savedIpWidth = imp.getWidth();
        savedIpHeight = imp.getHeight();
        Prefs.set("Astronomy_Tool.savedPanX", savedPanX);
        Prefs.set("Astronomy_Tool.savedPanY", savedPanY);
        Prefs.set("Astronomy_Tool.savedPanHeight", savedPanHeight);
        Prefs.set("Astronomy_Tool.savedPanWidth", savedPanWidth);
        Prefs.set("Astronomy_Tool.savedIpWidth", savedIpWidth);
        Prefs.set("Astronomy_Tool.savedIpHeight", savedIpHeight);
        setImageEdges();
//        if (r.x<=0 || r.y<=0 || r.x+r.width>=ipWidth || r.y+h>=ipHeight)
//            {
//            clearAndPaint();
//            }
//        else
//            ac.repaint();
        ac.paint(ac.getGraphics());
        prevMag = ac.getMagnification();
    	}


    void setImageEdges()
        {
        imageEdgeX1 = ac.screenX(0) > 0 ? (int)photom.rBack2 : ac.getSrcRect().x;
        imageEdgeY1 = ac.screenY(0) > 0 ? (int)photom.rBack2 : ac.getSrcRect().y;
        imageEdgeX2 = ac.screenX(imp.getWidth()) < ac.getWidth() ? imp.getWidth() - (int)photom.rBack2 : ac.getSrcRect().x + ac.getSrcRect().width;
        imageEdgeY2 = ac.screenY(imp.getHeight()) < ac.getHeight() ? imp.getHeight() - (int)photom.rBack2 : ac.getSrcRect().y + ac.getSrcRect().height;
        }

//    public void fitToAstroWindow() {
//        ipWidth = imp.getWidth();
//        ipHeight = imp.getHeight();
//        icWidth = ac.getWidth();
//        icHeight = ac.getHeight();
//        Rectangle srcRect = new Rectangle(ac.getSrcRect());
//		ImageWindow win = imp.getWindow();
//		if (win==null) return;
//		Rectangle bounds = win.getBounds();
//		Insets insets = win.getInsets();
//		int sliderHeight = (win instanceof StackWindow)?20:0;
//		double xmag = (double)(bounds.width-10)/srcRect.width;
//		double ymag = (double)(bounds.height-(10+insets.top+insets.bottom+otherPanelsHeight+sliderHeight))/srcRect.height;
//		ac.setMagnification(Math.min(xmag, ymag));
//		int width=(int)(ipWidth*magnification);
//		int height=(int)(ipHeight*magnification);
//		if (width==bounds.width-10&&height==bounds.height-(10+insets.top+insets.bottom+otherPanelsHeight+sliderHeight)) return;
//		srcRect=new Rectangle(0,0,ipWidth, ipHeight);
//        ac.setSourceRect(srcRect);
//		ac.setDrawingSize(width, height);
//        savedPanX = 0;
//        savedPanY = 0;
//        savedPanHeight = ipHeight;
//        savedPanWidth = ipWidth;
//        savedMag = ac.getMagnification();
//        savedICWidth = width;
//        savedICHeight = height;
//        Prefs.set("Astronomy_Tool.savedPanX", savedPanX);
//        Prefs.set("Astronomy_Tool.savedPanY", savedPanY);
//        Prefs.set("Astronomy_Tool.savedPanHeight", savedPanHeight);
//        Prefs.set("Astronomy_Tool.savedPanWidth", savedPanWidth);
//        Prefs.set("Astronomy_Tool.savedMag", savedMag);
//        Prefs.set("Astronomy_Tool.savedICWidth", savedICWidth);
//        Prefs.set("Astronomy_Tool.savedICHeight", savedICHeight);
//        buildAstroWindow();
////        layoutContainer(imageWindow);
////        ac.repaint();
////		openFrame.doLayout();
////        openFrame.pack();
//	}

	public String hms (double d, int fractionPlaces)
		{
        NumberFormat nf = null;
        NumberFormat nf23 = null;
        NumberFormat nf22 = null;
        nf = NumberFormat.getInstance();
		nf.setMinimumIntegerDigits(2);
        nf23 = NumberFormat.getInstance();
        nf23.setMinimumIntegerDigits(2);
        nf23.setMinimumFractionDigits(3);
        nf23.setMaximumFractionDigits(3);
        nf22 = NumberFormat.getInstance();
        nf22.setMinimumIntegerDigits(2);
        nf22.setMinimumFractionDigits(2);
        nf22.setMaximumFractionDigits(2);
		double dd = Math.abs(d);
		int h = (int)dd;
		int m = (int)(60.0*(dd-(double)h));
		double s = 3600.0*(dd-(double)h-(double)m/60.0);

		String str = "";
		if (d < 0.0) str = "-";
		str += ""+nf.format(h)+":"+nf.format(m)+":";
        if (fractionPlaces == 2)
            str += nf22.format(s);
        else
            str += nf23.format(s);
		return str;
		}

    public void setDisableShiftClick(boolean state)
        {
        shiftClickDisabled = state;
        }

	void getPrefs()
		{
        savedIpHeight = (int)Prefs.get("Astronomy_Tool.savedIpHeight", savedIpHeight);
        savedIpWidth = (int)Prefs.get("Astronomy_Tool.savedIpWidth", savedIpWidth);
        showMeanNotPeak = Prefs.get("Astronomy_Tool.showMeanNotPeak", showMeanNotPeak);
        useSexagesimal = Prefs.get("Astronomy_Tool.useSexagesimal", useSexagesimal);
        startupAutoLevel = Prefs.get("Astronomy_Tool.startupAutoLevel", startupAutoLevel);
        ac.showRedCrossHairCursor = Prefs.get("Astronomy_Tool.showRedCrossHairCursor",ac.showRedCrossHairCursor);
        startupPrevSize = Prefs.get("Astronomy_Tool.startupPrevSize", startupPrevSize);
        startupPrevPan = Prefs.get("Astronomy_Tool.startupPrevPan", startupPrevPan);
        startupPrevZoom = Prefs.get("Astronomy_Tool.startupPrevZoom", startupPrevZoom);
        startupPrevLevels = Prefs.get("Astronomy_Tool.startupPrevLevels", startupPrevLevels);
        startupPrevLevelsPerSlice = Prefs.get("Astronomy_Tool.startupPrevLevelsPerSlice", startupPrevLevelsPerSlice);
        writeMiddleClickValues = Prefs.get("Astronomy_Tool.writeMiddleClickValues", writeMiddleClickValues);
        writeMiddleDragValues = Prefs.get("Astronomy_Tool.writeMiddleDragValues", writeMiddleDragValues);
        autoConvert = Prefs.get("Astronomy_Tool.autoConvert", autoConvert);
        autoScaleFactorLow = Prefs.get("Astronomy_Tool.autoScaleFactorLow", autoScaleFactorLow);
        autoScaleFactorHigh = Prefs.get("Astronomy_Tool.autoScaleFactorHigh", autoScaleFactorHigh);
        autoScaleFactorLowRGB = Prefs.get("Astronomy_Tool.autoScaleFactorLowRGB", autoScaleFactorLowRGB);
        autoScaleFactorHighRGB = Prefs.get("Astronomy_Tool.autoScaleFactorHighRGB", autoScaleFactorHighRGB);
        reposition = Prefs.get ("aperture.reposition", reposition);
        saveImage = Prefs.get("Astronomy_Tool.saveImage", saveImage);
        savePlot = Prefs.get("Astronomy_Tool.savePlot", savePlot);
        saveConfig = Prefs.get("Astronomy_Tool.saveConfig", saveConfig);
        saveTable = Prefs.get("Astronomy_Tool.saveTable", saveTable);
        saveApertures = Prefs.get("Astronomy_Tool.saveApertures", saveApertures);
        saveLog = Prefs.get("Astronomy_Tool.saveLog", saveLog);
        imageSuffix = Prefs.get("Astronomy_Tool.imageSuffix", imageSuffix);
        plotSuffix = Prefs.get("Astronomy_Tool.plotSuffix", plotSuffix);
        configSuffix = Prefs.get("Astronomy_Tool.configSuffix", configSuffix);
        dataSuffix = Prefs.get("Astronomy_Tool.dataSuffix", dataSuffix);
        aperSuffix = Prefs.get("Astronomy_Tool.aperSuffix", aperSuffix);
        logSuffix = Prefs.get("Astronomy_Tool.logSuffix", logSuffix);
        saveAllPNG = Prefs.get("Astronomy_Tool.saveAllPNG", saveAllPNG);
        

        savedMag = Prefs.get("Astronomy_Tool.savedMag", savedMag);
        savedICWidth = (int)Prefs.get("Astronomy_Tool.savedICWidth", savedICWidth);
        savedICHeight = (int)Prefs.get("Astronomy_Tool.savedICHeight", savedICHeight);
        savedPanX = (int)Prefs.get("Astronomy_Tool.savedPanX", savedPanX);
        savedPanY = (int)Prefs.get("Astronomy_Tool.savedPanY", savedPanY);
        savedPanHeight = (int)Prefs.get("Astronomy_Tool.savedPanHeight", savedPanHeight);
        savedPanWidth = (int)Prefs.get("Astronomy_Tool.savedPanWidth", savedPanWidth);
        savedMin = Prefs.get("Astronomy_Tool.savedMin", savedMin);
        savedMax = Prefs.get("Astronomy_Tool.savedMax", savedMax);
        frameLocationX = (int)Prefs.get("Astronomy_Tool.frameLocationX",frameLocationX);
        frameLocationY = (int)Prefs.get("Astronomy_Tool.frameLocationY",frameLocationY);
        rememberWindowLocation = Prefs.get("Astronomy_Tool.rememberWindowLocation", rememberWindowLocation);
        radius = Prefs.get("aperture.radius", radius);
		rBack1 = Prefs.get("aperture.rback1", rBack1);
		rBack2 = Prefs.get("aperture.rback2", rBack2);
        nameOverlay = Prefs.get ("aperture.nameoverlay", nameOverlay);
        valueOverlay = Prefs.get ("aperture.valueoverlay", valueOverlay);
        ac.zoomIndicatorSize = (int)Prefs.get("Astronomy_Tool.zoomIndicatorSize",ac.zoomIndicatorSize);
        pixelScaleX = Prefs.get("Astronomy_Tool.pixelScaleX", pixelScaleX);
        pixelScaleY = Prefs.get("Astronomy_Tool.pixelScaleY", pixelScaleY);
        ac.NdirAngle = Prefs.get("Astronomy_Tool.NdirAngle", ac.NdirAngle);
        ac.EdirAngle = Prefs.get("Astronomy_Tool.EdirAngle", ac.EdirAngle);
        middleClickCenter = Prefs.get("Astronomy_Tool.middleClickCenter", middleClickCenter);
        showPhotometer = Prefs.get("Astronomy_Tool.showPhotometer", showPhotometer);
        removeBackStars = Prefs.get("aperture.removebackstars", removeBackStars);
        showRemovedPixels = Prefs.get("aperture.showremovedpixels", showRemovedPixels);
        useInvertingLut = Prefs.get("Astronomy_Tool.useInvertingLut", useInvertingLut);
        invertX = Prefs.get("Astronomy_Tool.invertX", invertX);
        invertY = Prefs.get("Astronomy_Tool.invertY", invertY);
        rotation = (int)Prefs.get("Astronomy_Tool.rotation", rotation);
        showZoom = Prefs.get("Astronomy_Tool.showZoom", showZoom);
        showDir = Prefs.get("Astronomy_Tool.showDir", showDir);
        showXY = Prefs.get("Astronomy_Tool.showXY", showXY);
        showScaleX = Prefs.get("Astronomy_Tool.showScaleX", showScaleX);
        showScaleY = Prefs.get("Astronomy_Tool.showScaleY", showScaleY);
        showSkyOverlay = Prefs.get ("aperture.skyoverlay", showSkyOverlay);
        useFixedMinMaxValues = Prefs.get("Astronomy_Tool.useFixedMinMaxValues", useFixedMinMaxValues);
        fixedMinValue = Prefs.get("Astronomy_Tool.fixedMinValue", minValue);
        fixedMaxValue = Prefs.get("Astronomy_Tool.fixedMaxValue", maxValue);
		}

    void savePrefs()
        {
        if (imp != null) savedIpWidth = imp.getWidth();
        if (imp != null) savedIpHeight = imp.getHeight();

        Prefs.set("Astronomy_Tool.savedIpHeight", savedIpHeight);
        Prefs.set("Astronomy_Tool.savedIpWidth", savedIpWidth);
        Prefs.set("Astronomy_Tool.useSexagesimal", useSexagesimal);
        Prefs.set("Astronomy_Tool.showMeanNotPeak", showMeanNotPeak);
        Prefs.set("Astronomy_Tool.startupAutoLevel", startupAutoLevel);
        Prefs.set("Astronomy_Tool.startupPrevPan", startupPrevPan);
        Prefs.set("Astronomy_Tool.startupPrevZoom", startupPrevZoom);
        Prefs.set("Astronomy_Tool.startupPrevLevels", startupPrevLevels);
        Prefs.set("Astronomy_Tool.startupPrevLevelsPerSlice", startupPrevLevelsPerSlice);
        Prefs.set("Astronomy_Tool.middleClickCenter", middleClickCenter);
        Prefs.set("Astronomy_Tool.showRedCrossHairCursor",ac.showRedCrossHairCursor);
        Prefs.set("Astronomy_Tool.writeMiddleClickValues", writeMiddleClickValues);
        Prefs.set("Astronomy_Tool.writeMiddleDragValues", writeMiddleDragValues);
        Prefs.set("Astronomy_Tool.autoConvert", autoConvert);
        Prefs.set ("aperture.nameoverlay", nameOverlay);
        Prefs.set ("aperture.valueoverlay", valueOverlay);
        Prefs.set("Astronomy_Tool.autoScaleFactorLow", autoScaleFactorLow);
        Prefs.set("Astronomy_Tool.autoScaleFactorHigh", autoScaleFactorHigh);
        Prefs.set("Astronomy_Tool.autoScaleFactorLowRGB", autoScaleFactorLowRGB);
        Prefs.set("Astronomy_Tool.autoScaleFactorHighRGB", autoScaleFactorHighRGB);
        Prefs.set("Astronomy_Tool.startupPrevSize", startupPrevSize);
        Prefs.set("Astronomy_Tool.savedMag", savedMag);
        Prefs.set("Astronomy_Tool.pixelScaleX", pixelScaleX);
        Prefs.set("Astronomy_Tool.pixelScaleY", pixelScaleY);
        Prefs.set("Astronomy_Tool.savedICWidth", savedICWidth);
        Prefs.set("Astronomy_Tool.savedICHeight", savedICHeight);
        Prefs.set("Astronomy_Tool.savedPanX", savedPanX);
        Prefs.set("Astronomy_Tool.savedPanY", savedPanY);
        Prefs.set("Astronomy_Tool.savedPanHeight", savedPanHeight);
        Prefs.set("Astronomy_Tool.savedPanWidth", savedPanWidth);
        Prefs.set("Astronomy_Tool.savedMin", savedMin);
        Prefs.set("Astronomy_Tool.savedMax", savedMax);
        Prefs.set("Astronomy_Tool.zoomIndicatorSize",ac.zoomIndicatorSize);
        Prefs.set("Astronomy_Tool.NdirAngle", ac.NdirAngle);
        Prefs.set("Astronomy_Tool.EdirAngle", ac.EdirAngle);
        Prefs.set("Astronomy_Tool.saveImage", saveImage);
        Prefs.set("Astronomy_Tool.savePlot", savePlot);
        Prefs.set("Astronomy_Tool.saveConfig", saveConfig);
        Prefs.set("Astronomy_Tool.saveTable", saveTable);
        Prefs.set("Astronomy_Tool.saveApertures", saveApertures);
        Prefs.set("Astronomy_Tool.saveLog", saveLog);
        Prefs.set("Astronomy_Tool.imageSuffix", imageSuffix);
        Prefs.set("Astronomy_Tool.plotSuffix", plotSuffix);
        Prefs.set("Astronomy_Tool.configSuffix", configSuffix);
        Prefs.set("Astronomy_Tool.dataSuffix", dataSuffix);
        Prefs.set("Astronomy_Tool.aperSuffix", aperSuffix);
        Prefs.set("Astronomy_Tool.logSuffix", logSuffix);
        Prefs.set("Astronomy_Tool.saveAllPNG", saveAllPNG);
        Prefs.set ("aperture.reposition", reposition);
        if (this != null) frameLocationX = this.getLocation().x;
        if (this != null) frameLocationY = this.getLocation().y;
        Prefs.set("Astronomy_Tool.frameLocationX",frameLocationX);
        Prefs.set("Astronomy_Tool.frameLocationY",frameLocationY);
        Prefs.set("Astronomy_Tool.rememberWindowLocation", rememberWindowLocation);
        Prefs.set("aperture.removebackstars", removeBackStars);
        Prefs.set("aperture.showremovedpixels", showRemovedPixels);
        Prefs.set("Astronomy_Tool.useInvertingLut", useInvertingLut);
        Prefs.set("Astronomy_Tool.invertX", invertX);
        Prefs.set("Astronomy_Tool.invertY", invertY);
        Prefs.set("Astronomy_Tool.rotation", rotation);
        Prefs.set("Astronomy_Tool.showZoom", showZoom);
        Prefs.set("Astronomy_Tool.showDir", showDir);
        Prefs.set("Astronomy_Tool.showXY", showXY);
        Prefs.set("Astronomy_Tool.showScaleX", showScaleX);
        Prefs.set("Astronomy_Tool.showScaleY", showScaleY);
        Prefs.set("aperture.skyoverlay", showSkyOverlay);
        if (imp != null && imp.getType() != ImagePlus.COLOR_RGB)
            Prefs.set("Astronomy_Tool.useFixedMinMaxValues", useFixedMinMaxValues);
        Prefs.set("Astronomy_Tool.fixedMinValue", fixedMinValue);
        Prefs.set("Astronomy_Tool.fixedMaxValue", fixedMaxValue);
        }

}   // AstroStackWindow class


